namespace Urho3D
{

/**
\page LuaScriptAPI Lua scripting API

\section LuaScriptAPI_TableOfContents Table of contents

\ref LuaScriptAPI_ClassList "Class list"<br>
\ref LuaScriptAPI_Classes "Classes"<br>
\ref LuaScriptAPI_Enums "Enumerations"<br>
\ref LuaScriptAPI_GlobalFunctions "Global functions"<br>
\ref LuaScriptAPI_GlobalProperties "Global properties"<br>
\ref LuaScriptAPI_GlobalConstants "Global constants"<br>

\section LuaScriptAPI_ClassList Class list

<a href="#Class_Animatable"><b>Animatable</b></a>
<a href="#Class_AnimatedModel"><b>AnimatedModel</b></a>
<a href="#Class_AnimatedSprite2D"><b>AnimatedSprite2D</b></a>
<a href="#Class_Animation"><b>Animation</b></a>
<a href="#Class_Animation2D"><b>Animation2D</b></a>
<a href="#Class_AnimationControl"><b>AnimationControl</b></a>
<a href="#Class_AnimationController"><b>AnimationController</b></a>
<a href="#Class_AnimationKeyFrame"><b>AnimationKeyFrame</b></a>
<a href="#Class_AnimationSet2D"><b>AnimationSet2D</b></a>
<a href="#Class_AnimationState"><b>AnimationState</b></a>
<a href="#Class_Audio"><b>Audio</b></a>
<a href="#Class_BiasParameters"><b>BiasParameters</b></a>
<a href="#Class_Billboard"><b>Billboard</b></a>
<a href="#Class_BillboardSet"><b>BillboardSet</b></a>
<a href="#Class_Bone"><b>Bone</b></a>
<a href="#Class_BorderImage"><b>BorderImage</b></a>
<a href="#Class_BoundingBox"><b>BoundingBox</b></a>
<a href="#Class_Button"><b>Button</b></a>
<a href="#Class_Camera"><b>Camera</b></a>
<a href="#Class_CascadeParameters"><b>CascadeParameters</b></a>
<a href="#Class_CheckBox"><b>CheckBox</b></a>
<a href="#Class_CollisionBox2D"><b>CollisionBox2D</b></a>
<a href="#Class_CollisionChain2D"><b>CollisionChain2D</b></a>
<a href="#Class_CollisionCircle2D"><b>CollisionCircle2D</b></a>
<a href="#Class_CollisionEdge2D"><b>CollisionEdge2D</b></a>
<a href="#Class_CollisionPolygon2D"><b>CollisionPolygon2D</b></a>
<a href="#Class_CollisionShape"><b>CollisionShape</b></a>
<a href="#Class_CollisionShape2D"><b>CollisionShape2D</b></a>
<a href="#Class_Color"><b>Color</b></a>
<a href="#Class_ColorFrame"><b>ColorFrame</b></a>
<a href="#Class_Component"><b>Component</b></a>
<a href="#Class_Connection"><b>Connection</b></a>
<a href="#Class_Console"><b>Console</b></a>
<a href="#Class_Constraint"><b>Constraint</b></a>
<a href="#Class_Constraint2D"><b>Constraint2D</b></a>
<a href="#Class_ConstraintDistance2D"><b>ConstraintDistance2D</b></a>
<a href="#Class_ConstraintFriction2D"><b>ConstraintFriction2D</b></a>
<a href="#Class_ConstraintGear2D"><b>ConstraintGear2D</b></a>
<a href="#Class_ConstraintMotor2D"><b>ConstraintMotor2D</b></a>
<a href="#Class_ConstraintMouse2D"><b>ConstraintMouse2D</b></a>
<a href="#Class_ConstraintPrismatic2D"><b>ConstraintPrismatic2D</b></a>
<a href="#Class_ConstraintPulley2D"><b>ConstraintPulley2D</b></a>
<a href="#Class_ConstraintRevolute2D"><b>ConstraintRevolute2D</b></a>
<a href="#Class_ConstraintRope2D"><b>ConstraintRope2D</b></a>
<a href="#Class_ConstraintWeld2D"><b>ConstraintWeld2D</b></a>
<a href="#Class_ConstraintWheel2D"><b>ConstraintWheel2D</b></a>
<a href="#Class_Context"><b>Context</b></a>
<a href="#Class_Controls"><b>Controls</b></a>
<a href="#Class_Cursor"><b>Cursor</b></a>
<a href="#Class_CustomGeometry"><b>CustomGeometry</b></a>
<a href="#Class_CustomGeometryVertex"><b>CustomGeometryVertex</b></a>
<a href="#Class_DebugHud"><b>DebugHud</b></a>
<a href="#Class_DebugRenderer"><b>DebugRenderer</b></a>
<a href="#Class_DecalSet"><b>DecalSet</b></a>
<a href="#Class_Deserializer"><b>Deserializer</b></a>
<a href="#Class_Drawable"><b>Drawable</b></a>
<a href="#Class_Drawable2D"><b>Drawable2D</b></a>
<a href="#Class_DropDownList"><b>DropDownList</b></a>
<a href="#Class_Engine"><b>Engine</b></a>
<a href="#Class_File"><b>File</b></a>
<a href="#Class_FileSelector"><b>FileSelector</b></a>
<a href="#Class_FileSelectorEntry"><b>FileSelectorEntry</b></a>
<a href="#Class_FileSystem"><b>FileSystem</b></a>
<a href="#Class_FocusParameters"><b>FocusParameters</b></a>
<a href="#Class_Font"><b>Font</b></a>
<a href="#Class_Frustum"><b>Frustum</b></a>
<a href="#Class_Graphics"><b>Graphics</b></a>
<a href="#Class_HttpRequest"><b>HttpRequest</b></a>
<a href="#Class_Image"><b>Image</b></a>
<a href="#Class_Input"><b>Input</b></a>
<a href="#Class_IntRect"><b>IntRect</b></a>
<a href="#Class_IntVector2"><b>IntVector2</b></a>
<a href="#Class_JSONFile"><b>JSONFile</b></a>
<a href="#Class_JSONValue"><b>JSONValue</b></a>
<a href="#Class_JoystickState"><b>JoystickState</b></a>
<a href="#Class_Light"><b>Light</b></a>
<a href="#Class_LineEdit"><b>LineEdit</b></a>
<a href="#Class_ListView"><b>ListView</b></a>
<a href="#Class_Log"><b>Log</b></a>
<a href="#Class_LuaScriptInstance"><b>LuaScriptInstance</b></a>
<a href="#Class_Material"><b>Material</b></a>
<a href="#Class_Matrix3"><b>Matrix3</b></a>
<a href="#Class_Matrix3x4"><b>Matrix3x4</b></a>
<a href="#Class_Matrix4"><b>Matrix4</b></a>
<a href="#Class_Menu"><b>Menu</b></a>
<a href="#Class_MessageBox"><b>MessageBox</b></a>
<a href="#Class_Model"><b>Model</b></a>
<a href="#Class_Navigable"><b>Navigable</b></a>
<a href="#Class_NavigationGeometryInfo"><b>NavigationGeometryInfo</b></a>
<a href="#Class_NavigationMesh"><b>NavigationMesh</b></a>
<a href="#Class_Network"><b>Network</b></a>
<a href="#Class_NetworkPriority"><b>NetworkPriority</b></a>
<a href="#Class_Node"><b>Node</b></a>
<a href="#Class_Object"><b>Object</b></a>
<a href="#Class_ObjectAnimation"><b>ObjectAnimation</b></a>
<a href="#Class_Octree"><b>Octree</b></a>
<a href="#Class_OctreeQueryResult"><b>OctreeQueryResult</b></a>
<a href="#Class_OffMeshConnection"><b>OffMeshConnection</b></a>
<a href="#Class_PackageEntry"><b>PackageEntry</b></a>
<a href="#Class_PackageFile"><b>PackageFile</b></a>
<a href="#Class_ParticleEffect"><b>ParticleEffect</b></a>
<a href="#Class_ParticleEffect2D"><b>ParticleEffect2D</b></a>
<a href="#Class_ParticleEmitter"><b>ParticleEmitter</b></a>
<a href="#Class_ParticleEmitter2D"><b>ParticleEmitter2D</b></a>
<a href="#Class_Pass"><b>Pass</b></a>
<a href="#Class_PhysicsRaycastResult"><b>PhysicsRaycastResult</b></a>
<a href="#Class_PhysicsRaycastResult2D"><b>PhysicsRaycastResult2D</b></a>
<a href="#Class_PhysicsWorld"><b>PhysicsWorld</b></a>
<a href="#Class_PhysicsWorld2D"><b>PhysicsWorld2D</b></a>
<a href="#Class_Plane"><b>Plane</b></a>
<a href="#Class_Polyhedron"><b>Polyhedron</b></a>
<a href="#Class_PropertySet2D"><b>PropertySet2D</b></a>
<a href="#Class_Quaternion"><b>Quaternion</b></a>
<a href="#Class_Ray"><b>Ray</b></a>
<a href="#Class_RayQueryResult"><b>RayQueryResult</b></a>
<a href="#Class_Rect"><b>Rect</b></a>
<a href="#Class_RemoteEvent"><b>RemoteEvent</b></a>
<a href="#Class_RenderPath"><b>RenderPath</b></a>
<a href="#Class_RenderSurface"><b>RenderSurface</b></a>
<a href="#Class_Renderer"><b>Renderer</b></a>
<a href="#Class_Resource"><b>Resource</b></a>
<a href="#Class_ResourceCache"><b>ResourceCache</b></a>
<a href="#Class_ResourceRef"><b>ResourceRef</b></a>
<a href="#Class_ResourceRefList"><b>ResourceRefList</b></a>
<a href="#Class_RigidBody"><b>RigidBody</b></a>
<a href="#Class_RigidBody2D"><b>RigidBody2D</b></a>
<a href="#Class_Scene"><b>Scene</b></a>
<a href="#Class_ScrollBar"><b>ScrollBar</b></a>
<a href="#Class_ScrollView"><b>ScrollView</b></a>
<a href="#Class_Serializable"><b>Serializable</b></a>
<a href="#Class_Serializer"><b>Serializer</b></a>
<a href="#Class_Skeleton"><b>Skeleton</b></a>
<a href="#Class_Skybox"><b>Skybox</b></a>
<a href="#Class_Slider"><b>Slider</b></a>
<a href="#Class_Sound"><b>Sound</b></a>
<a href="#Class_SoundListener"><b>SoundListener</b></a>
<a href="#Class_SoundSource"><b>SoundSource</b></a>
<a href="#Class_SoundSource3D"><b>SoundSource3D</b></a>
<a href="#Class_Sphere"><b>Sphere</b></a>
<a href="#Class_Spline"><b>Spline</b></a>
<a href="#Class_SplinePath"><b>SplinePath</b></a>
<a href="#Class_Sprite"><b>Sprite</b></a>
<a href="#Class_Sprite2D"><b>Sprite2D</b></a>
<a href="#Class_SpriteSheet2D"><b>SpriteSheet2D</b></a>
<a href="#Class_StaticModel"><b>StaticModel</b></a>
<a href="#Class_StaticModelGroup"><b>StaticModelGroup</b></a>
<a href="#Class_StaticSprite2D"><b>StaticSprite2D</b></a>
<a href="#Class_StringHash"><b>StringHash</b></a>
<a href="#Class_Technique"><b>Technique</b></a>
<a href="#Class_Terrain"><b>Terrain</b></a>
<a href="#Class_TerrainPatch"><b>TerrainPatch</b></a>
<a href="#Class_Text"><b>Text</b></a>
<a href="#Class_Text3D"><b>Text3D</b></a>
<a href="#Class_Texture"><b>Texture</b></a>
<a href="#Class_Texture2D"><b>Texture2D</b></a>
<a href="#Class_TextureCube"><b>TextureCube</b></a>
<a href="#Class_TextureFrame"><b>TextureFrame</b></a>
<a href="#Class_Tile2D"><b>Tile2D</b></a>
<a href="#Class_TileMap2D"><b>TileMap2D</b></a>
<a href="#Class_TileMapInfo2D"><b>TileMapInfo2D</b></a>
<a href="#Class_TileMapLayer2D"><b>TileMapLayer2D</b></a>
<a href="#Class_TileMapObject2D"><b>TileMapObject2D</b></a>
<a href="#Class_Time"><b>Time</b></a>
<a href="#Class_TmxFile2D"><b>TmxFile2D</b></a>
<a href="#Class_ToolTip"><b>ToolTip</b></a>
<a href="#Class_TouchState"><b>TouchState</b></a>
<a href="#Class_UI"><b>UI</b></a>
<a href="#Class_UIElement"><b>UIElement</b></a>
<a href="#Class_ValueAnimation"><b>ValueAnimation</b></a>
<a href="#Class_Variant"><b>Variant</b></a>
<a href="#Class_VariantMap"><b>VariantMap</b></a>
<a href="#Class_Vector2"><b>Vector2</b></a>
<a href="#Class_Vector3"><b>Vector3</b></a>
<a href="#Class_Vector4"><b>Vector4</b></a>
<a href="#Class_VectorBuffer"><b>VectorBuffer</b></a>
<a href="#Class_View3D"><b>View3D</b></a>
<a href="#Class_Viewport"><b>Viewport</b></a>
<a href="#Class_Window"><b>Window</b></a>
<a href="#Class_XMLElement"><b>XMLElement</b></a>
<a href="#Class_XMLFile"><b>XMLFile</b></a>
<a href="#Class_Zone"><b>Zone</b></a>

\section LuaScriptAPI_Classes Classes

<a name="Class_Animatable"></a>
### Animatable : Serializable

Methods:

- void SetAnimationEnabled(bool enable)
- void SetObjectAnimation(ObjectAnimation* objectAnimation)
- void SetAttributeAnimation(const String name, ValueAnimation* attributeAnimation, WrapMode wrapMode = WM_LOOP, float speed = 1.0f)
- void SetAttributeAnimationWrapMode(const String name, WrapMode wrapMode)
- void SetAttributeAnimationSpeed(const String name, float speed)
- bool GetAnimationEnabled() const
- ObjectAnimation* GetObjectAnimation() const
- ValueAnimation* GetAttributeAnimation(const String name) const
- WrapMode GetAttributeAnimationWrapMode(const String name) const
- float GetAttributeAnimationSpeed(const String name) const

Properties:

- bool animationEnabled
- ObjectAnimation* objectAnimation

<a name="Class_AnimatedModel"></a>
### AnimatedModel : StaticModel

Methods:

- void SetModel(Model* model)
- AnimationState* AddAnimationState(Animation* animation)
- void RemoveAnimationState(Animation* animation)
- void RemoveAnimationState(const String animationName)
- void RemoveAnimationState(StringHash animationNameHash)
- void RemoveAnimationState(AnimationState* state)
- void RemoveAnimationState(unsigned index)
- void RemoveAllAnimationStates()
- void SetAnimationLodBias(float bias)
- void SetUpdateInvisible(bool enable)
- void SetMorphWeight(const String name, float weight)
- void SetMorphWeight(StringHash nameHash, float weight)
- void SetMorphWeight(unsigned index, float weight)
- void ResetMorphWeights()
- Skeleton& GetSkeleton()
- unsigned GetNumAnimationStates() const
- AnimationState* GetAnimationState(Animation* animation) const
- AnimationState* GetAnimationState(const String animationName) const
- AnimationState* GetAnimationState(const StringHash animationNameHash) const
- AnimationState* GetAnimationState(unsigned index) const
- float GetAnimationLodBias() const
- bool GetUpdateInvisible() const
- unsigned GetNumMorphs() const
- float GetMorphWeight(const String name) const
- float GetMorphWeight(StringHash nameHash) const
- float GetMorphWeight(unsigned index) const
- bool IsMaster() const

Properties:

- Model* model
- Skeleton& skeleton (readonly)
- unsigned numAnimationStates (readonly)
- float animationLodBias
- bool updateInvisible
- unsigned numMorphs (readonly)
- bool master (readonly)

<a name="Class_AnimatedSprite2D"></a>
### AnimatedSprite2D : Drawable

Methods:

- void SetLayer(int layer)
- void SetOrderInLayer(int orderInLayer)
- void SetBlendMode(BlendMode mode)
- void SetFlip(bool flipX, bool flipY)
- void SetFlipX(bool flipX)
- void SetFlipY(bool flipY)
- void SetColor(const Color& color)
- void SetSpeed(float speed)
- void SetAnimation(AnimationSet2D* animationSet, const String name, LoopMode2D loopMode = LM_DEFAULT)
- void SetAnimation(const String name, LoopMode2D loopMode = LM_DEFAULT)
- void SetAnimationSet(AnimationSet2D* animationSet)
- void SetLoopMode(LoopMode2D loopMode)
- int GetLayer() const
- int GetOrderInLayer() const
- BlendMode GetBlendMode() const
- bool GetFlipX() const
- bool GetFlipY() const
- const Color& GetColor() const
- float GetSpeed() const
- const String GetAnimation() const
- AnimationSet2D* GetAnimationSet() const
- LoopMode2D GetLoopMode() const

Properties:

- int layer
- int orderInLayer
- BlendMode blendMode
- bool flipX
- bool flipY
- Color& color
- float speed
- String animation
- AnimationSet2D* animationSet
- LoopMode2D loopMode

<a name="Class_Animation"></a>
### Animation : Resource

Methods:

- const String GetAnimationName() const
- StringHash GetAnimationNameHash() const
- float GetLength() const
- unsigned GetNumTracks() const
- const AnimationTrack* GetTrack(const String name) const
- const AnimationTrack* GetTrack(StringHash nameHash) const
- const AnimationTrack* GetTrack(unsigned index) const
- unsigned GetNumTriggers() const

Properties:

- String animationName (readonly)
- StringHash animationNameHash (readonly)
- float length (readonly)
- unsigned numTracks (readonly)
- unsigned numTriggers (readonly)

<a name="Class_Animation2D"></a>
### Animation2D : RefCounted

Methods:

- const String GetName() const
- float GetLength() const
- bool IsLooped() const

Properties:

- String name (readonly)
- float length (readonly)
- bool looped (readonly)

<a name="Class_AnimationControl"></a>
### AnimationControl


Methods:

- AnimationControl() (GC)
- AnimationControl* new()
- void delete()

Properties:

- StringHash hash_
- float speed_
- float targetWeight_
- float fadeTime_
- float autoFadeTime_
- float setTimeTtl_
- float setWeightTtl_
- short setTime_
- char setWeight_
- char setTimeRev_
- char setWeightRev_

<a name="Class_AnimationController"></a>
### AnimationController : Component

Methods:

- bool Play(const String name, char layer, bool looped, float fadeInTime = 0.0f)
- bool PlayExclusive(const String name, char layer, bool looped, float fadeTime = 0.0f)
- bool Stop(const String name, float fadeOutTime = 0.0f)
- void StopLayer(char layer, float fadeOutTime = 0.0f)
- void StopAll(float fadeTime = 0.0f)
- bool Fade(const String name, float targetWeight, float fadeTime)
- bool FadeOthers(const String name, float targetWeight, float fadeTime)
- bool SetLayer(const String name, char layer)
- bool SetStartBone(const String name, const String startBoneName)
- bool SetTime(const String name, float time)
- bool SetWeight(const String name, float weight)
- bool SetLooped(const String name, bool enable)
- bool SetSpeed(const String name, float speed)
- bool SetAutoFade(const String name, float fadeOutTime)
- bool IsPlaying(const String name) const
- bool IsFadingIn(const String name) const
- bool IsFadingOut(const String name) const
- char GetLayer(const String name) const
- Bone* GetStartBone(const String name) const
- const String GetStartBoneName(const String name) const
- float GetTime(const String name) const
- float GetWeight(const String name) const
- bool IsLooped(const String name) const
- float GetLength(const String name) const
- float GetSpeed(const String name) const
- float GetFadeTarget(const String name) const
- float GetFadeTime(const String name) const
- float GetAutoFade(const String name) const
- AnimationState* GetAnimationState(const String name) const
- AnimationState* GetAnimationState(StringHash nameHash) const

<a name="Class_AnimationKeyFrame"></a>
### AnimationKeyFrame


Properties:

- float time
- Vector3 position
- Quaternion rotation
- Vector3 scale

<a name="Class_AnimationSet2D"></a>
### AnimationSet2D : Resource

Methods:

- unsigned GetNumAnimations() const
- Animation2D* GetAnimation(unsigned index) const
- Animation2D* GetAnimation(const String name) const

Properties:

- unsigned numAnimations (readonly)

<a name="Class_AnimationState"></a>
### AnimationState


Methods:

- AnimationState(AnimatedModel* model, Animation* animation) (GC)
- AnimationState* new(AnimatedModel* model, Animation* animation)
- AnimationState(Node* node, Animation* animation) (GC)
- AnimationState* new(Node* node, Animation* animation)
- void delete()
- void SetStartBone(Bone* bone)
- void SetLooped(bool looped)
- void SetWeight(float weight)
- void SetTime(float time)
- void SetBoneWeight(const String name, float weight, bool recursive = false)
- void SetBoneWeight(StringHash nameHash, float weight, bool recursive = false)
- void SetBoneWeight(unsigned index, float weight, bool recursive = false)
- void AddWeight(float delta)
- void AddTime(float delta)
- void SetLayer(char layer)
- Animation* GetAnimation() const
- Bone* GetStartBone() const
- float GetBoneWeight(const String name) const
- float GetBoneWeight(StringHash nameHash) const
- float GetBoneWeight(unsigned index) const
- unsigned GetTrackIndex(const String name) const
- unsigned GetTrackIndex(StringHash nameHash) const
- bool IsEnabled() const
- bool IsLooped() const
- float GetWeight() const
- float GetTime() const
- float GetLength() const
- char GetLayer() const

Properties:

- Animation* animation (readonly)
- Bone* startBone
- bool enabled (readonly)
- bool looped
- float weight
- float time
- float length (readonly)
- char layer

<a name="Class_Audio"></a>
### Audio : Object

Methods:

- bool SetMode(int bufferLengthMSec, int mixRate, bool stereo, bool interpolation = true)
- bool Play()
- void Stop()
- void SetMasterGain(SoundType type, float gain)
- void SetListener(SoundListener* listener)
- void StopSound(Sound* sound)
- unsigned GetSampleSize() const
- int GetMixRate() const
- bool GetInterpolation() const
- bool IsStereo() const
- bool IsPlaying() const
- bool IsInitialized() const
- float GetMasterGain(SoundType type) const
- SoundListener* GetListener() const
- const PODVector<SoundSource*>& GetSoundSources() const
- void AddSoundSource(SoundSource* soundSource)
- void RemoveSoundSource(SoundSource* soundSource)
- float GetSoundSourceMasterGain(SoundType type) const
- void MixOutput(void* dest, unsigned samples)

Properties:

- unsigned sampleSize (readonly)
- int mixRate (readonly)
- bool interpolation (readonly)
- bool stereo (readonly)
- bool playing (readonly)
- bool initialized (readonly)
- SoundListener* listener

<a name="Class_BiasParameters"></a>
### BiasParameters


Methods:

- BiasParameters() (GC)
- BiasParameters* new()
- BiasParameters(float constantBias, float slopeScaledBias) (GC)
- BiasParameters* new(float constantBias, float slopeScaledBias)
- void delete()

<a name="Class_Billboard"></a>
### Billboard


Properties:

- Vector3 position
- Vector2 size
- Rect uv
- Color color
- float rotation
- bool enabled
- float sortDistance

<a name="Class_BillboardSet"></a>
### BillboardSet : Drawable

Methods:

- void SetMaterial(Material* material)
- void SetNumBillboards(unsigned num)
- void SetRelative(bool enable)
- void SetScaled(bool enable)
- void SetSorted(bool enable)
- void SetFaceCameraMode(FaceCameraMode mode)
- void SetAnimationLodBias(float bias)
- void Commit()
- Material* GetMaterial() const
- unsigned GetNumBillboards() const
- Billboard* GetBillboard(unsigned index)
- bool IsRelative() const
- bool IsScaled() const
- bool IsSorted() const
- FaceCameraMode GetFaceCameraMode() const
- float GetAnimationLodBias() const

Properties:

- Material* material
- unsigned numBillboards
- bool relative
- bool scaled
- bool sorted
- FaceCameraMode faceCameraMode
- float animationLodBias

<a name="Class_Bone"></a>
### Bone


Methods:

- Bone() (GC)
- Bone* new()
- void delete()

Properties:

- String name
- StringHash nameHash
- unsigned parentIndex
- Vector3 initialPosition
- Quaternion initialRotation
- Vector3 initialScale
- Matrix3x4 offsetMatrix
- bool animated
- char collisionMask
- float radius
- BoundingBox boundingBox
- Node* node

<a name="Class_BorderImage"></a>
### BorderImage : UIElement

Methods:

- BorderImage() (GC)
- BorderImage* new()
- void delete()
- void SetTexture(Texture* texture)
- void SetImageRect(const IntRect& rect)
- void SetFullImageRect()
- void SetBorder(const IntRect& rect)
- void SetImageBorder(const IntRect& rect)
- void SetHoverOffset(const IntVector2& offset)
- void SetHoverOffset(int x, int y)
- void SetBlendMode(BlendMode mode)
- void SetTiled(bool enable)
- Texture* GetTexture() const
- const IntRect& GetImageRect() const
- const IntRect& GetBorder() const
- const IntRect& GetImageBorder() const
- const IntVector2& GetHoverOffset() const
- BlendMode GetBlendMode() const
- bool IsTiled() const

Properties:

- Texture* texture
- IntRect& imageRect
- IntRect& border
- IntRect& imageBorder
- IntVector2& hoverOffset
- BlendMode blendMode
- bool tiled

<a name="Class_BoundingBox"></a>
### BoundingBox


Methods:

- BoundingBox() (GC)
- BoundingBox* new()
- BoundingBox(const BoundingBox& box) (GC)
- BoundingBox* new(const BoundingBox& box)
- BoundingBox(const Rect& rect) (GC)
- BoundingBox* new(const Rect& rect)
- BoundingBox(const Vector3& min, const Vector3& max) (GC)
- BoundingBox* new(const Vector3& min, const Vector3& max)
- BoundingBox(float min, float max) (GC)
- BoundingBox* new(float min, float max)
- BoundingBox(const Frustum& frustum) (GC)
- BoundingBox* new(const Frustum& frustum)
- BoundingBox(const Polyhedron& poly) (GC)
- BoundingBox* new(const Polyhedron& poly)
- BoundingBox(const Sphere& sphere) (GC)
- BoundingBox* new(const Sphere& sphere)
- void delete()
- bool operator==(const BoundingBox& rhs) const
- void Define(const BoundingBox& box)
- void Define(const Rect& rect)
- void Define(const Vector3& min, const Vector3& max)
- void Define(float min, float max)
- void Define(const Vector3& point)
- void Define(const Frustum& frustum)
- void Define(const Polyhedron& poly)
- void Define(const Sphere& sphere)
- void Merge(const Vector3& point)
- void Merge(const BoundingBox& box)
- void Merge(const Frustum& frustum)
- void Merge(const Polyhedron& poly)
- void Merge(const Sphere& sphere)
- void Clip(const BoundingBox& box)
- void Transform(const Matrix3& transform)
- void Transform(const Matrix3x4& transform)
- void Clear()
- Vector3 Center() const
- Vector3 Size() const
- Vector3 HalfSize() const
- BoundingBox Transformed(const Matrix3& transform) const
- BoundingBox Transformed(const Matrix3x4& transform) const
- Rect Projected(const Matrix4& projection) const
- Intersection IsInside(const Vector3& point) const
- Intersection IsInside(const BoundingBox& box) const
- Intersection IsInsideFast(const BoundingBox& box) const
- Intersection IsInside(const Sphere& sphere) const
- Intersection IsInsideFast(const Sphere& sphere) const
- String ToString() const

Properties:

- Vector3 min
- Vector3 max
- bool defined
- Vector3 center (readonly)
- Vector3 size (readonly)
- Vector3 halfSize (readonly)

<a name="Class_Button"></a>
### Button : BorderImage

Methods:

- Button() (GC)
- Button* new()
- void delete()
- void SetPressedOffset(const IntVector2& offset)
- void SetPressedOffset(int x, int y)
- void SetPressedChildOffset(const IntVector2& offset)
- void SetPressedChildOffset(int x, int y)
- void SetRepeat(float delay, float rate)
- void SetRepeatDelay(float delay)
- void SetRepeatRate(float rate)
- const IntVector2& GetPressedOffset() const
- const IntVector2& GetPressedChildOffset() const
- float GetRepeatDelay() const
- float GetRepeatRate() const
- bool IsPressed() const

Properties:

- IntVector2& pressedOffset
- IntVector2& pressedChildOffset
- float repeatDelay
- float repeatRate
- bool pressed (readonly)

<a name="Class_Camera"></a>
### Camera : Component

Methods:

- void SetNearClip(float nearClip)
- void SetFarClip(float farClip)
- void SetFov(float fov)
- void SetOrthoSize(float orthoSize)
- void SetOrthoSize(const Vector2& orthoSize)
- void SetAspectRatio(float aspectRatio)
- void SetFillMode(FillMode mode)
- void SetZoom(float zoom)
- void SetLodBias(float bias)
- void SetViewMask(unsigned mask)
- void SetViewOverrideFlags(unsigned flags)
- void SetOrthographic(bool enable)
- void SetAutoAspectRatio(bool enable)
- void SetProjectionOffset(const Vector2& offset)
- void SetUseReflection(bool enable)
- void SetReflectionPlane(const Plane& reflectionPlane)
- void SetUseClipping(bool enable)
- void SetClipPlane(const Plane& clipPlane)
- float GetFarClip() const
- float GetNearClip() const
- float GetFov() const
- float GetOrthoSize() const
- float GetAspectRatio() const
- float GetZoom() const
- float GetLodBias() const
- unsigned GetViewMask() const
- unsigned GetViewOverrideFlags() const
- FillMode GetFillMode() const
- bool IsOrthographic() const
- bool GetAutoAspectRatio() const
- const Frustum& GetFrustum() const
- const Matrix4& GetProjection() const
- const Matrix3x4& GetView() const
- void GetFrustumSize(Vector3& near, Vector3& far) const
- float GetHalfViewSize() const
- Frustum GetSplitFrustum(float nearClip, float farClip) const
- Frustum GetViewSpaceFrustum() const
- Frustum GetViewSpaceSplitFrustum(float nearClip, float farClip) const
- Ray GetScreenRay(float x, float y) const
- Vector2 WorldToScreenPoint(const Vector3& worldPos) const
- Vector3 ScreenToWorldPoint(const Vector3& screenPos) const
- const Vector2& GetProjectionOffset() const
- bool GetUseReflection() const
- const Plane& GetReflectionPlane() const
- bool GetUseClipping() const
- const Plane& GetClipPlane() const
- float GetDistance(const Vector3& worldPos) const
- float GetDistanceSquared(const Vector3& worldPos) const
- float GetLodDistance(float distance, float scale, float bias) const
- bool IsProjectionValid() const
- Matrix3x4 GetEffectiveWorldTransform() const

Properties:

- float farClip
- float nearClip
- float fov
- float orthoSize
- float aspectRatio
- float zoom
- float lodBias
- unsigned viewMask
- unsigned viewOverrideFlags
- FillMode fillMode
- bool orthographic
- bool autoAspectRatio
- Frustum& frustum (readonly)
- Matrix4& projection (readonly)
- Matrix3x4& view (readonly)
- float halfViewSize (readonly)
- Frustum viewSpaceFrustum (readonly)
- Vector2& projectionOffset
- bool useReflection
- Plane& reflectionPlane
- bool useClipping
- Plane& clipPlane
- bool projectionValid (readonly)
- Matrix3x4 effectiveWorldTransform (readonly)

<a name="Class_CascadeParameters"></a>
### CascadeParameters


Methods:

- CascadeParameters() (GC)
- CascadeParameters* new()
- CascadeParameters(float split1, float split2, float split3, float split4, float fadeStart, float biasAutoAdjust = 1.0f) (GC)
- CascadeParameters* new(float split1, float split2, float split3, float split4, float fadeStart, float biasAutoAdjust = 1.0f)
- void delete()

<a name="Class_CheckBox"></a>
### CheckBox : BorderImage

Methods:

- CheckBox() (GC)
- CheckBox* new()
- void delete()
- void SetChecked(bool enable)
- void SetCheckedOffset(const IntVector2& rect)
- void SetCheckedOffset(int x, int y)
- bool IsChecked() const
- const IntVector2& GetCheckedOffset() const

Properties:

- bool checked
- IntVector2& checkedOffset

<a name="Class_CollisionBox2D"></a>
### CollisionBox2D : CollisionShape2D

Methods:

- void SetSize(const Vector2& size)
- void SetSize(float width, float height)
- void SetCenter(const Vector2& center)
- void SetCenter(float x, float y)
- void SetAngle(float angle)
- const Vector2& GetSize() const
- const Vector2& GetCenter() const
- float GetAngle() const

Properties:

- Vector2& size
- Vector2& center
- float angle

<a name="Class_CollisionChain2D"></a>
### CollisionChain2D : CollisionShape2D

Methods:

- void SetLoop(bool loop)
- void SetVertexCount(unsigned count)
- void SetVertex(unsigned index, const Vector2& vertex)
- void SetVertices(const PODVector<Vector2>& vertices)
- bool GetLoop() const
- unsigned GetVertexCount() const
- const Vector2& GetVertex(unsigned index) const

Properties:

- bool loop
- unsigned vertexCount

<a name="Class_CollisionCircle2D"></a>
### CollisionCircle2D : CollisionShape2D

Methods:

- void SetRadius(float radius)
- void SetCenter(const Vector2& center)
- void SetCenter(float x, float y)
- float GetRadius() const
- const Vector2& GetCenter() const

Properties:

- float radius
- Vector2& center

<a name="Class_CollisionEdge2D"></a>
### CollisionEdge2D : CollisionShape2D

Methods:

- void SetVertex1(const Vector2& vertex)
- void SetVertex2(const Vector2& vertex)
- void SetVertices(const Vector2& vertex1, const Vector2& vertex2)
- const Vector2& GetVertex1() const
- const Vector2& GetVertex2() const

Properties:

- Vector2& vertex1
- Vector2& vertex2

<a name="Class_CollisionPolygon2D"></a>
### CollisionPolygon2D : CollisionShape2D

Methods:

- void SetVertexCount(unsigned count)
- void SetVertex(unsigned index, const Vector2& vertex)
- void SetVertices(const PODVector<Vector2>& vertices)
- unsigned GetVertexCount() const
- const Vector2& GetVertex(unsigned index) const

Properties:

- unsigned vertexCount

<a name="Class_CollisionShape"></a>
### CollisionShape : Component

Methods:

- void SetBox(const Vector3& size)
- void SetBox(const Vector3& size, const Vector3& position)
- void SetBox(const Vector3& size, const Vector3& position, const Quaternion& rotation)
- void SetSphere(float diameter)
- void SetSphere(float diameter, const Vector3& position)
- void SetSphere(float diameter, const Vector3& position, const Quaternion& rotation)
- void SetStaticPlane()
- void SetStaticPlane(const Vector3& position)
- void SetStaticPlane(const Vector3& position, const Quaternion& rotation)
- void SetCylinder(float diameter, float height)
- void SetCylinder(float diameter, float height, const Vector3& position)
- void SetCylinder(float diameter, float height, const Vector3& position, const Quaternion& rotation)
- void SetCapsule(float diameter, float height)
- void SetCapsule(float diameter, float height, const Vector3& position)
- void SetCapsule(float diameter, float height, const Vector3& position, const Quaternion& rotation)
- void SetCone(float diameter, float height)
- void SetCone(float diameter, float height, const Vector3& position)
- void SetCone(float diameter, float height, const Vector3& position, const Quaternion& rotation)
- void SetTriangleMesh(Model* model, unsigned lodLevel = 0)
- void SetTriangleMesh(Model* model, unsigned lodLevel, const Vector3& scale)
- void SetTriangleMesh(Model* model, unsigned lodLevel, const Vector3& scale, const Vector3& position)
- void SetTriangleMesh(Model* model, unsigned lodLevel, const Vector3& scale, const Vector3& position, const Quaternion& rotation)
- void SetCustomTriangleMesh(CustomGeometry* custom)
- void SetCustomTriangleMesh(CustomGeometry* custom, const Vector3& scale)
- void SetCustomTriangleMesh(CustomGeometry* custom, const Vector3& scale, const Vector3& position)
- void SetCustomTriangleMesh(CustomGeometry* custom, const Vector3& scale, const Vector3& position, const Quaternion& rotation)
- void SetConvexHull(Model* model, unsigned lodLevel = 0)
- void SetConvexHull(Model* model, unsigned lodLevel, const Vector3& scale)
- void SetConvexHull(Model* model, unsigned lodLevel, const Vector3& scale, const Vector3& position)
- void SetConvexHull(Model* model, unsigned lodLevel, const Vector3& scale, const Vector3& position, const Quaternion& rotation)
- void SetCustomConvexHull(CustomGeometry* custom)
- void SetCustomConvexHull(CustomGeometry* custom, const Vector3& scale)
- void SetCustomConvexHull(CustomGeometry* custom, const Vector3& scale, const Vector3& position)
- void SetCustomConvexHull(CustomGeometry* custom, const Vector3& scale, const Vector3& position, const Quaternion& rotation)
- void SetTerrain()
- void SetShapeType(ShapeType type)
- void SetSize(const Vector3& size)
- void SetPosition(const Vector3& position)
- void SetRotation(const Quaternion& rotation)
- void SetTransform(const Vector3& position, const Quaternion& rotation)
- void SetMargin(float margin)
- void SetModel(Model* model)
- void SetLodLevel(unsigned lodLevel)
- PhysicsWorld* GetPhysicsWorld() const
- ShapeType GetShapeType() const
- const Vector3& GetSize() const
- const Vector3& GetPosition() const
- const Quaternion& GetRotation() const
- float GetMargin() const
- Model* GetModel() const
- unsigned GetLodLevel() const
- BoundingBox GetWorldBoundingBox() const

Properties:

- PhysicsWorld* physicsWorld (readonly)
- ShapeType shapeType
- Vector3& size
- Vector3& position
- Quaternion& rotation
- float margin
- Model* model
- unsigned lodLevel
- BoundingBox worldBoundingBox (readonly)
- ResourceRef modelAttr

<a name="Class_CollisionShape2D"></a>
### CollisionShape2D : Component

Methods:

- void SetTrigger(bool trigger)
- void SetCategoryBits(int categoryBits)
- void SetMaskBits(int maskBits)
- void SetGroupIndex(int groupIndex)
- void SetDensity(float density)
- void SetFriction(float friction)
- void SetRestitution(float restitution)
- bool IsTrigger() const
- int GetCategoryBits() const
- int GetMaskBits() const
- int GetGroupIndex() const
- float GetDensity() const
- float GetFriction() const
- float GetRestitution() const
- float GetMass() const
- float GetInertia() const
- Vector2 GetMassCenter() const

Properties:

- bool trigger
- int categoryBits
- int maskBits
- int groupIndex
- float density
- float friction
- float restitution
- float mass (readonly)
- float inertia (readonly)
- Vector2 massCenter (readonly)

<a name="Class_Color"></a>
### Color


Methods:

- Color() (GC)
- Color* new()
- Color(const Color& color) (GC)
- Color* new(const Color& color)
- Color(const Color& color, float a) (GC)
- Color* new(const Color& color, float a)
- Color(float r, float g, float b) (GC)
- Color* new(float r, float g, float b)
- Color(float r, float g, float b, float a) (GC)
- Color* new(float r, float g, float b, float a)
- void delete()
- bool operator==(const Color& rhs) const
- Color operator*(float rhs) const
- Color operator+(const Color& rhs)
- unsigned ToUInt() const
- Vector3 ToHSL() const
- Vector3 ToHSV() const
- void FromHSL(float h, float s, float l, float a)
- void FromHSV(float h, float s, float v, float a)
- Vector3 ToVector3() const
- Vector4 ToVector4() const
- float SumRGB() const
- float Average() const
- float Luma() const
- float Chroma() const
- float Hue() const
- float SaturationHSL() const
- float SaturationHSV() const
- float Value() const
- float Lightness() const
- float MaxRGB() const
- float MinRGB() const
- float Range() const
- void Clip(bool clipAlpha = false)
- void Invert(bool invertAlpha = false)
- Color Lerp(const Color& rhs, float t) const
- Color Abs() const
- bool Equals(const Color& rhs) const
- String ToString() const

Properties:

- float r
- float g
- float b
- float a
- const Color WHITE
- const Color GRAY
- const Color BLACK
- const Color RED
- const Color GREEN
- const Color BLUE
- const Color CYAN
- const Color MAGENTA
- const Color YELLOW
- const Color TRANSPARENT

<a name="Class_ColorFrame"></a>
### ColorFrame


Methods:

- ColorFrame() (GC)
- ColorFrame* new()
- ColorFrame(const Color& color) (GC)
- ColorFrame* new(const Color& color)
- ColorFrame(const Color& color, float time) (GC)
- ColorFrame* new(const Color& color, float time)
- void delete()
- Color Interpolate(const ColorFrame& next, float time)

Properties:

- Color color
- float time

<a name="Class_Component"></a>
### Component : Animatable

Methods:

- void SetEnabled(bool enable)
- void Remove()
- unsigned GetID() const
- Node* GetNode() const
- Scene* GetScene() const
- bool IsEnabled() const
- bool IsEnabledEffective() const
- Component* GetComponent(StringHash type) const
- Component* GetComponent(const String type) const

<a name="Class_Connection"></a>
### Connection : Object

Methods:

- void SendMessage(int msgID, bool reliable, bool inOrder, const VectorBuffer& msg, unsigned contentID = 0)
- void SendRemoteEvent(StringHash eventType, bool inOrder)
- void SendRemoteEvent(StringHash eventType, bool inOrder, const VariantMap& eventData)
- void SendRemoteEvent(const String eventType, bool inOrder)
- void SendRemoteEvent(const String eventType, bool inOrder, const VariantMap& eventData)
- void SendRemoteEvent(Node* node, StringHash eventType, bool inOrder)
- void SendRemoteEvent(Node* node, StringHash eventType, bool inOrder, const VariantMap& eventData)
- void SendRemoteEvent(Node* node, const String eventType, bool inOrder)
- void SendRemoteEvent(Node* node, const String eventType, bool inOrder, const VariantMap& eventData)
- void SetScene(Scene* newScene)
- void SetIdentity(const VariantMap& identity)
- void SetControls(const Controls& newControls)
- void SetPosition(const Vector3& position)
- void SetRotation(const Quaternion& rotation)
- void SetConnectPending(bool connectPending)
- void SetLogStatistics(bool enable)
- void Disconnect(int waitMSec = 0)
- void SendPackageToClient(PackageFile* package)
- VariantMap& GetIdentity()
- Scene* GetScene() const
- const Controls& GetControls() const
- const Vector3& GetPosition() const
- const Quaternion& GetRotation() const
- bool IsClient() const
- bool IsConnected() const
- bool IsConnectPending() const
- bool IsSceneLoaded() const
- bool GetLogStatistics() const
- String GetAddress() const
- short GetPort() const
- String ToString() const
- unsigned GetNumDownloads() const
- const String GetDownloadName() const
- float GetDownloadProgress() const

Properties:

- VariantMap& identity
- Scene* scene
- Controls& controls
- Vector3& position
- Quaternion& rotation
- bool client (readonly)
- bool connected (readonly)
- bool connectPending
- bool sceneLoaded (readonly)
- bool logStatistics
- String address (readonly)
- short port (readonly)
- unsigned numDownloads (readonly)
- String downloadName (readonly)
- float downloadProgress (readonly)

<a name="Class_Console"></a>
### Console : Object

Methods:

- void SetDefaultStyle(XMLFile* style)
- void SetVisible(bool enable)
- void Toggle()
- void SetAutoVisibleOnError(bool enable)
- void SetCommandInterpreter(const String interpreter)
- void SetNumBufferedRows(unsigned rows)
- void SetNumRows(unsigned rows)
- void SetNumHistoryRows(unsigned rows)
- void SetFocusOnShow(bool enable)
- void UpdateElements()
- XMLFile* GetDefaultStyle() const
- BorderImage* GetBackground() const
- LineEdit* GetLineEdit() const
- Button* GetCloseButton() const
- bool IsVisible() const
- bool IsAutoVisibleOnError() const
- const String GetCommandInterpreter() const
- unsigned GetNumBufferedRows() const
- unsigned GetNumRows() const
- void CopySelectedRows() const
- unsigned GetNumHistoryRows() const
- unsigned GetHistoryPosition() const
- const String GetHistoryRow(unsigned index) const
- bool GetFocusOnShow() const

Properties:

- XMLFile* defaultStyle
- BorderImage* background (readonly)
- LineEdit* lineEdit (readonly)
- Button* closeButton (readonly)
- bool visible
- bool autoVisibleOnError
- String commandInterpreter
- unsigned numBufferedRows
- unsigned numRows
- unsigned numHistoryRows
- unsigned historyPosition (readonly)
- bool focusOnShow

<a name="Class_Constraint"></a>
### Constraint : Component

Methods:

- void SetConstraintType(ConstraintType type)
- void SetOtherBody(RigidBody* body)
- void SetPosition(const Vector3& position)
- void SetRotation(const Quaternion& rotation)
- void SetAxis(const Vector3& axis)
- void SetOtherPosition(const Vector3& position)
- void SetOtherRotation(const Quaternion& rotation)
- void SetOtherAxis(const Vector3& axis)
- void SetWorldPosition(const Vector3& position)
- void SetHighLimit(const Vector2& limit)
- void SetLowLimit(const Vector2& limit)
- void SetERP(float erp)
- void SetCFM(float cfm)
- void SetDisableCollision(bool disable)
- PhysicsWorld* GetPhysicsWorld() const
- ConstraintType GetConstraintType() const
- RigidBody* GetOwnBody() const
- RigidBody* GetOtherBody() const
- const Vector3& GetPosition() const
- const Quaternion& GetRotation() const
- const Vector3& GetOtherPosition() const
- const Quaternion& GetOtherRotation() const
- Vector3 GetWorldPosition() const
- const Vector2& GetHighLimit() const
- const Vector2& GetLowLimit() const
- float GetERP() const
- float GetCFM() const
- bool GetDisableCollision() const

Properties:

- PhysicsWorld* physicsWorld (readonly)
- ConstraintType constraintType
- RigidBody* ownBody (readonly)
- RigidBody* otherBody
- Vector3& position
- Quaternion& rotation
- Vector3& axis
- Vector3& otherPosition
- Quaternion& otherRotation
- Vector3& otherAxis
- Vector3 worldPosition
- Vector2& highLimit
- Vector2& lowLimit
- float ERP
- float CFM
- bool disableCollision

<a name="Class_Constraint2D"></a>
### Constraint2D : Component

Methods:

- void SetOtherBody(RigidBody2D* body)
- void SetCollideConnected(bool collideConnected)
- RigidBody2D* GetOwnerBody() const
- RigidBody2D* GetOtherBody() const
- bool GetCollideConnected() const

Properties:

- RigidBody2D* ownerBody (readonly)
- RigidBody2D* otherBody
- bool collideConnected

<a name="Class_ConstraintDistance2D"></a>
### ConstraintDistance2D : Constraint2D

Methods:

- void SetOwnerBodyAnchor(const Vector2& anchor)
- void SetOtherBodyAnchor(const Vector2& anchor)
- void SetFrequencyHz(float frequencyHz)
- void SetDampingRatio(float dampingRatio)
- const Vector2& GetOwnerBodyAnchor() const
- const Vector2& GetOtherBodyAnchor() const
- float GetFrequencyHz() const
- float GetDampingRatio() const

Properties:

- Vector2& ownerBodyAnchor
- Vector2& otherBodyAnchor
- float frequencyHz
- float dampingRatio

<a name="Class_ConstraintFriction2D"></a>
### ConstraintFriction2D : Constraint2D

Methods:

- void SetAnchor(const Vector2& anchor)
- void SetMaxForce(float maxForce)
- void SetMaxTorque(float maxTorque)
- const Vector2& GetAnchor() const
- float GetMaxForce() const
- float GetMaxTorque() const

Properties:

- Vector2& anchor
- float maxForce
- float maxTorque

<a name="Class_ConstraintGear2D"></a>
### ConstraintGear2D : Constraint2D

Methods:

- void SetOwnerConstraint(Constraint2D* constraint)
- void SetOtherConstraint(Constraint2D* constraint)
- void SetRatio(float ratio)
- Constraint2D* GetOwnerConstraint() const
- Constraint2D* GetOtherConstraint() const
- float GetRatio() const

Properties:

- Constraint2D* ownerConstraint
- Constraint2D* otherConstraint
- float ratio

<a name="Class_ConstraintMotor2D"></a>
### ConstraintMotor2D : Constraint2D

Methods:

- void SetLinearOffset(const Vector2& linearOffset)
- void SetAngularOffset(float angularOffset)
- void SetMaxForce(float maxForce)
- void SetMaxTorque(float maxTorque)
- void SetCorrectionFactor(float correctionFactor)
- const Vector2& GetLinearOffset() const
- float GetAngularOffset() const
- float GetMaxForce() const
- float GetMaxTorque() const
- float GetCorrectionFactor() const

Properties:

- Vector2& linearOffset
- float angularOffset
- float maxForce
- float maxTorque
- float correctionFactor

<a name="Class_ConstraintMouse2D"></a>
### ConstraintMouse2D : Constraint2D

Methods:

- void SetTarget(const Vector2& target)
- void SetMaxForce(float maxForce)
- void SetFrequencyHz(float frequencyHz)
- void SetDampingRatio(float dampingRatio)
- const Vector2& GetTarget() const
- float GetMaxForce() const
- float GetFrequencyHz() const
- float GetDampingRatio() const

Properties:

- Vector2& target
- float maxForce
- float frequencyHz
- float dampingRatio

<a name="Class_ConstraintPrismatic2D"></a>
### ConstraintPrismatic2D : Constraint2D

Methods:

- void SetAnchor(const Vector2& anchor)
- void SetAxis(const Vector2& axis)
- void SetEnableLimit(bool enableLimit)
- void SetLowerTranslation(float lowerTranslation)
- void SetUpperTranslation(float upperTranslation)
- void SetEnableMotor(bool enableMotor)
- void SetMaxMotorForce(float maxMotorForce)
- void SetMotorSpeed(float motorSpeed)
- const Vector2& GetAnchor() const
- const Vector2& GetAxis() const
- bool GetEnableLimit() const
- float GetLowerTranslation() const
- float GetUpperTranslation() const
- bool GetEnableMotor() const
- float GetMaxMotorForce() const
- float GetMotorSpeed() const

Properties:

- Vector2& anchor
- Vector2& axis
- bool enableLimit
- float lowerTranslation
- float upperTranslation
- bool enableMotor
- float maxMotorForce
- float motorSpeed

<a name="Class_ConstraintPulley2D"></a>
### ConstraintPulley2D : Constraint2D

Methods:

- void SetOwnerBodyGroundAnchor(const Vector2& groundAnchor)
- void SetOtherBodyGroundAnchor(const Vector2& groundAnchor)
- void SetOwnerBodyAnchor(const Vector2& anchor)
- void SetOtherBodyAnchor(const Vector2& anchor)
- void SetRatio(float ratio)
- const Vector2& GetOwnerBodyGroundAnchor() const
- const Vector2& GetOtherBodyGroundAnchor() const
- const Vector2& GetOwnerBodyAnchor() const
- const Vector2& GetOtherBodyAnchor() const
- float GetRatio() const

Properties:

- Vector2& ownerBodyGroundAnchor
- Vector2& otherBodyGroundAnchor
- Vector2& ownerBodyAnchor
- Vector2& otherBodyAnchor
- float ratio

<a name="Class_ConstraintRevolute2D"></a>
### ConstraintRevolute2D : Constraint2D

Methods:

- void SetAnchor(const Vector2& anchor)
- void SetEnableLimit(bool enableLimit)
- void SetLowerAngle(float lowerAngle)
- void SetUpperAngle(float upperAngle)
- void SetEnableMotor(bool enableMotor)
- void SetMotorSpeed(float motorSpeed)
- void SetMaxMotorTorque(float maxMotorTorque)
- const Vector2& GetAnchor() const
- bool GetEnableLimit() const
- float GetLowerAngle() const
- float GetUpperAngle() const
- bool GetEnableMotor() const
- float GetMotorSpeed() const
- float GetMaxMotorTorque() const

Properties:

- Vector2& anchor
- bool enableLimit
- float lowerAngle
- float upperAngle
- bool enableMotor
- float motorSpeed
- float maxMotorTorque

<a name="Class_ConstraintRope2D"></a>
### ConstraintRope2D : Constraint2D

Methods:

- void SetOwnerBodyAnchor(const Vector2& anchor)
- void SetOtherBodyAnchor(const Vector2& anchor)
- void SetMaxLength(float maxLength)
- const Vector2& GetOwnerBodyAnchor() const
- const Vector2& GetOtherBodyAnchor() const
- float GetMaxLength() const

Properties:

- Vector2& ownerBodyAnchor
- Vector2& otherBodyAnchor
- float maxLength

<a name="Class_ConstraintWeld2D"></a>
### ConstraintWeld2D : Constraint2D

Methods:

- void SetAnchor(const Vector2& anchor)
- void SetFrequencyHz(float frequencyHz)
- void SetDampingRatio(float dampingRatio)
- const Vector2& GetAnchor() const
- float GetFrequencyHz() const
- float GetDampingRatio() const

Properties:

- Vector2& anchor
- float frequencyHz
- float dampingRatio

<a name="Class_ConstraintWheel2D"></a>
### ConstraintWheel2D : Constraint2D

Methods:

- void SetAnchor(const Vector2& anchor)
- void SetAxis(const Vector2& axis)
- void SetEnableMotor(bool enableMotor)
- void SetMaxMotorTorque(float maxMotorTorque)
- void SetMotorSpeed(float motorSpeed)
- void SetFrequencyHz(float frequencyHz)
- void SetDampingRatio(float dampingRatio)
- const Vector2& GetAnchor() const
- const Vector2& GetAxis() const
- bool GetEnableMotor() const
- float GetMaxMotorTorque() const
- float GetMotorSpeed() const
- float GetFrequencyHz() const
- float GetDampingRatio() const

Properties:

- Vector2& anchor
- Vector2& axis
- bool enableMotor
- float maxMotorTorque
- float motorSpeed
- float frequencyHz
- float dampingRatio

<a name="Class_Context"></a>
### Context


Methods:

- Object* GetEventSender() const
- EventHandler* GetEventHandler() const
- const String GetTypeName(StringHash objectType) const

<a name="Class_Controls"></a>
### Controls


Methods:

- Controls() (GC)
- Controls* new()
- void delete()
- void Reset()
- void Set(unsigned buttons, bool down = true)
- bool IsDown(unsigned button) const
- bool IsPressed(unsigned button, const Controls& previousControls) const

Properties:

- unsigned buttons
- float yaw
- float pitch
- VariantMap extraData

<a name="Class_Cursor"></a>
### Cursor : BorderImage

Methods:

- Cursor() (GC)
- Cursor* new()
- void delete()
- void DefineShape(CursorShape shape, Image* image, const IntRect& imageRect, const IntVector2& hotSpot)
- void SetShape(CursorShape shape)
- void SetUseSystemShapes(bool enable)
- CursorShape GetShape() const
- bool GetUseSystemShapes() const

Properties:

- CursorShape shape
- bool useSystemShapes

<a name="Class_CustomGeometry"></a>
### CustomGeometry : Drawable

Methods:

- void Clear()
- void SetNumGeometries(unsigned num)
- void SetDynamic(bool enable)
- void BeginGeometry(unsigned index, PrimitiveType type)
- void DefineVertex(const Vector3& position)
- void DefineNormal(const Vector3& normal)
- void DefineTangent(const Vector4& tangent)
- void DefineColor(const Color& color)
- void DefineTexCoord(const Vector2& texCoord)
- void DefineGeometry(unsigned index, PrimitiveType type, unsigned numVertices, bool hasNormals, bool hasColors, bool hasTexCoords, bool hasTangents)
- void Commit()
- void SetMaterial(Material* material)
- bool SetMaterial(unsigned index, Material* material)
- unsigned GetNumGeometries() const
- unsigned GetNumVertices(unsigned index) const
- bool IsDynamic() const
- Material* GetMaterial(unsigned index = 0)
- CustomGeometryVertex* GetVertex(unsigned geometryIndex, unsigned vertexNum)

Properties:

- Material* material
- unsigned numGeometries
- bool dynamic

<a name="Class_CustomGeometryVertex"></a>
### CustomGeometryVertex


Properties:

- Vector3 position
- Vector3 normal
- unsigned color
- Vector2 texCoord
- Vector4 tangent

<a name="Class_DebugHud"></a>
### DebugHud : Object

Methods:

- void Update()
- void SetDefaultStyle(XMLFile* style)
- void SetMode(unsigned mode)
- void SetProfilerMaxDepth(unsigned depth)
- void SetProfilerInterval(float interval)
- void SetUseRendererStats(bool enable)
- void Toggle(unsigned mode)
- void ToggleAll()
- XMLFile* GetDefaultStyle() const
- Text* GetStatsText() const
- Text* GetModeText() const
- Text* GetProfilerText() const
- unsigned GetMode() const
- unsigned GetProfilerMaxDepth() const
- float GetProfilerInterval() const
- bool GetUseRendererStats() const
- void SetAppStats(const String label, const Variant stats)
- void SetAppStats(const String label, const String stats)
- bool ResetAppStats(const String label)
- void ClearAppStats()

Properties:

- XMLFile* defaultStyle
- Text* statsText (readonly)
- Text* modeText (readonly)
- Text* profilerText (readonly)
- unsigned mode
- unsigned profilerMaxDepth
- float profilerInterval
- bool useRendererStats

<a name="Class_DebugRenderer"></a>
### DebugRenderer : Component

Methods:

- void SetView(Camera* camera)
- void AddLine(const Vector3& start, const Vector3& end, const Color& color, bool depthTest = true)
- void AddLine(const Vector3& start, const Vector3& end, unsigned color, bool depthTest = true)
- void AddTriangle(const Vector3& v1, const Vector3& v2, const Vector3& v3, const Color& color, bool depthTest = true)
- void AddTriangle(const Vector3& v1, const Vector3& v2, const Vector3& v3, unsigned color, bool depthTest = true)
- void AddNode(Node* node, float scale = 1.0f, bool depthTest = true)
- void AddBoundingBox(const BoundingBox& box, const Color& color, bool depthTest = true)
- void AddBoundingBox(const BoundingBox& box, const Matrix3x4& transform, const Color& color, bool depthTest = true)
- void AddFrustum(const Frustum& frustum, const Color& color, bool depthTest = true)
- void AddPolyhedron(const Polyhedron& poly, const Color& color, bool depthTest = true)
- void AddSphere(const Sphere& sphere, const Color& color, bool depthTest = true)
- void AddSkeleton(const Skeleton& skeleton, const Color& color, bool depthTest = true)
- void AddTriangleMesh(const void* vertexData, unsigned vertexSize, const void* indexData, unsigned indexSize, unsigned indexStart, unsigned indexCount, const Matrix3x4& transform, const Color& color, bool depthTest = true)
- void Render()
- const Matrix3x4& GetView() const
- const Matrix4& GetProjection() const
- const Frustum& GetFrustum() const
- bool IsInside(const BoundingBox& box) const

Properties:

- Matrix3x4& view (readonly)
- Matrix4& projection (readonly)
- Frustum& frustum (readonly)

<a name="Class_DecalSet"></a>
### DecalSet : Drawable

Methods:

- void SetMaterial(Material* material)
- void SetMaxVertices(unsigned num)
- void SetMaxIndices(unsigned num)
- bool AddDecal(Drawable* target, const Vector3& worldPosition, const Quaternion& worldRotation, float size, float aspectRatio, float depth, const Vector2& topLeftUV, const Vector2& bottomRightUV, float timeToLive = 0.0f, float normalCutoff = 0.1f, unsigned subGeometry = M_MAX_UNSIGNED)
- void RemoveDecals(unsigned num)
- void RemoveAllDecals()
- Material* GetMaterial() const
- unsigned GetNumDecals() const
- unsigned GetNumVertices() const
- unsigned GetNumIndices() const
- unsigned GetMaxVertices() const
- unsigned GetMaxIndices() const

Properties:

- Material* material
- unsigned numDecals (readonly)
- unsigned numVertices (readonly)
- unsigned numIndices (readonly)
- unsigned maxVertices
- unsigned maxIndices

<a name="Class_Deserializer"></a>
### Deserializer


Methods:

- VectorBuffer Read(unsigned size)
- unsigned Seek(unsigned position)
- const String GetName() const
- unsigned GetChecksum()
- unsigned GetPosition() const
- unsigned GetSize() const
- bool IsEof() const
- int ReadInt()
- short ReadShort()
- char ReadByte()
- unsigned ReadUInt()
- short ReadUShort()
- char ReadUByte()
- bool ReadBool()
- float ReadFloat()
- IntRect ReadIntRect()
- IntVector2 ReadIntVector2()
- Rect ReadRect()
- Vector2 ReadVector2()
- Vector3 ReadVector3()
- Vector3 ReadPackedVector3(float maxAbsCoord)
- Vector4 ReadVector4()
- Quaternion ReadQuaternion()
- Quaternion ReadPackedQuaternion()
- Matrix3 ReadMatrix3()
- Matrix3x4 ReadMatrix3x4()
- Matrix4 ReadMatrix4()
- Color ReadColor()
- BoundingBox ReadBoundingBox()
- String ReadString()
- String ReadFileID()
- StringHash ReadStringHash()
- VectorBuffer ReadBuffer()
- ResourceRef ReadResourceRef()
- ResourceRefList ReadResourceRefList()
- Variant ReadVariant()
- Variant ReadVariant(VariantType type)
- VariantVector ReadVariantVector()
- VariantMap ReadVariantMap()
- unsigned ReadVLE()
- unsigned ReadNetID()
- String ReadLine()

Properties:

- String name (readonly)
- unsigned checksum (readonly)
- unsigned position (readonly)
- unsigned size (readonly)
- bool eof (readonly)

<a name="Class_Drawable"></a>
### Drawable : Component

Methods:

- void SetDrawDistance(float distance)
- void SetShadowDistance(float distance)
- void SetLodBias(float bias)
- void SetViewMask(unsigned mask)
- void SetLightMask(unsigned mask)
- void SetShadowMask(unsigned mask)
- void SetZoneMask(unsigned mask)
- void SetMaxLights(unsigned num)
- void SetCastShadows(bool enable)
- void SetOccluder(bool enable)
- void SetOccludee(bool enable)
- void MarkForUpdate()
- const BoundingBox& GetBoundingBox() const
- const BoundingBox& GetWorldBoundingBox()
- char GetDrawableFlags() const
- float GetDrawDistance() const
- float GetShadowDistance() const
- float GetLodBias() const
- unsigned GetViewMask() const
- unsigned GetLightMask() const
- unsigned GetShadowMask() const
- unsigned GetZoneMask() const
- unsigned GetMaxLights() const
- bool GetCastShadows() const
- bool IsOccluder() const
- bool IsOccludee() const
- bool IsInView() const
- bool IsInView(Camera* tolua_var_2) const
- Zone* GetZone() const

Properties:

- BoundingBox& worldBoundingBox (readonly)
- char drawableFlags (readonly)
- float drawDistance
- float shadowDistance
- float lodBias
- unsigned viewMask
- unsigned lightMask
- unsigned shadowMask
- unsigned zoneMask
- unsigned maxLights
- bool castShadows
- bool occluder
- bool occludee
- bool inView (readonly)
- Zone* zone (readonly)

<a name="Class_Drawable2D"></a>
### Drawable2D : Drawable

Methods:

- void SetLayer(int layer)
- void SetOrderInLayer(int orderInLayer)
- void SetSprite(Sprite2D* sprite)
- void SetBlendMode(BlendMode mode)
- void SetMaterial(Material* material)
- int GetLayer() const
- int GetOrderInLayer() const
- Sprite2D* GetSprite() const
- Texture2D* GetTexture() const
- BlendMode GetBlendMode() const
- Material* GetMaterial() const

Properties:

- int layer
- int orderInLayer
- Sprite2D* sprite
- Texture2D* texture (readonly)
- BlendMode blendMode
- Material* material

<a name="Class_DropDownList"></a>
### DropDownList : Menu

Methods:

- DropDownList() (GC)
- DropDownList* new()
- void delete()
- void AddItem(UIElement* item)
- void InsertItem(unsigned index, UIElement* item)
- void RemoveItem(UIElement* item)
- void RemoveItem(unsigned index)
- void RemoveAllItems()
- void SetSelection(unsigned index)
- void SetPlaceholderText(const String text)
- void SetResizePopup(bool enable)
- unsigned GetNumItems() const
- UIElement* GetItem(unsigned index) const
- const PODVector<UIElement*>& GetItems() const
- unsigned GetSelection() const
- UIElement* GetSelectedItem() const
- ListView* GetListView() const
- UIElement* GetPlaceholder() const
- const String GetPlaceholderText() const
- bool GetResizePopup() const

Properties:

- unsigned numItems (readonly)
- unsigned selection
- UIElement* selectedItem (readonly)
- ListView* listView (readonly)
- UIElement* placeholder (readonly)
- String placeholderText
- bool resizePopup

<a name="Class_Engine"></a>
### Engine : Object

Methods:

- void RunFrame()
- Console* CreateConsole()
- DebugHud* CreateDebugHud()
- void SetMinFps(int fps)
- void SetMaxFps(int fps)
- void SetMaxInactiveFps(int fps)
- void SetTimeStepSmoothing(int frames)
- void SetPauseMinimized(bool enable)
- void SetAutoExit(bool enable)
- void Exit()
- void DumpProfiler()
- void DumpResources(bool dumpFileName = false)
- void DumpMemory()
- int GetMinFps() const
- int GetMaxFps() const
- int GetMaxInactiveFps() const
- int GetTimeStepSmoothing() const
- bool GetPauseMinimized() const
- bool GetAutoExit() const
- bool IsInitialized() const
- bool IsExiting() const
- bool IsHeadless() const

Properties:

- int minFps
- int maxFps
- int maxInactiveFps
- int timeStepSmoothing
- bool pauseMinimized
- bool autoExit
- bool initialized (readonly)
- bool exiting (readonly)
- bool headless (readonly)

<a name="Class_File"></a>
### File : Object

Methods:

- File() (GC)
- File* new()
- File(const String fileName, FileMode mode = FILE_READ) (GC)
- File* new(const String fileName, FileMode mode = FILE_READ)
- File(PackageFile* package, const String fileName) (GC)
- File* new(PackageFile* package, const String fileName)
- void delete()
- bool Open(const String fileName, FileMode mode = FILE_READ)
- bool Open(PackageFile* package, const String fileName)
- void Close()
- void Flush()
- void SetName(const String name)
- FileMode GetMode() const
- bool IsOpen() const
- void* GetHandle() const
- bool IsPackaged() const
- VectorBuffer Read(unsigned size)
- unsigned Seek(unsigned position)
- const String GetName() const
- unsigned GetChecksum()
- unsigned GetPosition() const
- unsigned GetSize() const
- bool IsEof() const
- int ReadInt()
- short ReadShort()
- char ReadByte()
- unsigned ReadUInt()
- short ReadUShort()
- char ReadUByte()
- bool ReadBool()
- float ReadFloat()
- IntRect ReadIntRect()
- IntVector2 ReadIntVector2()
- Rect ReadRect()
- Vector2 ReadVector2()
- Vector3 ReadVector3()
- Vector3 ReadPackedVector3(float maxAbsCoord)
- Vector4 ReadVector4()
- Quaternion ReadQuaternion()
- Quaternion ReadPackedQuaternion()
- Matrix3 ReadMatrix3()
- Matrix3x4 ReadMatrix3x4()
- Matrix4 ReadMatrix4()
- Color ReadColor()
- BoundingBox ReadBoundingBox()
- String ReadString()
- String ReadFileID()
- StringHash ReadStringHash()
- VectorBuffer ReadBuffer()
- ResourceRef ReadResourceRef()
- ResourceRefList ReadResourceRefList()
- Variant ReadVariant()
- Variant ReadVariant(VariantType type)
- VariantVector ReadVariantVector()
- VariantMap ReadVariantMap()
- unsigned ReadVLE()
- unsigned ReadNetID()
- String ReadLine()
- unsigned Write(const VectorBuffer& buffer)
- bool WriteInt(int value)
- bool WriteShort(short value)
- bool WriteByte(char value)
- bool WriteUInt(unsigned value)
- bool WriteUShort(short value)
- bool WriteUByte(char value)
- bool WriteBool(bool value)
- bool WriteFloat(float value)
- bool WriteIntRect(const IntRect& value)
- bool WriteIntVector2(const IntVector2& value)
- bool WriteRect(const Rect& value)
- bool WriteVector2(const Vector2& value)
- bool WriteVector3(const Vector3& value)
- bool WritePackedVector3(const Vector3& value, float maxAbsCoord)
- bool WriteVector4(const Vector4& value)
- bool WriteQuaternion(const Quaternion& value)
- bool WritePackedQuaternion(const Quaternion& value)
- bool WriteMatrix3(const Matrix3& value)
- bool WriteMatrix3x4(const Matrix3x4& value)
- bool WriteMatrix4(const Matrix4& value)
- bool WriteColor(const Color& value)
- bool WriteBoundingBox(const BoundingBox& value)
- bool WriteString(const String value)
- bool WriteFileID(const String value)
- bool WriteStringHash(const StringHash& value)
- bool WriteBuffer(const VectorBuffer& buffer)
- bool WriteResourceRef(const ResourceRef& value)
- bool WriteResourceRefList(const ResourceRefList& value)
- bool WriteVariant(const Variant& value)
- bool WriteVariantData(const Variant& value)
- bool WriteVariantVector(const VariantVector& value)
- bool WriteVariantMap(const VariantMap& value)
- bool WriteVLE(unsigned value)
- bool WriteNetID(unsigned value)
- bool WriteLine(const String value)

Properties:

- FileMode mode (readonly)
- bool open (readonly)
- bool packaged (readonly)
- String name (readonly)
- unsigned checksum (readonly)
- unsigned position (readonly)
- unsigned size (readonly)
- bool eof (readonly)

<a name="Class_FileSelector"></a>
### FileSelector : Object

Methods:

- FileSelector() (GC)
- FileSelector* new()
- void delete()
- void SetDefaultStyle(XMLFile* style)
- void SetTitle(const String text)
- void SetButtonTexts(const String okText, const String cancelText)
- void SetPath(const String path)
- void SetFileName(const String fileName)
- void SetFilters(const Vector<String>& filters, unsigned defaultIndex)
- void SetDirectoryMode(bool enable)
- void UpdateElements()
- XMLFile* GetDefaultStyle() const
- Window* GetWindow() const
- Text* GetTitleText() const
- ListView* GetFileList() const
- LineEdit* GetPathEdit() const
- LineEdit* GetFileNameEdit() const
- DropDownList* GetFilterList() const
- Button* GetOKButton() const
- Button* GetCancelButton() const
- Button* GetCloseButton() const
- const String GetTitle() const
- const String GetPath() const
- const String GetFileName() const
- const String GetFilter() const
- unsigned GetFilterIndex() const
- bool GetDirectoryMode() const

Properties:

- XMLFile* defaultStyle
- Window* window (readonly)
- Text* titleText (readonly)
- ListView* fileList (readonly)
- LineEdit* pathEdit (readonly)
- LineEdit* fileNameEdit (readonly)
- DropDownList* filterList (readonly)
- Button* OKButton (readonly)
- Button* cancelButton (readonly)
- Button* closeButton (readonly)
- String title
- String path
- String fileName
- String filter (readonly)
- unsigned filterIndex (readonly)
- bool directoryMode

<a name="Class_FileSelectorEntry"></a>
### FileSelectorEntry


Properties:

- String name
- bool directory

<a name="Class_FileSystem"></a>
### FileSystem : Object

Methods:

- bool SetCurrentDir(const String pathName)
- bool CreateDir(const String pathName)
- void SetExecuteConsoleCommands(bool enable)
- int SystemCommand(const String commandLine, bool redirectStdOutToLog = false)
- int SystemRun(const String fileName, const Vector<String>& arguments)
- unsigned SystemCommandAsync(const String commandLine)
- unsigned SystemRunAsync(const String fileName, const Vector<String>& arguments)
- bool SystemOpen(const String fileName, const String mode = String::EMPTY)
- bool Copy(const String srcFileName, const String destFileName)
- bool Rename(const String srcFileName, const String destFileName)
- bool Delete(const String fileName)
- bool SetLastModifiedTime(const String fileName, unsigned newTime)
- String GetCurrentDir() const
- bool GetExecuteConsoleCommands() const
- bool HasRegisteredPaths() const
- bool CheckAccess(const String pathName) const
- unsigned GetLastModifiedTime(const String fileName) const
- bool FileExists(const String fileName) const
- bool DirExists(const String pathName) const
- const Vector<String>& ScanDir(const String pathName, const String filter, unsigned flags, bool recursive) const
- String GetProgramDir() const
- String GetUserDocumentsDir() const
- String GetAppPreferencesDir(const String org, const String app) const

<a name="Class_FocusParameters"></a>
### FocusParameters


Methods:

- FocusParameters() (GC)
- FocusParameters* new()
- FocusParameters(bool focus, bool nonUniform, bool autoSize, float quantize, float minView) (GC)
- FocusParameters* new(bool focus, bool nonUniform, bool autoSize, float quantize, float minView)
- void delete()

<a name="Class_Font"></a>
### Font : Resource

Methods:

- void SetAbsoluteGlyphOffset(const IntVector2& offset)
- void SetScaledGlyphOffset(const Vector2& offset)
- const IntVector2& GetAbsoluteGlyphOffset() const
- const Vector2& GetScaledGlyphOffset() const
- IntVector2 GetTotalGlyphOffset(int pointSize) const
- bool IsSDFFont() const

Properties:

- IntVector2 absoluteGlyphOffset
- Vector2 scaledGlyphOffset

<a name="Class_Frustum"></a>
### Frustum


Methods:

- Frustum() (GC)
- Frustum* new()
- Frustum(const Frustum& frustum) (GC)
- Frustum* new(const Frustum& frustum)
- void delete()
- void Define(float fov, float aspectRatio, float zoom, float nearZ, float farZ)
- void Define(float fov, float aspectRatio, float zoom, float nearZ, float farZ, const Matrix3x4& transform)
- void Define(const Vector3& near, const Vector3& far)
- void Define(const Vector3& near, const Vector3& far, const Matrix3x4& transform)
- void Define(const BoundingBox& box)
- void Define(const BoundingBox& box, const Matrix3x4& transform)
- void DefineOrtho(float orthoSize, float aspectRatio, float zoom, float nearZ, float farZ)
- void DefineOrtho(float orthoSize, float aspectRatio, float zoom, float nearZ, float farZ, const Matrix3x4& transform)
- void Transform(const Matrix3& transform)
- void Transform(const Matrix3x4& transform)
- Intersection IsInside(const Vector3& point) const
- Intersection IsInside(const Sphere& sphere) const
- Intersection IsInsideFast(const Sphere& sphere) const
- Intersection IsInside(const BoundingBox& box) const
- Intersection IsInsideFast(const BoundingBox& box) const
- float Distance(const Vector3& point) const
- Frustum Transformed(const Matrix3& transform) const
- Frustum Transformed(const Matrix3x4& transform) const
- Rect Projected(const Matrix4& transform) const
- void UpdatePlanes()

<a name="Class_Graphics"></a>
### Graphics : Object

Methods:

- void SetWindowTitle(const String windowTitle)
- void SetWindowIcon(Image* windowIcon)
- void SetWindowPosition(const IntVector2& position)
- void SetWindowPosition(int x, int y)
- bool SetMode(int width, int height, bool fullscreen, bool borderless, bool resizable, bool vsync, bool tripleBuffer, int multiSample)
- bool SetMode(int width, int height)
- void SetSRGB(bool enable)
- void SetFlushGPU(bool enable)
- void SetOrientations(const String orientations)
- bool ToggleFullscreen()
- void Maximize()
- void Minimize()
- void Close()
- bool TakeScreenShot(Image& destImage)
- void BeginDumpShaders(const String fileName)
- void EndDumpShaders()
- void PrecacheShaders(Deserializer& source)
- void PrecacheShaders(const String fileName)
- bool IsInitialized() const
- void* GetExternalWindow() const
- const String GetWindowTitle() const
- IntVector2 GetWindowPosition() const
- int GetWidth() const
- int GetHeight() const
- int GetMultiSample() const
- bool GetFullscreen() const
- bool GetResizable() const
- bool GetBorderless() const
- bool GetVSync() const
- bool GetTripleBuffer() const
- bool GetSRGB() const
- bool GetFlushGPU() const
- const String GetOrientations() const
- bool IsDeviceLost() const
- unsigned GetNumPrimitives() const
- unsigned GetNumBatches() const
- unsigned GetDummyColorFormat() const
- unsigned GetShadowMapFormat() const
- unsigned GetHiresShadowMapFormat() const
- bool GetSM3Support() const
- bool GetInstancingSupport() const
- bool GetLightPrepassSupport() const
- bool GetDeferredSupport() const
- bool GetHardwareShadowSupport() const
- bool GetStreamOffsetSupport() const
- bool GetSRGBSupport() const
- bool GetSRGBWriteSupport() const
- IntVector2 GetDesktopResolution() const
- unsigned GetRGBFormat()

Properties:

- bool initialized (readonly)
- String windowTitle
- IntVector2 windowPosition
- int width (readonly)
- int height (readonly)
- int multiSample (readonly)
- bool fullscreen (readonly)
- bool resizable (readonly)
- bool borderless (readonly)
- bool vSync (readonly)
- bool tripleBuffer (readonly)
- bool sRGB
- bool flushGPU
- String orientations
- bool deviceLost (readonly)
- unsigned numPrimitives (readonly)
- unsigned numBatches (readonly)
- unsigned dummyColorFormat (readonly)
- unsigned shadowMapFormat (readonly)
- unsigned hiresShadowMapFormat (readonly)
- bool SM3Support (readonly)
- bool instancingSupport (readonly)
- bool lightPrepassSupport (readonly)
- bool deferredSupport (readonly)
- bool hardwareShadowSupport (readonly)
- bool streamOffsetSupport (readonly)
- bool sRGBSupport (readonly)
- bool sRGBWriteSupport (readonly)
- IntVector2 desktopResolution (readonly)

<a name="Class_HttpRequest"></a>
### HttpRequest : Deserializer

Methods:

- const String GetURL() const
- const String GetVerb() const
- String GetError() const
- HttpRequestState GetState() const
- unsigned GetAvailableSize() const
- bool IsOpen() const

Properties:

- String URL (readonly)
- String verb (readonly)
- String error (readonly)
- HttpRequestState state (readonly)
- unsigned availableSize (readonly)
- bool open (readonly)

<a name="Class_Image"></a>
### Image : Resource

Methods:

- Image() (GC)
- Image* new()
- void delete()
- bool SetSize(int width, int height, unsigned components)
- bool SetSize(int width, int height, int depth, unsigned components)
- void SetPixel(int x, int y, const Color& color)
- void SetPixel(int x, int y, int z, const Color& color)
- void SetPixelInt(int x, int y, unsigned uintColor)
- void SetPixelInt(int x, int y, int z, unsigned uintColor)
- bool LoadColorLUT(Deserializer& source)
- bool LoadColorLUT(const String fileName)
- bool FlipHorizontal()
- bool FlipVertical()
- bool Resize(int width, int height)
- void Clear(const Color& color)
- void ClearInt(unsigned uintColor)
- bool SaveBMP(const String fileName) const
- bool SavePNG(const String fileName) const
- bool SaveTGA(const String fileName) const
- bool SaveJPG(const String fileName, int quality) const
- Color GetPixel(int x, int y) const
- Color GetPixel(int x, int y, int z) const
- unsigned GetPixelInt(int x, int y) const
- unsigned GetPixelInt(int x, int y, int z) const
- Color GetPixelBilinear(float x, float y) const
- Color GetPixelTrilinear(float x, float y, float z) const
- int GetWidth() const
- int GetHeight() const
- int GetDepth() const
- unsigned GetComponents() const
- bool IsCompressed() const
- CompressedFormat GetCompressedFormat() const
- unsigned GetNumCompressedLevels() const
- CompressedLevel GetCompressedLevel(unsigned index) const
- Image* GetSubimage(const IntRect& rect) const

Properties:

- int width (readonly)
- int height (readonly)
- int depth (readonly)
- unsigned components (readonly)
- bool compressed (readonly)
- CompressedFormat compressedFormat (readonly)
- unsigned numCompressedLevels (readonly)

<a name="Class_Input"></a>
### Input : Object

Methods:

- void SetToggleFullscreen(bool enable)
- void SetMouseVisible(bool enable, bool suppressEvent = false)
- void SetMouseGrabbed(bool grab)
- void SetMouseMode(MouseMode mode)
- int AddScreenJoystick(XMLFile* layoutFile = 0, XMLFile* styleFile = 0)
- bool RemoveScreenJoystick(int id)
- void SetScreenJoystickVisible(int id, bool enable)
- void SetScreenKeyboardVisible(bool enable)
- void SetTouchEmulation(bool enable)
- bool RecordGesture()
- bool SaveGestures(File* dest)
- bool SaveGesture(File* dest, unsigned gestureID)
- unsigned LoadGestures(File* source)
- bool SaveGestures(const String fileName)
- bool SaveGesture(const String fileName, unsigned gestureID)
- unsigned LoadGestures(const String fileName)
- bool RemoveGesture(unsigned gestureID)
- void RemoveAllGestures()
- int GetKeyFromName(const String name) const
- int GetKeyFromScancode(int scancode) const
- String GetKeyName(int key) const
- int GetScancodeFromKey(int key) const
- int GetScancodeFromName(const String name) const
- String GetScancodeName(int scancode) const
- bool GetKeyDown(int key) const
- bool GetKeyPress(int key) const
- bool GetScancodeDown(int scancode) const
- bool GetScancodePress(int scancode) const
- bool GetMouseButtonDown(int button) const
- bool GetMouseButtonPress(int button) const
- bool GetQualifierDown(int qualifier) const
- bool GetQualifierPress(int qualifier) const
- int GetQualifiers() const
- IntVector2 GetMousePosition() const
- const IntVector2& GetMouseMove() const
- int GetMouseMoveX() const
- int GetMouseMoveY() const
- int GetMouseMoveWheel() const
- unsigned GetNumTouches() const
- TouchState* GetTouch(unsigned index) const
- unsigned GetNumJoysticks() const
- JoystickState* GetJoystick(int id)
- JoystickState* GetJoystickByIndex(unsigned index)
- bool GetToggleFullscreen() const
- bool GetScreenKeyboardSupport() const
- bool IsScreenJoystickVisible(int id) const
- bool IsScreenKeyboardVisible() const
- bool GetTouchEmulation() const
- bool IsMouseVisible() const
- bool IsMouseGrabbed() const
- MouseMode GetMouseMode() const
- bool HasFocus()
- bool IsMinimized() const

Properties:

- int qualifiers (readonly)
- IntVector2 mousePosition (readonly)
- IntVector2& mouseMove (readonly)
- int mouseMoveX (readonly)
- int mouseMoveY (readonly)
- int mouseMoveWheel (readonly)
- unsigned numTouches (readonly)
- unsigned numJoysticks (readonly)
- bool toggleFullscreen (readonly)
- bool screenKeyboardSupport (readonly)
- MouseMode mouseMode
- bool screenKeyboardVisible
- bool touchEmulation
- bool mouseVisible
- bool mouseGrabbed
- bool focus (readonly)
- bool minimized (readonly)

<a name="Class_IntRect"></a>
### IntRect


Methods:

- IntRect() (GC)
- IntRect* new()
- IntRect(int left, int top, int right, int bottom) (GC)
- IntRect* new(int left, int top, int right, int bottom)
- void delete()
- bool operator==(const IntRect& rhs) const
- IntVector2 Size() const
- int Width() const
- int Height() const
- Intersection IsInside(const IntVector2& point) const

Properties:

- int left
- int top
- int right
- int bottom
- const IntRect ZERO
- IntVector2 size (readonly)
- int width (readonly)
- int height (readonly)

<a name="Class_IntVector2"></a>
### IntVector2


Methods:

- IntVector2() (GC)
- IntVector2* new()
- IntVector2(int x, int y) (GC)
- IntVector2* new(int x, int y)
- IntVector2(const IntVector2& rhs) (GC)
- IntVector2* new(const IntVector2& rhs)
- void delete()
- bool operator==(const IntVector2& rhs) const
- IntVector2 operator+(const IntVector2& rhs) const
- IntVector2 operator-() const
- IntVector2 operator-(const IntVector2& rhs) const
- IntVector2 operator*(int rhs) const
- IntVector2 operator/(int rhs) const
- IntVector2 operator/(int rhs) const
- String ToString() const

Properties:

- int x
- int y
- const IntVector2 ZERO

<a name="Class_JSONFile"></a>
### JSONFile : Resource

Methods:

- JSONFile() (GC)
- JSONFile* new()
- void delete()
- JSONValue CreateRoot(JSONValueType valueType = JSON_OBJECT)
- JSONValue GetRoot(JSONValueType valueType = JSON_ANY)

<a name="Class_JSONValue"></a>
### JSONValue


Methods:

- bool IsNull() const
- bool NotNull() const
- bool operatorbool() const
- JSONValue CreateChild(const String name, JSONValueType valueType = JSON_OBJECT)
- JSONValue GetChild(const String name, JSONValueType valueType = JSON_ANY) const
- void SetInt(const String name, int value)
- void SetBool(const String name, bool value)
- void SetFloat(const String name, float value)
- void SetVector2(const String name, const Vector2& value)
- void SetVector3(const String name, const Vector3& value)
- void SetVector4(const String name, const Vector4& value)
- void SetVectorVariant(const String name, const Variant& value)
- void SetQuaternion(const String name, const Quaternion& value)
- void SetColor(const String name, const Color& value)
- void SetString(const String name, const String value)
- void SetResourceRef(const String name, const ResourceRef& value)
- void SetResourceRefList(const String name, const ResourceRefList& value)
- void SetIntRect(const String name, const IntRect& value)
- void SetIntVector2(const String name, const IntVector2& value)
- void SetMatrix3(const String name, const Matrix3& value)
- void SetMatrix3x4(const String name, const Matrix3x4& value)
- void SetMatrix4(const String name, const Matrix4& value)
- void SetVariant(const String name, const Variant& value)
- void SetVariantValue(const String name, const Variant& value)
- bool IsObject() const
- Vector<String> GetChildNames() const
- Vector<String> GetValueNames() const
- int GetInt(const String name) const
- bool GetBool(const String name) const
- float GetFloat(const String name) const
- Vector2 GetVector2(const String name) const
- Vector3 GetVector3(const String name) const
- Vector4 GetVector4(const String name) const
- Variant GetVectorVariant(const String name) const
- Quaternion GetQuaternion(const String name) const
- Color GetColor(const String name) const
- String GetString(const String name) const
- const char* GetCString(const String name) const
- ResourceRef GetResourceRef(const String name) const
- ResourceRefList GetResourceRefList(const String name) const
- IntRect GetIntRect(const String name) const
- IntVector2 GetIntVector2(const String name) const
- Matrix3 GetMatrix3(const String name) const
- Matrix3x4 GetMatrix3x4(const String name) const
- Matrix4 GetMatrix4(const String name) const
- Variant GetVariant(const String name) const
- Variant GetVariantValue(const String name, VariantType type) const
- JSONValue CreateChild(JSONValueType valueType = JSON_OBJECT)
- JSONValue GetChild(unsigned index, JSONValueType valueType = JSON_ANY) const
- void AddInt(int value)
- void AddBool(bool value)
- void AddFloat(float value)
- void AddVector2(const Vector2& value)
- void AddVector3(const Vector3& value)
- void AddVector4(const Vector4& value)
- void AddVectorVariant(const Variant& value)
- void AddQuaternion(const Quaternion& value)
- void AddColor(const Color& value)
- void AddString(const String value)
- void AddResourceRef(const ResourceRef& value)
- void AddResourceRefList(const ResourceRefList& value)
- void AddIntRect(const IntRect& value)
- void AddIntVector2(const IntVector2& value)
- void AddMatrix3(const Matrix3& value)
- void AddMatrix3x4(const Matrix3x4& value)
- void AddMatrix4(const Matrix4& value)
- void AddVariant(const Variant& value)
- void AddVariantValue(const Variant& value)
- bool IsArray() const
- unsigned GetSize() const
- int GetInt(unsigned index) const
- bool GetBool(unsigned index) const
- float GetFloat(unsigned index) const
- Vector2 GetVector2(unsigned index) const
- Vector3 GetVector3(unsigned index) const
- Vector4 GetVector4(unsigned index) const
- Variant GetVectorVariant(unsigned index) const
- Quaternion GetQuaternion(unsigned index) const
- Color GetColor(unsigned index) const
- String GetString(unsigned index) const
- const char* GetCString(unsigned index) const
- ResourceRef GetResourceRef(unsigned index) const
- ResourceRefList GetResourceRefList(unsigned index) const
- IntRect GetIntRect(unsigned index) const
- IntVector2 GetIntVector2(unsigned index) const
- Matrix3 GetMatrix3(unsigned index) const
- Matrix3x4 GetMatrix3x4(unsigned index) const
- Matrix4 GetMatrix4(unsigned index) const
- Variant GetVariant(unsigned index) const
- Variant GetVariantValue(unsigned index, VariantType type) const

Properties:

- const JSONValue EMPTY
- bool null (readonly)
- bool object (readonly)
- bool array (readonly)

<a name="Class_JoystickState"></a>
### JoystickState


Methods:

- bool IsController() const
- unsigned GetNumButtons() const
- unsigned GetNumAxes() const
- unsigned GetNumHats() const
- bool GetButtonDown(unsigned index) const
- bool GetButtonPress(unsigned index) const
- float GetAxisPosition(unsigned index) const
- int GetHatPosition(unsigned index) const

Properties:

- const String name
- const int joystickID
- bool controller (readonly)
- unsigned numButtons (readonly)
- unsigned numAxes (readonly)
- unsigned numHats (readonly)

<a name="Class_Light"></a>
### Light : Drawable

Methods:

- void SetLightType(LightType type)
- void SetPerVertex(bool enable)
- void SetColor(const Color& color)
- void SetSpecularIntensity(float intensity)
- void SetBrightness(float brightness)
- void SetRange(float range)
- void SetFov(float fov)
- void SetAspectRatio(float aspectRatio)
- void SetFadeDistance(float distance)
- void SetShadowFadeDistance(float distance)
- void SetShadowBias(const BiasParameters& parameters)
- void SetShadowCascade(const CascadeParameters& parameters)
- void SetShadowFocus(const FocusParameters& parameters)
- void SetShadowIntensity(float intensity)
- void SetShadowResolution(float resolution)
- void SetShadowNearFarRatio(float nearFarRatio)
- void SetRampTexture(Texture* texture)
- void SetShapeTexture(Texture* texture)
- LightType GetLightType() const
- bool GetPerVertex() const
- const Color& GetColor() const
- float GetSpecularIntensity() const
- float GetBrightness() const
- Color GetEffectiveColor() const
- float GetEffectiveSpecularIntensity() const
- float GetRange() const
- float GetFov() const
- float GetAspectRatio() const
- float GetFadeDistance() const
- float GetShadowFadeDistance() const
- const BiasParameters& GetShadowBias() const
- const CascadeParameters& GetShadowCascade() const
- const FocusParameters& GetShadowFocus() const
- float GetShadowIntensity() const
- float GetShadowResolution() const
- float GetShadowNearFarRatio() const
- Texture* GetRampTexture() const
- Texture* GetShapeTexture() const
- Frustum GetFrustum() const
- int GetNumShadowSplits() const
- bool IsNegative() const

Properties:

- LightType lightType
- bool perVertex
- Color& color
- float specularIntensity
- float brightness
- float range
- float fov
- float aspectRatio
- float fadeDistance
- float shadowFadeDistance
- BiasParameters& shadowBias
- CascadeParameters& shadowCascade
- FocusParameters& shadowFocus
- float shadowIntensity
- float shadowResolution
- float shadowNearFarRatio
- Texture* rampTexture
- Texture* shapeTexture
- Frustum frustum (readonly)
- int numShadowSplits (readonly)
- bool negative (readonly)
- Color effectiveColor (readonly)
- float effectiveSpecularIntensity (readonly)

<a name="Class_LineEdit"></a>
### LineEdit : BorderImage

Methods:

- LineEdit() (GC)
- LineEdit* new()
- void delete()
- void SetText(const String text)
- void SetCursorPosition(unsigned position)
- void SetCursorBlinkRate(float rate)
- void SetMaxLength(unsigned length)
- void SetEchoCharacter(unsigned c)
- void SetCursorMovable(bool enable)
- void SetTextSelectable(bool enable)
- void SetTextCopyable(bool enable)
- const String GetText() const
- unsigned GetCursorPosition() const
- float GetCursorBlinkRate() const
- unsigned GetMaxLength() const
- unsigned GetEchoCharacter() const
- bool IsCursorMovable() const
- bool IsTextSelectable() const
- bool IsTextCopyable() const
- Text* GetTextElement() const
- BorderImage* GetCursor() const

Properties:

- String text
- unsigned cursorPosition
- float cursorBlinkRate
- unsigned maxLength
- unsigned echoCharacter
- bool cursorMovable
- bool textSelectable
- bool textCopyable
- Text* textElement (readonly)
- BorderImage* cursor (readonly)

<a name="Class_ListView"></a>
### ListView : ScrollView

Methods:

- ListView() (GC)
- ListView* new()
- void delete()
- void AddItem(UIElement* item)
- void InsertItem(unsigned index, UIElement* item, UIElement* parentItem = 0)
- void RemoveItem(UIElement* item, unsigned index = 0)
- void RemoveItem(unsigned index)
- void RemoveAllItems()
- void SetSelection(unsigned index)
- void SetSelections(const PODVector<unsigned>& indices)
- void AddSelection(unsigned index)
- void RemoveSelection(unsigned index)
- void ToggleSelection(unsigned index)
- void ChangeSelection(int delta, bool additive = false)
- void ClearSelection()
- void SetHighlightMode(HighlightMode mode)
- void SetMultiselect(bool enable)
- void SetHierarchyMode(bool enable)
- void SetBaseIndent(int baseIndent)
- void SetClearSelectionOnDefocus(bool enable)
- void SetSelectOnClickEnd(bool enable)
- void Expand(unsigned index, bool enable, bool recursive = false)
- void ToggleExpand(unsigned index, bool recursive = false)
- unsigned GetNumItems() const
- UIElement* GetItem(unsigned index) const
- const PODVector<UIElement*>& GetItems() const
- unsigned FindItem(UIElement* item) const
- unsigned GetSelection() const
- const PODVector<unsigned>& GetSelections() const
- void CopySelectedItemsToClipboard() const
- UIElement* GetSelectedItem() const
- const PODVector<UIElement*>& GetSelectedItems() const
- bool IsSelected(unsigned index) const
- bool IsExpanded(unsigned index) const
- HighlightMode GetHighlightMode() const
- bool GetMultiselect() const
- bool GetClearSelectionOnDefocus() const
- bool GetSelectOnClickEnd() const
- bool GetHierarchyMode() const
- int GetBaseIndent() const

Properties:

- unsigned numItems (readonly)
- unsigned selection
- UIElement* selectedItem (readonly)
- HighlightMode highlightMode
- bool multiselect
- bool clearSelectionOnDefocus
- bool selectOnClickEnd
- bool hierarchyMode
- int baseIndent

<a name="Class_Log"></a>
### Log : Object

Methods:

- void Open(const String fileName)
- void Close()
- void SetLevel(int level)
- void SetTimeStamp(bool enable)
- void SetQuiet(bool quiet)
- int GetLevel() const
- bool GetTimeStamp() const
- String GetLastMessage() const
- bool IsQuiet() const
- void Write(int level, const String message)
- void WriteRaw(const String message, bool error = false)

Properties:

- int level
- bool timeStamp
- bool quiet

<a name="Class_LuaScriptInstance"></a>
### LuaScriptInstance : Component

Methods:

- bool CreateObject(const String scriptObjectType)
- bool CreateObject(LuaFile* scriptFile, const String scriptObjectType)
- void SetScriptFile(LuaFile* scriptFile)
- void SetScriptObjectType(const String scriptObjectType)
- void SubscribeToEvent(const String eventName, void* functionOrFunctionName)
- void UnsubscribeFromEvent(const String eventName)
- void UnsubscribeFromAllEvents()
- void SubscribeToEvent(void* sender, const String eventName, void* functionOrFunctionName)
- void UnsubscribeFromEvent(void* sender, const String eventName)
- void UnsubscribeFromEvents(void* sender)
- LuaFile* GetScriptFile() const
- const String GetScriptObjectType() const

Properties:

- const LuaFile* scriptFile
- const String scriptObjectType

<a name="Class_Material"></a>
### Material : Resource

Methods:

- Material() (GC)
- Material* new()
- void delete()
- void SetNumTechniques(unsigned num)
- void SetTechnique(unsigned index, Technique* tech, unsigned qualityLevel = 0, float lodDistance = 0.0f)
- void SetShaderParameter(const String name, const Variant& value)
- void SetShaderParameterAnimation(const String name, ValueAnimation* animation, WrapMode wrapMode = WM_LOOP, float speed = 1.0f)
- void SetShaderParameterAnimationWrapMode(const String name, WrapMode wrapMode)
- void SetShaderParameterAnimationSpeed(const String name, float speed)
- void SetTexture(TextureUnit unit, Texture* texture)
- void SetUVTransform(const Vector2& offset, float rotation, const Vector2& repeat)
- void SetUVTransform(const Vector2& offset, float rotation, float repeat)
- void SetCullMode(CullMode mode)
- void SetShadowCullMode(CullMode mode)
- void SetDepthBias(const BiasParameters& parameters)
- void SetScene(Scene* scene)
- void RemoveShaderParameter(const String name)
- void ReleaseShaders()
- Material* Clone(const String cloneName = String::EMPTY) const
- void SortTechniques()
- void MarkForAuxView(unsigned frameNumber)
- unsigned GetNumTechniques() const
- Technique* GetTechnique(unsigned index) const
- Pass* GetPass(unsigned index, StringHash passType) const
- Pass* GetPass(unsigned index, const String passType) const
- Texture* GetTexture(TextureUnit unit) const
- ValueAnimation* GetShaderParameterAnimation(const String name) const
- WrapMode GetShaderParameterAnimationWrapMode(const String name) const
- float GetShaderParameterAnimationSpeed(const String name) const
- CullMode GetCullMode() const
- CullMode GetShadowCullMode() const
- const BiasParameters& GetDepthBias() const
- unsigned GetAuxViewFrameNumber() const
- bool GetOcclusion() const
- bool GetSpecular() const
- Scene* GetScene() const

Properties:

- CullMode cullMode (readonly)
- CullMode shadowCullMode (readonly)
- unsigned auxViewFrameNumber (readonly)
- bool occlusion (readonly)
- bool specular (readonly)
- Scene* scene

<a name="Class_Matrix3"></a>
### Matrix3


Methods:

- Matrix3() (GC)
- Matrix3* new()
- Matrix3(const Matrix3& matrix) (GC)
- Matrix3* new(const Matrix3& matrix)
- Matrix3(float v00, float v01, float v02, float v10, float v11, float v12, float v20, float v21, float v22) (GC)
- Matrix3* new(float v00, float v01, float v02, float v10, float v11, float v12, float v20, float v21, float v22)
- void delete()
- bool operator==(const Matrix3& rhs) const
- Vector3 operator*(const Vector3& rhs) const
- Matrix3 operator+(const Matrix3& rhs) const
- Matrix3 operator-(const Matrix3& rhs) const
- Matrix3 operator*(float rhs) const
- Matrix3 operator*(const Matrix3& rhs) const
- void SetScale(const Vector3& scale)
- void SetScale(float scale)
- Vector3 Scale() const
- Matrix3 Transpose() const
- Matrix3 Scaled(const Vector3& scale) const
- bool Equals(const Matrix3& rhs) const
- Matrix3 Inverse() const
- String ToString() const

Properties:

- float m00
- float m01
- float m02
- float m10
- float m11
- float m12
- float m20
- float m21
- float m22
- const Matrix3 ZERO
- const Matrix3 IDENTITY

<a name="Class_Matrix3x4"></a>
### Matrix3x4


Methods:

- Matrix3x4() (GC)
- Matrix3x4* new()
- Matrix3x4(const Matrix3x4& matrix) (GC)
- Matrix3x4* new(const Matrix3x4& matrix)
- Matrix3x4(const Matrix3& matrix) (GC)
- Matrix3x4* new(const Matrix3& matrix)
- Matrix3x4(const Matrix4& matrix) (GC)
- Matrix3x4* new(const Matrix4& matrix)
- Matrix3x4(float v00, float v01, float v02, float v03, float v10, float v11, float v12, float v13, float v20, float v21, float v22, float v23) (GC)
- Matrix3x4* new(float v00, float v01, float v02, float v03, float v10, float v11, float v12, float v13, float v20, float v21, float v22, float v23)
- Matrix3x4(const Vector3& translation, const Quaternion& rotation, float scale) (GC)
- Matrix3x4* new(const Vector3& translation, const Quaternion& rotation, float scale)
- Matrix3x4(const Vector3& translation, const Quaternion& rotation, const Vector3& scale) (GC)
- Matrix3x4* new(const Vector3& translation, const Quaternion& rotation, const Vector3& scale)
- void delete()
- bool operator==(const Matrix3x4& rhs) const
- Vector3 operator*(const Vector3& rhs) const
- Vector3 operator*(const Vector4& rhs) const
- Matrix3x4 operator+(const Matrix3x4& rhs) const
- Matrix3x4 operator-(const Matrix3x4& rhs) const
- Matrix3x4 operator*(float rhs) const
- Matrix3x4 operator*(const Matrix3x4& rhs) const
- Matrix4 operator*(const Matrix4& rhs) const
- void SetTranslation(const Vector3& translation)
- void SetRotation(const Matrix3& rotation)
- void SetScale(const Vector3& scale)
- void SetScale(float scale)
- Matrix3 ToMatrix3() const
- Matrix4 ToMatrix4() const
- Matrix3 RotationMatrix() const
- Vector3 Translation() const
- Quaternion Rotation() const
- Vector3 Scale() const
- bool Equals(const Matrix3x4& rhs) const
- void Decompose(Vector3& translation, Quaternion& rotation, Vector3& scale) const
- Matrix3x4 Inverse() const
- String ToString() const

Properties:

- float m00
- float m01
- float m02
- float m03
- float m10
- float m11
- float m12
- float m13
- float m20
- float m21
- float m22
- float m23
- const Matrix3x4 ZERO
- const Matrix3x4 IDENTITY

<a name="Class_Matrix4"></a>
### Matrix4


Methods:

- Matrix4() (GC)
- Matrix4* new()
- Matrix4(const Matrix4& matrix) (GC)
- Matrix4* new(const Matrix4& matrix)
- Matrix4(const Matrix3& matrix) (GC)
- Matrix4* new(const Matrix3& matrix)
- Matrix4(float v00, float v01, float v02, float v03, float v10, float v11, float v12, float v13, float v20, float v21, float v22, float v23, float v30, float v31, float v32, float v33) (GC)
- Matrix4* new(float v00, float v01, float v02, float v03, float v10, float v11, float v12, float v13, float v20, float v21, float v22, float v23, float v30, float v31, float v32, float v33)
- void delete()
- bool operator==(const Matrix4& rhs) const
- Vector3 operator*(const Vector3& rhs) const
- Vector4 operator*(const Vector4& rhs) const
- Matrix4 operator+(const Matrix4& rhs) const
- Matrix4 operator-(const Matrix4& rhs) const
- Matrix4 operator*(float rhs) const
- Matrix4 operator*(const Matrix4& rhs) const
- Matrix4 operator*(const Matrix3x4& rhs) const
- void SetTranslation(const Vector3& translation)
- void SetRotation(const Matrix3& rotation)
- void SetScale(const Vector3& scale)
- void SetScale(float scale)
- Matrix3 ToMatrix3() const
- Matrix3 RotationMatrix() const
- Vector3 Translation() const
- Quaternion Rotation() const
- Vector3 Scale() const
- Matrix4 Transpose() const
- bool Equals(const Matrix4& rhs) const
- void Decompose(Vector3& translation, Quaternion& rotation, Vector3& scale) const
- Matrix4 Inverse() const
- String ToString() const

Properties:

- float m00
- float m01
- float m02
- float m03
- float m10
- float m11
- float m12
- float m13
- float m20
- float m21
- float m22
- float m23
- float m30
- float m31
- float m32
- float m33
- const Matrix4 ZERO
- const Matrix4 IDENTITY

<a name="Class_Menu"></a>
### Menu : Button

Methods:

- Menu() (GC)
- Menu* new()
- void delete()
- void SetPopup(UIElement* element)
- void SetPopupOffset(const IntVector2& offset)
- void SetPopupOffset(int x, int y)
- void ShowPopup(bool enable)
- void SetAccelerator(int key, int qualifiers)
- UIElement* GetPopup() const
- const IntVector2& GetPopupOffset() const
- bool GetShowPopup() const
- int GetAcceleratorKey() const
- int GetAcceleratorQualifiers() const

Properties:

- UIElement* popup
- IntVector2& popupOffset
- bool showPopup
- int acceleratorKey (readonly)
- int acceleratorQualifiers (readonly)

<a name="Class_MessageBox"></a>
### MessageBox : Object

Methods:

- MessageBox(const String messageString = String::EMPTY, const String titleString = String::EMPTY, XMLFile* layoutFile = 0, XMLFile* styleFile = 0) (GC)
- MessageBox* new(const String messageString = String::EMPTY, const String titleString = String::EMPTY, XMLFile* layoutFile = 0, XMLFile* styleFile = 0)
- void delete()
- void SetTitle(const String text)
- void SetMessage(const String text)
- const String GetTitle() const
- const String GetMessage() const
- UIElement* GetWindow() const

Properties:

- String title
- String message
- UIElement* window (readonly)

<a name="Class_Model"></a>
### Model : Resource

Methods:

- Model* Clone(const String cloneName = String::EMPTY) const
- const BoundingBox& GetBoundingBox() const
- Skeleton& GetSkeleton()
- unsigned GetNumGeometries() const
- unsigned GetNumGeometryLodLevels(unsigned index) const
- Geometry* GetGeometry(unsigned index, unsigned lodLevel) const
- unsigned GetNumMorphs() const
- const ModelMorph* GetMorph(const String name) const
- const ModelMorph* GetMorph(StringHash nameHash) const
- const ModelMorph* GetMorph(unsigned index) const
- unsigned GetMorphRangeStart(unsigned bufferIndex) const
- unsigned GetMorphRangeCount(unsigned bufferIndex) const

Properties:

- BoundingBox& boundingBox (readonly)
- Skeleton skeleton (readonly)
- unsigned numGeometries (readonly)
- unsigned numMorphs (readonly)

<a name="Class_Navigable"></a>
### Navigable : Component

Methods:

- void SetRecursive(bool enable)
- bool IsRecursive() const

Properties:

- bool recursive

<a name="Class_NavigationGeometryInfo"></a>
### NavigationGeometryInfo


Properties:

- Component* component
- unsigned lodLevel
- Matrix3x4 transform
- BoundingBox boundingBox

<a name="Class_NavigationMesh"></a>
### NavigationMesh : Component

Methods:

- void SetTileSize(int size)
- void SetCellSize(float size)
- void SetCellHeight(float height)
- void SetAgentHeight(float height)
- void SetAgentRadius(float radius)
- void SetAgentMaxClimb(float maxClimb)
- void SetAgentMaxSlope(float maxSlope)
- void SetRegionMinSize(float size)
- void SetRegionMergeSize(float size)
- void SetEdgeMaxLength(float length)
- void SetEdgeMaxError(float error)
- void SetDetailSampleDistance(float distance)
- void SetDetailSampleMaxError(float error)
- void SetPadding(const Vector3& padding)
- bool Build()
- bool Build(const BoundingBox& boundingBox)
- Vector3 FindNearestPoint(const Vector3& point)
- Vector3 FindNearestPoint(const Vector3& point, const Vector3& extents)
- Vector3 MoveAlongSurface(const Vector3& start, const Vector3& end)
- Vector3 MoveAlongSurface(const Vector3& start, const Vector3& end, const Vector3& extents, int maxVisited = 3)
- const PODVector<Vector3>& FindPath(const Vector3& start, const Vector3& end)
- const PODVector<Vector3>& FindPath(const Vector3& start, const Vector3& end, const Vector3& extents)
- Vector3 GetRandomPoint()
- Vector3 GetRandomPointInCircle(const Vector3& center, float radius)
- Vector3 GetRandomPointInCircle(const Vector3& center, float radius, const Vector3& extents)
- float GetDistanceToWall(const Vector3& point, float radius)
- float GetDistanceToWall(const Vector3& point, float radius, const Vector3& extents)
- Vector3 Raycast(const Vector3& start, const Vector3& end)
- Vector3 Raycast(const Vector3& start, const Vector3& end, const Vector3& extents)
- void DrawDebugGeometry(bool depthTest)
- int GetTileSize() const
- float GetCellSize() const
- float GetCellHeight() const
- float GetAgentHeight() const
- float GetAgentRadius() const
- float GetAgentMaxClimb() const
- float GetAgentMaxSlope() const
- float GetRegionMinSize() const
- float GetRegionMergeSize() const
- float GetEdgeMaxLength() const
- float GetEdgeMaxError() const
- float GetDetailSampleDistance() const
- float GetDetailSampleMaxError() const
- const Vector3& GetPadding() const
- bool IsInitialized() const
- const BoundingBox& GetBoundingBox() const
- BoundingBox GetWorldBoundingBox() const
- IntVector2 GetNumTiles() const

Properties:

- int tileSize
- float cellSize
- float cellHeight
- float agentHeight
- float agentRadius
- float agentMaxClimb
- float agentMaxSlope
- float regionMinSize
- float regionMergeSize
- float edgeMaxLength
- float edgeMaxError
- float detailSampleDistance
- float detailSampleMaxError
- Vector3& padding
- bool initialized (readonly)
- BoundingBox& boundingBox (readonly)
- BoundingBox worldBoundingBox (readonly)
- IntVector2 numTiles (readonly)

<a name="Class_Network"></a>
### Network


Methods:

- bool Connect(const String address, short port, Scene* scene)
- bool Connect(const String address, short port, Scene* scene, const VariantMap& identity)
- void Disconnect(int waitMSec = 0)
- bool StartServer(short port)
- void StopServer()
- void BroadcastMessage(int msgID, bool reliable, bool inOrder, const VectorBuffer& msg, unsigned contentID = 0)
- void BroadcastRemoteEvent(StringHash eventType, bool inOrder)
- void BroadcastRemoteEvent(StringHash eventType, bool inOrder, const VariantMap& eventData)
- void BroadcastRemoteEvent(const String eventType, bool inOrder)
- void BroadcastRemoteEvent(const String eventType, bool inOrder, const VariantMap& eventData)
- void BroadcastRemoteEvent(Scene* scene, StringHash eventType, bool inOrder)
- void BroadcastRemoteEvent(Scene* scene, StringHash eventType, bool inOrder, const VariantMap& eventData)
- void BroadcastRemoteEvent(Scene* scene, const String eventType, bool inOrder)
- void BroadcastRemoteEvent(Scene* scene, const String eventType, bool inOrder, const VariantMap& eventData)
- void BroadcastRemoteEvent(Node* node, StringHash eventType, bool inOrder)
- void BroadcastRemoteEvent(Node* node, StringHash eventType, bool inOrder, const VariantMap& eventData)
- void BroadcastRemoteEvent(Node* node, const String eventType, bool inOrder)
- void BroadcastRemoteEvent(Node* node, const String eventType, bool inOrder, const VariantMap& eventData)
- void SetUpdateFps(int fps)
- void RegisterRemoteEvent(StringHash eventType)
- void RegisterRemoteEvent(const String eventType)
- void UnregisterRemoteEvent(StringHash eventType)
- void UnregisterRemoteEvent(const String eventType)
- void UnregisterAllRemoteEvents()
- void SetPackageCacheDir(const String path)
- void SendPackageToClients(Scene* scene, PackageFile* package)
- HttpRequest* MakeHttpRequest(const String url, const String verb = String::EMPTY)
- HttpRequest* MakeHttpRequest(const String url, const String verb, const Vector<String>& headers, const String postData = String::EMPTY)
- int GetUpdateFps() const
- Connection* GetServerConnection() const
- bool IsServerRunning() const
- bool CheckRemoteEvent(StringHash eventType) const
- const String GetPackageCacheDir() const

Properties:

- int updateFps
- Connection* serverConnection (readonly)
- bool serverRunning (readonly)
- String packageCacheDir

<a name="Class_NetworkPriority"></a>
### NetworkPriority : Component

Methods:

- void SetBasePriority(float priority)
- void SetDistanceFactor(float factor)
- void SetMinPriority(float priority)
- void SetAlwaysUpdateOwner(bool enable)
- float GetBasePriority() const
- float GetDistanceFactor() const
- float GetMinPriority() const
- bool GetAlwaysUpdateOwner() const
- bool CheckUpdate(float distance, float accumulator)

Properties:

- float basePriority
- float distanceFactor
- float minPriority
- bool alwaysUpdateOwner

<a name="Class_Node"></a>
### Node : Animatable

Methods:

- Node() (GC)
- Node* new()
- void delete()
- bool SaveXML(File* dest) const
- void SetName(const String name)
- void SetPosition(const Vector3& position)
- void SetPosition2D(const Vector2& position)
- void SetPosition2D(float x, float y)
- void SetRotation(const Quaternion& rotation)
- void SetRotation2D(float rotation)
- void SetDirection(const Vector3& direction)
- void SetScale(float scale)
- void SetScale(const Vector3& scale)
- void SetScale2D(const Vector2& scale)
- void SetScale2D(float x, float y)
- void SetTransform(const Vector3& position, const Quaternion& rotation)
- void SetTransform(const Vector3& position, const Quaternion& rotation, const Vector3& scale)
- void SetTransform(const Vector3& position, const Quaternion& rotation, float scale)
- void SetTransform2D(const Vector2& position, float rotation)
- void SetTransform2D(const Vector2& position, float rotation, const Vector2& scale)
- void SetTransform2D(const Vector2& position, float rotation, float scale)
- void SetWorldPosition(const Vector3& position)
- void SetWorldPosition2D(const Vector2& position)
- void SetWorldPosition2D(float x, float y)
- void SetWorldRotation(const Quaternion& rotation)
- void SetWorldRotation2D(float rotation)
- void SetWorldDirection(const Vector3& direction)
- void SetWorldScale(float scale)
- void SetWorldScale(const Vector3& scale)
- void SetWorldScale2D(const Vector2& scale)
- void SetWorldScale2D(float x, float y)
- void SetWorldTransform(const Vector3& position, const Quaternion& rotation)
- void SetWorldTransform(const Vector3& position, const Quaternion& rotation, const Vector3& scale)
- void SetWorldTransform(const Vector3& position, const Quaternion& rotation, float scale)
- void SetWorldTransform2D(const Vector2& position, float rotation)
- void SetWorldTransform2D(const Vector2& position, float rotation, const Vector2& scale)
- void SetWorldTransform2D(const Vector2& position, float rotation, float scale)
- void Translate(const Vector3& delta, TransformSpace space = TS_LOCAL)
- void Translate2D(const Vector2& delta, TransformSpace space = TS_LOCAL)
- void Rotate(const Quaternion& delta, TransformSpace space = TS_LOCAL)
- void Rotate2D(float delta, TransformSpace space = TS_LOCAL)
- void RotateAround(const Vector3& point, const Quaternion& delta, TransformSpace space = TS_LOCAL)
- void RotateAround2D(const Vector2& point, float delta, TransformSpace space = TS_LOCAL)
- void Pitch(float angle, TransformSpace space = TS_LOCAL)
- void Yaw(float angle, TransformSpace space = TS_LOCAL)
- void Roll(float angle, TransformSpace space = TS_LOCAL)
- bool LookAt(const Vector3& target)
- bool LookAt(const Vector3& target, const Vector3& upAxis, TransformSpace space = TS_WORLD)
- void Scale(float scale)
- void Scale(const Vector3& scale)
- void Scale2D(const Vector2& scale)
- void SetEnabled(bool enable)
- void SetDeepEnabled(bool enable)
- void ResetDeepEnabled()
- void SetEnabledRecursive(bool enable)
- void SetOwner(Connection* owner)
- void MarkDirty()
- Node* CreateChild(const String name = String::EMPTY, CreateMode mode = REPLICATED, unsigned id = 0)
- void AddChild(Node* node, unsigned index = M_MAX_UNSIGNED)
- void RemoveChild(Node* node)
- void RemoveAllChildren()
- void RemoveChildren(bool removeReplicated, bool removeLocal, bool recursive)
- void RemoveComponent(Component* component)
- void RemoveComponent(StringHash type)
- void RemoveComponent(const String type)
- void RemoveAllComponents()
- void RemoveComponents(bool removeReplicated, bool removeLocal)
- Node* Clone(CreateMode mode = REPLICATED)
- void Remove()
- void SetParent(Node* parent)
- void SetVar(StringHash key, const Variant& value)
- void AddListener(Component* component)
- void RemoveListener(Component* component)
- Component* CreateComponent(const String type, CreateMode mode = REPLICATED, unsigned id = 0)
- Component* CloneComponent(Component* component, unsigned id = 0)
- Component* CloneComponent(Component* component, CreateMode mode, unsigned id = 0)
- int CreateScriptObject(const String scriptObjectType)
- int CreateScriptObject(const String fileName, const String scriptObjectType)
- int GetScriptObject() const
- int GetScriptObject(const String scriptObjectType) const
- unsigned GetID() const
- const String GetName() const
- StringHash GetNameHash() const
- Node* GetParent() const
- Scene* GetScene() const
- bool IsEnabled() const
- bool IsEnabledSelf() const
- Connection* GetOwner() const
- const Vector3& GetPosition() const
- Vector2 GetPosition2D() const
- const Quaternion& GetRotation() const
- float GetRotation2D() const
- Vector3 GetDirection() const
- Vector3 GetUp() const
- Vector3 GetRight() const
- const Vector3& GetScale() const
- Vector2 GetScale2D() const
- Matrix3x4 GetTransform() const
- Vector3 GetWorldPosition() const
- Vector2 GetWorldPosition2D() const
- Quaternion GetWorldRotation() const
- float GetWorldRotation2D() const
- Vector3 GetWorldDirection() const
- Vector3 GetWorldUp() const
- Vector3 GetWorldRight() const
- Vector3 GetWorldScale() const
- Vector2 GetWorldScale2D() const
- const Matrix3x4& GetWorldTransform() const
- Vector3 LocalToWorld(const Vector3& position) const
- Vector3 LocalToWorld(const Vector4& vector) const
- Vector2 LocalToWorld2D(const Vector2& vector) const
- Vector3 WorldToLocal(const Vector3& position) const
- Vector3 WorldToLocal(const Vector4& vector) const
- Vector2 WorldToLocal2D(const Vector2& vector) const
- bool IsDirty() const
- unsigned GetNumChildren(bool recursive = false) const
- Node* GetChild(const String name, bool recursive = false) const
- Node* GetChild(StringHash nameHash, bool recursive = false) const
- Node* GetChild(unsigned index) const
- unsigned GetNumComponents() const
- unsigned GetNumNetworkComponents() const
- bool HasComponent(StringHash type) const
- bool HasComponent(const String type) const
- const Variant& GetVar(StringHash key) const
- const VariantMap& GetVars() const
- Component* GetComponent(const String type) const
- void SetID(unsigned id)
- void SetScene(Scene* scene)
- void ResetScene()
- bool Load(Deserializer& source, SceneResolver& resolver, bool loadChildren = true, bool rewriteIDs = false, CreateMode mode = REPLICATED)
- bool LoadXML(const XMLElement& source, SceneResolver& resolver, bool loadChildren = true, bool rewriteIDs = false, CreateMode mode = REPLICATED)
- Node* CreateChild(unsigned id, CreateMode mode)
- void AddComponent(Component* component, unsigned id, CreateMode mode)

Properties:

- unsigned ID
- String name
- StringHash nameHash (readonly)
- Node* parent
- Scene* scene
- bool enabled
- bool enabledSelf (readonly)
- Connection* owner
- Vector3& position
- Vector2 position2D
- Quaternion& rotation
- float rotation2D
- Vector3 direction
- Vector3 up (readonly)
- Vector3 right (readonly)
- Vector3& scale
- Vector2 scale2D
- Matrix3x4 transform (readonly)
- Vector3 worldPosition
- Vector2 worldPosition2D
- Quaternion worldRotation
- float worldRotation2D
- Vector3 worldDirection
- Vector3 worldUp (readonly)
- Vector3 worldRight (readonly)
- Vector3 worldScale
- Vector2 worldScale2D
- Matrix3x4& worldTransform (readonly)
- bool dirty (readonly)
- unsigned numComponents (readonly)
- unsigned numNetworkComponents (readonly)

<a name="Class_Object"></a>
### Object : RefCounted

Methods:

- StringHash GetType() const
- StringHash GetBaseType() const
- const String GetTypeName() const
- const String GetCategory() const
- void SendEvent(const String eventName, VariantMap* eventData = 0)

Properties:

- StringHash type (readonly)
- StringHash baseType (readonly)
- const String typeName (readonly)
- const String category (readonly)

<a name="Class_ObjectAnimation"></a>
### ObjectAnimation : Resource

Methods:

- ObjectAnimation() (GC)
- ObjectAnimation* new()
- void delete()
- void AddAttributeAnimation(const String name, ValueAnimation* attributeAnimation, WrapMode wrapMode = WM_LOOP, float speed = 1.0f)
- void RemoveAttributeAnimation(const String name)
- void RemoveAttributeAnimation(ValueAnimation* attributeAnimation)
- ValueAnimation* GetAttributeAnimation(const String name) const
- WrapMode GetAttributeAnimationWrapMode(const String name) const
- float GetAttributeAnimationSpeed(const String name) const

<a name="Class_Octree"></a>
### Octree : Component

Methods:

- void SetSize(const BoundingBox& box, unsigned numLevels)
- void Update(const FrameInfo& frame)
- void AddManualDrawable(Drawable* drawable)
- void RemoveManualDrawable(Drawable* drawable)
- const PODVector<OctreeQueryResult>& GetDrawables(const Vector3& point, char drawableFlags = DRAWABLE_ANY, unsigned viewMask = DEFAULT_VIEWMASK) const
- const PODVector<OctreeQueryResult>& GetDrawables(const BoundingBox& box, char drawableFlags = DRAWABLE_ANY, unsigned viewMask = DEFAULT_VIEWMASK) const
- const PODVector<OctreeQueryResult>& GetDrawables(const Frustum& frustum, char drawableFlags = DRAWABLE_ANY, unsigned viewMask = DEFAULT_VIEWMASK) const
- const PODVector<OctreeQueryResult>& GetDrawables(const Sphere& sphere, char drawableFlags = DRAWABLE_ANY, unsigned viewMask = DEFAULT_VIEWMASK) const
- const PODVector<RayQueryResult>& Raycast(const Ray& ray, RayQueryLevel level, float maxDistance, char drawableFlags, unsigned viewMask = DEFAULT_VIEWMASK) const
- RayQueryResult RaycastSingle(const Ray& ray, RayQueryLevel level, float maxDistance, char drawableFlags, unsigned viewMask = DEFAULT_VIEWMASK) const
- unsigned GetNumLevels() const
- void QueueUpdate(Drawable* drawable)
- void DrawDebugGeometry(bool depthTest)

Properties:

- unsigned numLevels (readonly)

<a name="Class_OctreeQueryResult"></a>
### OctreeQueryResult


Methods:

- OctreeQueryResult() (GC)
- OctreeQueryResult* new()
- void delete()

Properties:

- Drawable* drawable
- Node* node

<a name="Class_OffMeshConnection"></a>
### OffMeshConnection : Component

Methods:

- void SetEndPoint(Node* node)
- void SetRadius(float radius)
- void SetBidirectional(bool enabled)
- Node* GetEndPoint() const
- float GetRadius() const
- bool IsBidirectional() const

Properties:

- Node* endPoint
- float radius
- bool bidirectional

<a name="Class_PackageEntry"></a>
### PackageEntry


Properties:

- unsigned offset
- unsigned size
- unsigned checksum

<a name="Class_PackageFile"></a>
### PackageFile : Object

Methods:

- PackageFile() (GC)
- PackageFile* new()
- PackageFile(const String fileName, unsigned startOffset = 0) (GC)
- PackageFile* new(const String fileName, unsigned startOffset = 0)
- void delete()
- bool Open(const String fileName, unsigned startOffset = 0)
- bool Exists(const String fileName) const
- const PackageEntry* GetEntry(const String fileName) const
- const HashMap<String,PackageEntry>& GetEntries() const
- const String GetName() const
- StringHash GetNameHash() const
- unsigned GetNumFiles() const
- unsigned GetTotalSize() const
- unsigned GetChecksum() const
- bool IsCompressed() const

Properties:

- String name (readonly)
- StringHash nameHash (readonly)
- unsigned numFiles (readonly)
- unsigned totalSize (readonly)
- unsigned checksum (readonly)
- bool compressed (readonly)

<a name="Class_ParticleEffect"></a>
### ParticleEffect : Resource

Methods:

- void SetMaterial(Material* material)
- void SetNumParticles(unsigned num)
- void SetUpdateInvisible(bool enable)
- void SetRelative(bool enable)
- void SetScaled(bool enable)
- void SetSorted(bool enable)
- void SetAnimationLodBias(float lodBias)
- void SetEmitterType(EmitterType type)
- void SetEmitterSize(const Vector3& size)
- void SetMinDirection(const Vector3& direction)
- void SetMaxDirection(const Vector3& direction)
- void SetConstantForce(const Vector3& force)
- void SetDampingForce(float force)
- void SetActiveTime(float time)
- void SetInactiveTime(float time)
- void SetMinEmissionRate(float rate)
- void SetMaxEmissionRate(float rate)
- void SetMinParticleSize(const Vector2& size)
- void SetMaxParticleSize(const Vector2& size)
- void SetMinTimeToLive(float time)
- void SetMaxTimeToLive(float time)
- void SetMinVelocity(float velocity)
- void SetMaxVelocity(float velocity)
- void SetMinRotation(float rotation)
- void SetMaxRotation(float rotation)
- void SetMinRotationSpeed(float speed)
- void SetMaxRotationSpeed(float speed)
- void SetSizeAdd(float sizeAdd)
- void SetSizeMul(float sizeMul)
- void SetColorFrame(unsigned index, const ColorFrame& colorFrame)
- void SetTextureFrame(unsigned index, const TextureFrame& textureFrame)
- Material* GetMaterial() const
- unsigned GetNumParticles() const
- bool GetUpdateInvisible() const
- bool IsRelative() const
- bool IsScaled() const
- bool IsSorted() const
- float GetAnimationLodBias() const
- EmitterType GetEmitterType() const
- const Vector3& GetEmitterSize() const
- const Vector3& GetMinDirection() const
- const Vector3& GetMaxDirection() const
- const Vector3& GetConstantForce() const
- float GetDampingForce() const
- float GetActiveTime() const
- float GetInactiveTime() const
- float GetMinEmissionRate() const
- float GetMaxEmissionRate() const
- const Vector2& GetMinParticleSize() const
- const Vector2& GetMaxParticleSize() const
- float GetMinTimeToLive() const
- float GetMaxTimeToLive() const
- float GetMinVelocity() const
- float GetMaxVelocity() const
- float GetMinRotation() const
- float GetMaxRotation() const
- float GetMinRotationSpeed() const
- float GetMaxRotationSpeed() const
- float GetSizeAdd() const
- float GetSizeMul() const
- unsigned GetNumColorFrames() const
- const ColorFrame* GetColorFrame(unsigned index) const
- unsigned GetNumTextureFrames() const
- const TextureFrame* GetTextureFrame(unsigned index) const

Properties:

- Material* material
- unsigned numParticles
- bool updateInvisible
- bool relative
- bool scaled
- bool sorted
- float animationLodBias
- EmitterType emitterType
- const Vector3& emitterSize
- const Vector3& minDirection
- const Vector3& maxDirection
- const Vector3& constantForce
- float dampingForce
- float activeTime
- float inactiveTime
- float minEmissionRate
- float maxEmissionRate
- const Vector2& minParticleSize
- const Vector2& maxParticleSize
- float minTimeToLive
- float maxTimeToLive
- float minVelocity
- float maxVelocity
- float minRotation
- float maxRotation
- float minRotationSpeed
- float maxRotationSpeed
- float sizeAdd
- float sizeMul
- unsigned numColorFrames
- unsigned numTextureFrames

<a name="Class_ParticleEffect2D"></a>
### ParticleEffect2D : Resource

<a name="Class_ParticleEmitter"></a>
### ParticleEmitter : BillboardSet

Methods:

- void SetEffect(ParticleEffect* effect)
- void SetNumParticles(unsigned num)
- void SetEmitting(bool enable)
- void SetSerializeParticles(bool enable)
- void ResetEmissionTimer()
- void RemoveAllParticles()
- void Reset()
- void ApplyEffect()
- ParticleEffect* GetEffect() const
- unsigned GetNumParticles() const
- bool IsEmitting() const
- bool GetSerializeParticles() const

Properties:

- ParticleEffect* effect
- unsigned numParticles
- bool emitting
- bool serializeParticles

<a name="Class_ParticleEmitter2D"></a>
### ParticleEmitter2D : Drawable2D

Methods:

- void SetEffect(ParticleEffect2D* effect)
- ParticleEffect2D* GetEffect() const

Properties:

- ParticleEffect2D* effect

<a name="Class_Pass"></a>
### Pass : RefCounted

Methods:

- bool IsSM3() const
- bool IsDesktop() const
- const String GetVertexShader() const
- const String GetPixelShader() const

Properties:

- bool SM3 (readonly)
- bool desktop (readonly)
- const String vertexShader (readonly)
- const String pixelShader (readonly)

<a name="Class_PhysicsRaycastResult"></a>
### PhysicsRaycastResult


Methods:

- PhysicsRaycastResult() (GC)
- PhysicsRaycastResult* new()
- void delete()

Properties:

- Vector3 position
- Vector3 normal
- float distance
- RigidBody* body

<a name="Class_PhysicsRaycastResult2D"></a>
### PhysicsRaycastResult2D


Methods:

- PhysicsRaycastResult2D() (GC)
- PhysicsRaycastResult2D* new()
- void delete()

Properties:

- Vector2 position
- Vector2 normal
- float distance
- RigidBody2D* body

<a name="Class_PhysicsWorld"></a>
### PhysicsWorld : Component

Methods:

- void Update(float timeStep)
- void UpdateCollisions()
- void SetFps(int fps)
- void SetGravity(Vector3 gravity)
- void SetMaxSubSteps(int num)
- void SetNumIterations(int num)
- void SetInterpolation(bool enable)
- void SetInternalEdge(bool enable)
- void SetSplitImpulse(bool enable)
- void SetMaxNetworkAngularVelocity(float velocity)
- const PODVector<PhysicsRaycastResult>& Raycast(const Ray& ray, float maxDistance, unsigned collisionMask = M_MAX_UNSIGNED)
- PhysicsRaycastResult RaycastSingle(const Ray& ray, float maxDistance, unsigned collisionMask = M_MAX_UNSIGNED)
- PhysicsRaycastResult SphereCast(const Ray& ray, float radius, float maxDistance, unsigned collisionMask = M_MAX_UNSIGNED)
- PhysicsRaycastResult ConvexCast(CollisionShape* shape, const Vector3& startPos, const Quaternion& startRot, const Vector3& endPos, const Quaternion& endRot, unsigned collisionMask = M_MAX_UNSIGNED)
- const PODVector<RigidBody*>& GetRigidBodies(const Sphere& sphere, unsigned collisionMask = M_MAX_UNSIGNED)
- const PODVector<RigidBody*>& GetRigidBodies(const BoundingBox& box, unsigned collisionMask = M_MAX_UNSIGNED)
- const PODVector<RigidBody*>& GetRigidBodies(const RigidBody* body)
- void DrawDebugGeometry(bool depthTest)
- void RemoveCachedGeometry(Model* model)
- Vector3 GetGravity() const
- int GetMaxSubSteps() const
- int GetNumIterations() const
- bool GetInterpolation() const
- bool GetInternalEdge() const
- bool GetSplitImpulse() const
- int GetFps() const
- float GetMaxNetworkAngularVelocity() const

Properties:

- Vector3 gravity
- int maxSubSteps
- int numIterations
- bool interpolation
- bool internalEdge
- bool splitImpulse
- int fps
- float maxNetworkAngularVelocity
- bool applyingTransforms

<a name="Class_PhysicsWorld2D"></a>
### PhysicsWorld2D : Component

Methods:

- void DrawDebugGeometry()
- void SetDrawShape(bool drawShape)
- void SetDrawJoint(bool drawJoint)
- void SetDrawAabb(bool drawAabb)
- void SetDrawPair(bool drawPair)
- void SetDrawCenterOfMass(bool drawCenterOfMass)
- void SetAllowSleeping(bool enable)
- void SetWarmStarting(bool enable)
- void SetContinuousPhysics(bool enable)
- void SetSubStepping(bool enable)
- void SetGravity(const Vector2& gravity)
- void SetAutoClearForces(bool enable)
- void SetVelocityIterations(int velocityIterations)
- void SetPositionIterations(int positionIterations)
- const PODVector<PhysicsRaycastResult2D>& Raycast(const Vector2& startPoint, const Vector2& endPoint, unsigned collisionMask = M_MAX_UNSIGNED)
- PhysicsRaycastResult2D RaycastSingle(const Vector2& startPoint, const Vector2& endPoint, unsigned collisionMask = M_MAX_UNSIGNED)
- RigidBody2D* GetRigidBody(const Vector2& point, unsigned collisionMask = M_MAX_UNSIGNED)
- RigidBody2D* GetRigidBody(int screenX, int screenY, unsigned collisionMask = M_MAX_UNSIGNED)
- const PODVector<RigidBody2D*>& GetRigidBodies(const Rect& aabb, unsigned collisionMask = M_MAX_UNSIGNED)
- bool GetDrawShape() const
- bool GetDrawJoint() const
- bool GetDrawAabb() const
- bool GetDrawPair() const
- bool GetDrawCenterOfMass() const
- bool GetAllowSleeping() const
- bool GetWarmStarting() const
- bool GetContinuousPhysics() const
- bool GetSubStepping() const
- bool GetAutoClearForces() const
- const Vector2& GetGravity() const
- int GetVelocityIterations() const
- int GetPositionIterations() const

Properties:

- bool drawShape
- bool drawJoint
- bool drawAabb
- bool drawPair
- bool drawCenterOfMass
- bool allowSleeping
- bool warmStarting
- bool continuousPhysics
- bool subStepping
- bool autoClearForces
- Vector2& gravity
- int velocityIterations
- int positionIterations

<a name="Class_Plane"></a>
### Plane


Methods:

- Plane() (GC)
- Plane* new()
- Plane(const Plane& plane) (GC)
- Plane* new(const Plane& plane)
- Plane(const Vector3& v0, const Vector3& v1, const Vector3& v2) (GC)
- Plane* new(const Vector3& v0, const Vector3& v1, const Vector3& v2)
- Plane(const Vector3& normal, const Vector3& point) (GC)
- Plane* new(const Vector3& normal, const Vector3& point)
- Plane(const Vector4& plane) (GC)
- Plane* new(const Vector4& plane)
- void delete()
- void Define(const Vector3& v0, const Vector3& v1, const Vector3& v2)
- void Define(const Vector3& normal, const Vector3& point)
- void Define(const Vector4& plane)
- void Transform(const Matrix3& transform)
- void Transform(const Matrix3x4& transform)
- void Transform(const Matrix4& transform)
- Vector3 Project(const Vector3& point) const
- float Distance(const Vector3& point) const
- Vector3 Reflect(const Vector3& direction) const
- Matrix3x4 ReflectionMatrix() const
- Plane Transformed(const Matrix3& transform) const
- Plane Transformed(const Matrix3x4& transform) const
- Plane Transformed(const Matrix4& transform) const
- Vector4 ToVector4() const

Properties:

- Vector3 normal
- Vector3 absNormal
- float d
- const Plane UP

<a name="Class_Polyhedron"></a>
### Polyhedron


Methods:

- Polyhedron() (GC)
- Polyhedron* new()
- Polyhedron(const Polyhedron& polyhedron) (GC)
- Polyhedron* new(const Polyhedron& polyhedron)
- Polyhedron(const BoundingBox& box) (GC)
- Polyhedron* new(const BoundingBox& box)
- Polyhedron(const Frustum& frustum) (GC)
- Polyhedron* new(const Frustum& frustum)
- void delete()
- void Define(const BoundingBox& box)
- void Define(const Frustum& frustum)
- void AddFace(const Vector3& v0, const Vector3& v1, const Vector3& v2)
- void AddFace(const Vector3& v0, const Vector3& v1, const Vector3& v2, const Vector3& v3)
- void Clip(const Plane& plane)
- void Clip(const BoundingBox& box)
- void Clip(const Frustum& box)
- void Clear()
- void Transform(const Matrix3& transform)
- void Transform(const Matrix3x4& transform)
- Polyhedron Transformed(const Matrix3& transform) const
- Polyhedron Transformed(const Matrix3x4& transform) const
- bool Empty() const

Properties:

- bool empty (readonly)

<a name="Class_PropertySet2D"></a>
### PropertySet2D


Methods:

- bool HasProperty(const String name) const
- const String GetProperty(const String name) const

<a name="Class_Quaternion"></a>
### Quaternion


Methods:

- Quaternion() (GC)
- Quaternion* new()
- Quaternion(const Quaternion& quat) (GC)
- Quaternion* new(const Quaternion& quat)
- Quaternion(float w, float x, float y, float z) (GC)
- Quaternion* new(float w, float x, float y, float z)
- Quaternion(float angle, const Vector3& axis) (GC)
- Quaternion* new(float angle, const Vector3& axis)
- Quaternion(float angle) (GC)
- Quaternion* new(float angle)
- Quaternion(float x, float y, float z) (GC)
- Quaternion* new(float x, float y, float z)
- Quaternion(const Vector3& start, const Vector3& end) (GC)
- Quaternion* new(const Vector3& start, const Vector3& end)
- Quaternion(const Vector3& xAxis, const Vector3& yAxis, const Vector3& zAxis) (GC)
- Quaternion* new(const Vector3& xAxis, const Vector3& yAxis, const Vector3& zAxis)
- Quaternion(const Matrix3& matrix) (GC)
- Quaternion* new(const Matrix3& matrix)
- void delete()
- bool operator==(const Quaternion& rhs) const
- Quaternion operator*(float rhs) const
- Quaternion operator-() const
- bool operator==(const Quaternion& rhs) const
- Quaternion operator*(float rhs) const
- Quaternion operator-() const
- Quaternion operator+(const Quaternion& rhs) const
- Quaternion operator-(const Quaternion& rhs) const
- Quaternion operator*(const Quaternion& rhs) const
- Vector3 operator*(const Vector3& rhs) const
- void FromAngleAxis(float angle, const Vector3& axis)
- void FromEulerAngles(float x, float y, float z)
- void FromRotationTo(const Vector3& start, const Vector3& end)
- void FromAxes(const Vector3& xAxis, const Vector3& yAxis, const Vector3& zAxis)
- void FromRotationMatrix(const Matrix3& matrix)
- bool FromLookRotation(const Vector3& direction, const Vector3& up)
- void Normalize()
- Quaternion Normalized() const
- Quaternion Inverse() const
- float LengthSquared() const
- float DotProduct(const Quaternion& rhs) const
- bool Equals(const Quaternion& rhs) const
- bool IsNaN() const
- Quaternion Conjugate() const
- Vector3 EulerAngles() const
- float YawAngle() const
- float PitchAngle() const
- float RollAngle() const
- Matrix3 RotationMatrix() const
- Quaternion Slerp(Quaternion rhs, float t) const
- Quaternion Nlerp(Quaternion rhs, float t, bool shortestPath) const
- String ToString() const

Properties:

- float w
- float x
- float y
- float z
- const Quaternion IDENTITY

<a name="Class_Ray"></a>
### Ray


Methods:

- Ray() (GC)
- Ray* new()
- Ray(const Vector3& origin, const Vector3& direction) (GC)
- Ray* new(const Vector3& origin, const Vector3& direction)
- Ray(const Ray& ray) (GC)
- Ray* new(const Ray& ray)
- void delete()
- bool operator==(const Ray& rhs) const
- void Define(const Vector3& origin, const Vector3& direction)
- Vector3 Project(const Vector3& point) const
- float Distance(const Vector3& point) const
- Vector3 ClosestPoint(const Ray& ray) const
- float HitDistance(const Plane& plane) const
- float HitDistance(const BoundingBox& box) const
- float HitDistance(const Frustum& frustum, bool solidInside = true) const
- float HitDistance(const Sphere& sphere) const
- float HitDistance(const Vector3& v0, const Vector3& v1, const Vector3& v2) const
- Ray Transformed(const Matrix3x4& transform) const

Properties:

- Vector3 origin
- Vector3 direction

<a name="Class_RayQueryResult"></a>
### RayQueryResult


Methods:

- RayQueryResult() (GC)
- RayQueryResult* new()
- void delete()

Properties:

- Vector3 position
- Vector3 normal
- float distance
- Drawable* drawable
- Node* node
- unsigned subObject

<a name="Class_Rect"></a>
### Rect


Methods:

- Rect() (GC)
- Rect* new()
- Rect(const Rect& rect) (GC)
- Rect* new(const Rect& rect)
- Rect(const Vector2& min, const Vector2& max) (GC)
- Rect* new(const Vector2& min, const Vector2& max)
- Rect(float left, float top, float right, float bottom) (GC)
- Rect* new(float left, float top, float right, float bottom)
- Rect(const Vector4& vector) (GC)
- Rect* new(const Vector4& vector)
- void delete()
- bool operator==(const Rect& rhs) const
- void Define(const Rect& rect)
- void Define(const Vector2& min, const Vector2& max)
- void Define(const Vector2& point)
- void Merge(const Vector2& point)
- void Merge(const Rect& rect)
- void Clear()
- void Clip(const Rect& rect)
- Vector2 Center() const
- Vector2 Size() const
- Vector2 HalfSize() const
- bool Equals(const Rect& rhs) const
- Intersection IsInside(const Vector2& point) const
- Vector4 ToVector4() const
- String ToString() const

Properties:

- Vector2 min
- Vector2 max
- const Rect FULL
- const Rect POSITIVE
- const Rect ZERO
- Vector2 center (readonly)
- Vector2 size (readonly)
- Vector2 halfSize (readonly)

<a name="Class_RemoteEvent"></a>
### RemoteEvent


Properties:

- unsigned senderID
- StringHash eventType
- VariantMap eventData
- bool inOrder

<a name="Class_RenderPath"></a>
### RenderPath


Methods:

- RenderPath* Clone()
- bool Load(XMLFile* file)
- bool Append(XMLFile* file)
- void SetEnabled(const String tag, bool active)
- void ToggleEnabled(const String tag)
- void SetRenderTarget(unsigned index, const RenderTargetInfo& info)
- void AddRenderTarget(const RenderTargetInfo& info)
- void RemoveRenderTarget(const String name)
- void RemoveRenderTarget(unsigned index)
- void RemoveRenderTargets(const String tag)
- void SetCommand(unsigned index, const RenderPathCommand& command)
- void AddCommand(const RenderPathCommand& command)
- void InsertCommand(unsigned index, const RenderPathCommand& command)
- void RemoveCommand(unsigned index)
- void RemoveCommands(const String tag)
- void SetShaderParameter(const String name, const Variant& value)
- unsigned GetNumRenderTargets() const
- unsigned GetNumCommands() const
- const Variant& GetShaderParameter(const String name) const

<a name="Class_RenderSurface"></a>
### RenderSurface


Methods:

- RenderSurface(Texture* parentTexture) (GC)
- RenderSurface* new(Texture* parentTexture)
- void delete()
- void SetNumViewports(unsigned num)
- void SetViewport(unsigned index, Viewport* viewport)
- void SetUpdateMode(RenderSurfaceUpdateMode mode)
- void SetLinkedRenderTarget(RenderSurface* renderTarget)
- void SetLinkedDepthStencil(RenderSurface* depthStencil)
- void QueueUpdate()
- void Release()
- Texture* GetParentTexture() const
- int GetWidth() const
- int GetHeight() const
- TextureUsage GetUsage() const
- unsigned GetNumViewports() const
- Viewport* GetViewport(unsigned index) const
- RenderSurfaceUpdateMode GetUpdateMode() const
- RenderSurface* GetLinkedRenderTarget() const
- RenderSurface* GetLinkedDepthStencil() const

Properties:

- Texture* parentTexture (readonly)
- int width (readonly)
- int height (readonly)
- TextureUsage usage (readonly)
- unsigned numViewports
- RenderSurfaceUpdateMode updateMode
- RenderSurface* linkedRenderTarget
- RenderSurface* linkedDepthStencil

<a name="Class_Renderer"></a>
### Renderer


Methods:

- void SetNumViewports(unsigned num)
- void SetViewport(unsigned index, Viewport* viewport)
- void SetDefaultRenderPath(RenderPath* renderPath)
- void SetDefaultRenderPath(XMLFile* file)
- void SetHDRRendering(bool enable)
- void SetSpecularLighting(bool enable)
- void SetTextureAnisotropy(int level)
- void SetTextureFilterMode(TextureFilterMode mode)
- void SetTextureQuality(int quality)
- void SetMaterialQuality(int quality)
- void SetDrawShadows(bool enable)
- void SetShadowMapSize(int size)
- void SetShadowQuality(int quality)
- void SetReuseShadowMaps(bool enable)
- void SetMaxShadowMaps(int shadowMaps)
- void SetDynamicInstancing(bool enable)
- void SetMinInstances(int instances)
- void SetMaxInstanceTriangles(int triangles)
- void SetMaxSortedInstances(int instances)
- void SetMaxOccluderTriangles(int triangles)
- void SetOcclusionBufferSize(int size)
- void SetOccluderSizeThreshold(float screenSize)
- void SetMobileShadowBiasMul(float mul)
- void SetMobileShadowBiasAdd(float add)
- void ReloadShaders()
- unsigned GetNumViewports() const
- Viewport* GetViewport(unsigned index) const
- RenderPath* GetDefaultRenderPath() const
- bool GetHDRRendering() const
- bool GetSpecularLighting() const
- bool GetDrawShadows() const
- int GetTextureAnisotropy() const
- TextureFilterMode GetTextureFilterMode() const
- int GetTextureQuality() const
- int GetMaterialQuality() const
- int GetShadowMapSize() const
- int GetShadowQuality() const
- bool GetReuseShadowMaps() const
- int GetMaxShadowMaps() const
- bool GetDynamicInstancing() const
- int GetMinInstances() const
- int GetMaxInstanceTriangles() const
- int GetMaxSortedInstances() const
- int GetMaxOccluderTriangles() const
- int GetOcclusionBufferSize() const
- float GetOccluderSizeThreshold() const
- float GetMobileShadowBiasMul() const
- float GetMobileShadowBiasAdd() const
- unsigned GetNumViews() const
- unsigned GetNumPrimitives() const
- unsigned GetNumBatches() const
- unsigned GetNumGeometries(bool allViews = false) const
- unsigned GetNumLights(bool allViews = false) const
- unsigned GetNumShadowMaps(bool allViews = false) const
- unsigned GetNumOccluders(bool allViews = false) const
- Zone* GetDefaultZone() const
- Material* GetDefaultMaterial() const
- Texture2D* GetDefaultLightRamp() const
- Texture2D* GetDefaultLightSpot() const
- void DrawDebugGeometry(bool depthTest)

Properties:

- unsigned numViewports
- RenderPath* defaultRenderPath
- bool HDRRendering
- bool specularLighting
- bool drawShadows
- int textureAnisotropy
- TextureFilterMode textureFilterMode
- int textureQuality
- int materialQuality
- int shadowMapSize
- int shadowQuality
- bool reuseShadowMaps
- int maxShadowMaps
- bool dynamicInstancing
- int minInstances
- int maxInstanceTriangles
- int maxSortedInstances
- int maxOccluderTriangles
- int occlusionBufferSize
- float occluderSizeThreshold
- float mobileShadowBiasMul
- float mobileShadowBiasAdd
- unsigned numViews (readonly)
- unsigned numPrimitives (readonly)
- unsigned numBatches (readonly)
- Zone* defaultZone (readonly)
- Material* defaultMaterial (readonly)
- Texture2D* defaultLightRamp (readonly)
- Texture2D* defaultLightSpot (readonly)

<a name="Class_Resource"></a>
### Resource


Methods:

- bool Load(Deserializer& source)
- bool Save(Serializer& dest) const
- bool Load(const String fileName)
- bool Save(const String fileName) const
- const String GetName() const
- StringHash GetNameHash() const
- unsigned GetMemoryUse() const

Properties:

- String name (readonly)
- StringHash nameHash (readonly)
- unsigned memoryUse (readonly)

<a name="Class_ResourceCache"></a>
### ResourceCache


Methods:

- void ReleaseAllResources(bool force = false)
- bool ReloadResource(Resource* resource)
- void ReloadResourceWithDependencies(const String fileName)
- void SetMemoryBudget(StringHash type, unsigned budget)
- void SetMemoryBudget(const String type, unsigned budget)
- void SetAutoReloadResources(bool enable)
- void SetReturnFailedResources(bool enable)
- void SetSearchPackagesFirst(bool value)
- void SetFinishBackgroundResourcesMs(int ms)
- File* GetFile(const String name)
- Resource* GetResource(const String type, const String name, bool sendEventOnFailure = true)
- bool BackgroundLoadResource(const String type, const String name, bool sendEventOnFailure = true)
- unsigned GetNumBackgroundLoadResources() const
- bool Exists(const String name) const
- unsigned GetMemoryBudget(StringHash type) const
- unsigned GetMemoryUse(StringHash type) const
- unsigned GetTotalMemoryUse() const
- String GetResourceFileName(const String name) const
- bool GetAutoReloadResources() const
- bool GetReturnFailedResources() const
- bool GetSearchPackagesFirst() const
- int GetFinishBackgroundResourcesMs() const
- String GetPreferredResourceDir(const String path) const
- String SanitateResourceName(const String name) const
- String SanitateResourceDirName(const String name) const

Properties:

- unsigned totalMemoryUse (readonly)
- bool autoReloadResources
- bool returnFailedResources
- bool searchPackagesFirst
- unsigned numBackgroundLoadResources (readonly)
- int finishBackgroundResourcesMs

<a name="Class_ResourceRef"></a>
### ResourceRef


Methods:

- ResourceRef() (GC)
- ResourceRef* new()
- ResourceRef(StringHash type) (GC)
- ResourceRef* new(StringHash type)
- ResourceRef(StringHash type, String name) (GC)
- ResourceRef* new(StringHash type, String name)
- ResourceRef(const ResourceRef& rhs) (GC)
- ResourceRef* new(const ResourceRef& rhs)
- void delete()
- bool operator==(const ResourceRef& rhs) const

Properties:

- StringHash type
- String name

<a name="Class_ResourceRefList"></a>
### ResourceRefList


Methods:

- ResourceRefList() (GC)
- ResourceRefList* new()
- ResourceRefList(StringHash type) (GC)
- ResourceRefList* new(StringHash type)
- void delete()
- bool operator==(const ResourceRefList& rhs) const

Properties:

- StringHash type

<a name="Class_RigidBody"></a>
### RigidBody : Component

Methods:

- void SetMass(float mass)
- void SetPosition(Vector3 position)
- void SetRotation(Quaternion rotation)
- void SetTransform(const Vector3& position, const Quaternion& rotation)
- void SetLinearVelocity(Vector3 velocity)
- void SetLinearFactor(Vector3 factor)
- void SetLinearRestThreshold(float threshold)
- void SetLinearDamping(float damping)
- void SetAngularVelocity(Vector3 angularVelocity)
- void SetAngularFactor(Vector3 factor)
- void SetAngularRestThreshold(float threshold)
- void SetAngularDamping(float factor)
- void SetFriction(float friction)
- void SetAnisotropicFriction(Vector3 friction)
- void SetRollingFriction(float friction)
- void SetRestitution(float restitution)
- void SetContactProcessingThreshold(float threshold)
- void SetCcdRadius(float radius)
- void SetCcdMotionThreshold(float threshold)
- void SetUseGravity(bool enable)
- void SetGravityOverride(const Vector3& gravity)
- void SetKinematic(bool enable)
- void SetTrigger(bool enable)
- void SetCollisionLayer(unsigned layer)
- void SetCollisionMask(unsigned mask)
- void SetCollisionLayerAndMask(unsigned layer, unsigned mask)
- void SetCollisionEventMode(CollisionEventMode mode)
- void DisableMassUpdate()
- void EnableMassUpdate()
- void ApplyForce(const Vector3& force)
- void ApplyForce(const Vector3& force, const Vector3& position)
- void ApplyTorque(const Vector3& torque)
- void ApplyImpulse(const Vector3& impulse)
- void ApplyImpulse(const Vector3& impulse, const Vector3& position)
- void ApplyTorqueImpulse(const Vector3& torque)
- void ResetForces()
- void Activate()
- void ReAddBodyToWorld()
- PhysicsWorld* GetPhysicsWorld() const
- float GetMass() const
- Vector3 GetPosition() const
- Quaternion GetRotation() const
- Vector3 GetLinearVelocity() const
- Vector3 GetLinearFactor() const
- Vector3 GetVelocityAtPoint(const Vector3& position) const
- float GetLinearRestThreshold() const
- float GetLinearDamping() const
- Vector3 GetAngularVelocity() const
- Vector3 GetAngularFactor() const
- float GetAngularRestThreshold() const
- float GetAngularDamping() const
- float GetFriction() const
- Vector3 GetAnisotropicFriction() const
- float GetRollingFriction() const
- float GetRestitution() const
- float GetContactProcessingThreshold() const
- float GetCcdRadius() const
- float GetCcdMotionThreshold() const
- bool GetUseGravity() const
- const Vector3& GetGravityOverride() const
- const Vector3& GetCenterOfMass() const
- bool IsKinematic() const
- bool IsTrigger() const
- bool IsActive() const
- unsigned GetCollisionLayer() const
- unsigned GetCollisionMask() const
- CollisionEventMode GetCollisionEventMode() const

Properties:

- PhysicsWorld* physicsWorld (readonly)
- float mass
- Vector3 position
- Quaternion rotation
- Vector3 linearVelocity
- Vector3 linearFactor
- float linearRestThreshold
- float linearDamping
- Vector3 angularVelocity
- Vector3 angularFactor
- float angularRestThreshold
- float angularDamping
- float friction
- Vector3 anisotropicFriction
- float rollingFriction
- float restitution
- float contactProcessingThreshold
- float ccdRadius
- float ccdMotionThreshold
- bool useGravity
- Vector3& gravityOverride
- Vector3& centerOfMass (readonly)
- bool kinematic
- bool trigger
- bool active (readonly)
- unsigned collisionLayer
- unsigned collisionMask
- CollisionEventMode collisionEventMode

<a name="Class_RigidBody2D"></a>
### RigidBody2D : Component

Methods:

- void SetBodyType(BodyType2D bodyType)
- void SetMass(float mass)
- void SetInertia(float inertia)
- void SetMassCenter(Vector2 center)
- void SetUseFixtureMass(bool useFixtureMass)
- void SetLinearDamping(float linearDamping)
- void SetAngularDamping(float angularDamping)
- void SetAllowSleep(bool allowSleep)
- void SetFixedRotation(bool fixedRotation)
- void SetBullet(bool bullet)
- void SetGravityScale(float gravityScale)
- void SetAwake(bool awake)
- void SetLinearVelocity(Vector2 linearVelocity)
- void SetAngularVelocity(float angularVelocity)
- void ApplyForce(const Vector2& force, const Vector2& point, bool wake)
- void ApplyForceToCenter(const Vector2& force, bool wake)
- void ApplyTorque(float torque, bool wake)
- void ApplyLinearImpulse(const Vector2& impulse, const Vector2& point, bool wake)
- void ApplyAngularImpulse(float impulse, bool wake)
- BodyType2D GetBodyType() const
- float GetMass() const
- float GetInertia() const
- Vector2 GetMassCenter() const
- bool GetUseFixtureMass() const
- float GetLinearDamping() const
- float GetAngularDamping() const
- bool IsAllowSleep() const
- bool IsFixedRotation() const
- bool IsBullet() const
- float GetGravityScale() const
- bool IsAwake() const
- Vector2 GetLinearVelocity() const
- float GetAngularVelocity() const

Properties:

- BodyType2D bodyType
- float mass
- float inertia
- Vector2 massCenter
- bool useFixtureMass
- float linearDamping
- float angularDamping
- bool allowSleep
- bool fixedRotation
- bool bullet
- float gravityScale
- bool awake
- Vector2 linearVelocity
- float angularVelocity

<a name="Class_Scene"></a>
### Scene : Node

Methods:

- Scene() (GC)
- Scene* new()
- void delete()
- bool Load(File* source)
- bool Save(File* dest) const
- bool Load(const String fileName)
- bool Save(const String fileName) const
- bool LoadXML(File* source)
- bool SaveXML(File* dest) const
- bool LoadXML(const String fileName)
- bool SaveXML(const String fileName) const
- Node* Instantiate(File* source, const Vector3& position, const Quaternion& rotation, CreateMode mode = REPLICATED)
- Node* Instantiate(const String fileName, const Vector3& position, const Quaternion& rotation, CreateMode mode = REPLICATED)
- Node* InstantiateXML(File* source, const Vector3& position, const Quaternion& rotation, CreateMode mode = REPLICATED)
- Node* InstantiateXML(const String fileName, const Vector3& position, const Quaternion& rotation, CreateMode mode = REPLICATED)
- bool LoadAsync(File* file, LoadMode mode = LOAD_SCENE_AND_RESOURCES)
- bool LoadAsyncXML(File* file, LoadMode mode = LOAD_SCENE_AND_RESOURCES)
- bool LoadAsync(const String fileName, LoadMode mode = LOAD_SCENE_AND_RESOURCES)
- bool LoadAsyncXML(const String fileName, LoadMode mode = LOAD_SCENE_AND_RESOURCES)
- void StopAsyncLoading()
- void Clear(bool clearReplicated = true, bool clearLocal = true)
- void SetUpdateEnabled(bool enable)
- void SetTimeScale(float scale)
- void SetElapsedTime(float time)
- void SetSmoothingConstant(float constant)
- void SetSnapThreshold(float threshold)
- void SetAsyncLoadingMs(int ms)
- Node* GetNode(unsigned id) const
- bool IsUpdateEnabled() const
- bool IsAsyncLoading() const
- float GetAsyncProgress() const
- LoadMode GetAsyncLoadMode() const
- const String GetFileName() const
- unsigned GetChecksum() const
- float GetTimeScale() const
- float GetElapsedTime() const
- float GetSmoothingConstant() const
- float GetSnapThreshold() const
- int GetAsyncLoadingMs() const
- const String GetVarName(StringHash hash) const
- void Update(float timeStep)
- void BeginThreadedUpdate()
- void EndThreadedUpdate()
- void DelayedMarkedDirty(Component* component)
- bool IsThreadedUpdate() const
- unsigned GetFreeNodeID(CreateMode mode)
- unsigned GetFreeComponentID(CreateMode mode)
- void NodeAdded(Node* node)
- void NodeRemoved(Node* node)
- void ComponentAdded(Component* component)
- void ComponentRemoved(Component* component)
- void SetVarNamesAttr(String value)
- String GetVarNamesAttr() const
- void PrepareNetworkUpdate()
- void CleanupConnection(Connection* connection)
- void MarkNetworkUpdate(Node* node)
- void MarkNetworkUpdate(Component* component)
- void MarkReplicationDirty(Node* node)

Properties:

- bool updateEnabled
- bool asyncLoading (readonly)
- float asyncProgress (readonly)
- LoadMode asyncLoadMode (readonly)
- const String fileName
- unsigned checksum (readonly)
- float timeScale
- float elapsedTime
- float smoothingConstant
- float snapThreshold
- int asyncLoadingMs
- bool threadedUpdate (readonly)
- String varNamesAttr

<a name="Class_ScrollBar"></a>
### ScrollBar : UIElement

Methods:

- ScrollBar() (GC)
- ScrollBar* new()
- void delete()
- void SetOrientation(Orientation orientation)
- void SetRange(float range)
- void SetValue(float value)
- void ChangeValue(float delta)
- void SetScrollStep(float step)
- void SetStepFactor(float factor)
- void StepBack()
- void StepForward()
- Orientation GetOrientation() const
- float GetRange() const
- float GetValue() const
- float GetScrollStep() const
- float GetStepFactor() const
- float GetEffectiveScrollStep() const
- Button* GetBackButton() const
- Button* GetForwardButton() const
- Slider* GetSlider() const

Properties:

- Orientation orientation
- float range
- float value
- float scrollStep
- float stepFactor
- float effectiveScrollStep (readonly)
- Button* backButton (readonly)
- Button* forwardButton (readonly)
- Slider* slider (readonly)

<a name="Class_ScrollView"></a>
### ScrollView : UIElement

Methods:

- ScrollView() (GC)
- ScrollView* new()
- void delete()
- void SetContentElement(UIElement* element)
- void SetViewPosition(const IntVector2& position)
- void SetViewPosition(int x, int y)
- void SetScrollBarsVisible(bool horizontal, bool vertical)
- void SetScrollBarsAutoVisible(bool enable)
- void SetScrollStep(float step)
- void SetPageStep(float step)
- void SetScrollDeceleration(float deceleration)
- void SetScrollSnapEpsilon(float snap)
- void SetAutoDisableChildren(bool disable)
- void SetAutoDisableThreshold(float amount)
- const IntVector2& GetViewPosition() const
- UIElement* GetContentElement() const
- ScrollBar* GetHorizontalScrollBar() const
- ScrollBar* GetVerticalScrollBar() const
- BorderImage* GetScrollPanel() const
- bool GetScrollBarsAutoVisible() const
- float GetScrollStep() const
- float GetPageStep() const
- float GetScrollDeceleration() const
- float GetScrollSnapEpsilon() const
- bool GetAutoDisableChildren() const
- float GetAutoDisableThreshold() const

Properties:

- IntVector2& viewPosition
- UIElement* contentElement
- ScrollBar* horizontalScrollBar (readonly)
- ScrollBar* verticalScrollBar (readonly)
- BorderImage* scrollPanel (readonly)
- bool scrollBarsAutoVisible
- float scrollStep
- float pageStep
- float scrollDeceleration
- float scrollSnapEpsilon

<a name="Class_Serializable"></a>
### Serializable : Object

Methods:

- void SetTemporary(bool enable)
- bool IsTemporary() const

Properties:

- bool temporary

<a name="Class_Serializer"></a>
### Serializer


Methods:

- unsigned Write(const VectorBuffer& buffer)
- bool WriteInt(int value)
- bool WriteShort(short value)
- bool WriteByte(char value)
- bool WriteUInt(unsigned value)
- bool WriteUShort(short value)
- bool WriteUByte(char value)
- bool WriteBool(bool value)
- bool WriteFloat(float value)
- bool WriteIntRect(const IntRect& value)
- bool WriteIntVector2(const IntVector2& value)
- bool WriteRect(const Rect& value)
- bool WriteVector2(const Vector2& value)
- bool WriteVector3(const Vector3& value)
- bool WritePackedVector3(const Vector3& value, float maxAbsCoord)
- bool WriteVector4(const Vector4& value)
- bool WriteQuaternion(const Quaternion& value)
- bool WritePackedQuaternion(const Quaternion& value)
- bool WriteMatrix3(const Matrix3& value)
- bool WriteMatrix3x4(const Matrix3x4& value)
- bool WriteMatrix4(const Matrix4& value)
- bool WriteColor(const Color& value)
- bool WriteBoundingBox(const BoundingBox& value)
- bool WriteString(const String value)
- bool WriteFileID(const String value)
- bool WriteStringHash(const StringHash& value)
- bool WriteBuffer(const VectorBuffer& buffer)
- bool WriteResourceRef(const ResourceRef& value)
- bool WriteResourceRefList(const ResourceRefList& value)
- bool WriteVariant(const Variant& value)
- bool WriteVariantData(const Variant& value)
- bool WriteVariantVector(const VariantVector& value)
- bool WriteVariantMap(const VariantMap& value)
- bool WriteVLE(unsigned value)
- bool WriteNetID(unsigned value)
- bool WriteLine(const String value)

<a name="Class_Skeleton"></a>
### Skeleton


Methods:

- unsigned GetNumBones() const
- Bone* GetRootBone()
- Bone* GetBone(const String name)
- Bone* GetBone(unsigned index)

Properties:

- unsigned numBones (readonly)
- Bone* rootBone (readonly)

<a name="Class_Skybox"></a>
### Skybox : StaticModel

<a name="Class_Slider"></a>
### Slider : BorderImage

Methods:

- Slider() (GC)
- Slider* new()
- void delete()
- void SetOrientation(Orientation orientation)
- void SetRange(float range)
- void SetValue(float value)
- void ChangeValue(float delta)
- void SetRepeatRate(float rate)
- Orientation GetOrientation() const
- float GetRange() const
- float GetValue() const
- BorderImage* GetKnob() const
- float GetRepeatRate() const

Properties:

- Orientation orientation
- float range
- float value
- BorderImage* knob (readonly)
- float repeatRate

<a name="Class_Sound"></a>
### Sound : Resource

Methods:

- Sound() (GC)
- Sound* new()
- void delete()
- bool LoadRaw(Deserializer& source)
- bool LoadWav(Deserializer& source)
- bool LoadOggVorbis(Deserializer& source)
- bool LoadRaw(const String fileName)
- bool LoadWav(const String fileName)
- bool LoadOggVorbis(const String fileName)
- void SetSize(unsigned dataSize)
- void SetData(const void* data, unsigned dataSize)
- void SetFormat(unsigned frequency, bool sixteenBit, bool stereo)
- void SetLooped(bool enable)
- void SetLoop(unsigned repeatOffset, unsigned endOffset)
- void FixInterpolation()
- float GetLength() const
- unsigned GetDataSize() const
- unsigned GetSampleSize() const
- float GetFrequency() const
- unsigned GetIntFrequency() const
- bool IsLooped() const
- bool IsSixteenBit() const
- bool IsStereo() const
- bool IsCompressed() const

Properties:

- float length (readonly)
- unsigned dataSize (readonly)
- unsigned sampleSize (readonly)
- float frequency (readonly)
- int intFrequency (readonly)
- bool looped
- bool sixteenBit (readonly)
- bool stereo (readonly)
- bool compressed (readonly)

<a name="Class_SoundListener"></a>
### SoundListener : Component

<a name="Class_SoundSource"></a>
### SoundSource : Component

Methods:

- void Play(Sound* sound)
- void Play(Sound* sound, float frequency)
- void Play(Sound* sound, float frequency, float gain)
- void Play(Sound* sound, float frequency, float gain, float panning)
- void Stop()
- void SetSoundType(SoundType type)
- void SetFrequency(float frequency)
- void SetGain(float gain)
- void SetAttenuation(float attenuation)
- void SetPanning(float panning)
- void SetAutoRemove(bool enable)
- Sound* GetSound() const
- SoundType GetSoundType() const
- float GetTimePosition() const
- float GetFrequency() const
- float GetGain() const
- float GetAttenuation() const
- float GetPanning() const
- bool GetAutoRemove() const
- bool IsPlaying() const

Properties:

- Sound* sound (readonly)
- SoundType soundType
- float timePosition (readonly)
- float frequency
- float gain
- float attenuation
- float panning
- bool autoRemove
- bool playing (readonly)

<a name="Class_SoundSource3D"></a>
### SoundSource3D : SoundSource

Methods:

- void SetDistanceAttenuation(float nearDistance, float farDistance, float rolloffFactor)
- void SetAngleAttenuation(float innerAngle, float outerAngle)
- void SetNearDistance(float distance)
- void SetFarDistance(float distance)
- void SetInnerAngle(float angle)
- void SetOuterAngle(float angle)
- void SetRolloffFactor(float factor)
- void CalculateAttenuation()
- float GetNearDistance() const
- float GetFarDistance() const
- float GetInnerAngle() const
- float GetOuterAngle() const
- float RollAngleoffFactor() const

Properties:

- float nearDistance
- float farDistance
- float innerAngle
- float outerAngle
- float rolloffFactor

<a name="Class_Sphere"></a>
### Sphere


Methods:

- Sphere() (GC)
- Sphere* new()
- Sphere(const Sphere& sphere) (GC)
- Sphere* new(const Sphere& sphere)
- Sphere(const Vector3& center, float radius) (GC)
- Sphere* new(const Vector3& center, float radius)
- Sphere(const BoundingBox& box) (GC)
- Sphere* new(const BoundingBox& box)
- Sphere(const Frustum& frustum) (GC)
- Sphere* new(const Frustum& frustum)
- Sphere(const Polyhedron& poly) (GC)
- Sphere* new(const Polyhedron& poly)
- void delete()
- bool operator==(const Sphere& rhs) const
- void Define(const Sphere& sphere)
- void Define(const Vector3& center, float radius)
- void Define(const BoundingBox& box)
- void Define(const Frustum& frustum)
- void Define(const Polyhedron& poly)
- void Merge(const Vector3& point)
- void Merge(const BoundingBox& box)
- void Merge(const Frustum& frustum)
- void Merge(const Polyhedron& poly)
- void Merge(const Sphere& sphere)
- void Clear()
- Intersection IsInside(const Vector3& point) const
- Intersection IsInside(const Sphere& sphere) const
- Intersection IsInsideFast(const Sphere& sphere) const
- Intersection IsInside(const BoundingBox& box) const
- Intersection IsInsideFast(const BoundingBox& box) const
- float Distance(const Vector3& point) const

Properties:

- Vector3 center
- float radius
- bool defined

<a name="Class_Spline"></a>
### Spline


Methods:

- Spline() (GC)
- Spline* new()
- Spline(InterpolationMode mode) (GC)
- Spline* new(InterpolationMode mode)
- Spline(const Spline& rhs) (GC)
- Spline* new(const Spline& rhs)
- void delete()
- bool operator==(const Spline& rhs) const
- Variant GetPoint(float f) const
- Variant GetKnot(unsigned index) const
- void SetKnot(const Variant& knot, unsigned tolua_var_1)
- void AddKnot(const Variant& knot)
- void AddKnot(const Variant& knot, unsigned index)
- void RemoveKnot()
- void RemoveKnot(unsigned index)
- void Clear()

Properties:

- InterpolationMode interpolationMode

<a name="Class_SplinePath"></a>
### SplinePath : Component

Methods:

- void AddControlPoint(Node* point, unsigned index = M_MAX_UNSIGNED)
- void RemoveControlPoint(Node* point)
- void ClearControlPoints()
- Vector3 GetPoint(float factor) const
- InterpolationMode GetInterpolationMode() const
- Vector3 GetPosition() const
- void SetInterpolationMode(InterpolationMode mode)
- void SetPosition(float factor)
- void Move(float timeStep)
- void Reset()
- bool IsFinished() const

Properties:

- float speed
- Node* controlledNode

<a name="Class_Sprite"></a>
### Sprite : UIElement

Methods:

- Sprite() (GC)
- Sprite* new()
- void delete()
- void SetPosition(const Vector2& position)
- void SetPosition(float x, float y)
- void SetHotSpot(const IntVector2& hotSpot)
- void SetHotSpot(int x, int y)
- void SetScale(const Vector2& scale)
- void SetScale(float x, float y)
- void SetScale(float scale)
- void SetRotation(float angle)
- void SetTexture(Texture* texture)
- void SetImageRect(const IntRect& rect)
- void SetFullImageRect()
- void SetBlendMode(BlendMode mode)
- const Vector2& GetPosition() const
- const IntVector2& GetHotSpot() const
- const Vector2& GetScale() const
- float GetRotation() const
- Texture* GetTexture() const
- const IntRect& GetImageRect() const
- BlendMode GetBlendMode() const
- const Matrix3x4& GetTransform() const

Properties:

- Vector2& position
- IntVector2& hotSpot
- Vector2& scale
- float rotation
- Texture* texture
- IntRect& imageRect
- BlendMode blendMode
- Matrix3x4& transform (readonly)

<a name="Class_Sprite2D"></a>
### Sprite2D : Resource

Methods:

- void SetTexture(Texture2D* texture)
- void SetRectangle(const IntRect& rectangle)
- void SetHotSpot(const Vector2& hotSpot)
- void SetOffset(const IntVector2& offset)
- void SetSpriteSheet(SpriteSheet2D* spriteSheet)
- Texture2D* GetTexture() const
- const IntRect& GetRectangle() const
- const Vector2& GetHotSpot() const
- const IntVector2& GetOffset() const
- SpriteSheet2D* GetSpriteSheet() const

Properties:

- Texture2D* texture
- IntRect rectangle
- Vector2 hotSpot
- IntVector2 offset
- SpriteSheet2D* spriteSheet

<a name="Class_SpriteSheet2D"></a>
### SpriteSheet2D : Resource

Methods:

- Texture2D* GetTexture() const
- Sprite2D* GetSprite(const String name) const
- void DefineSprite(const String name, const IntRect& rectangle)
- void DefineSprite(const String name, const IntRect& rectangle, const Vector2& hotSpot)
- void DefineSprite(const String name, const IntRect& rectangle, const Vector2& hotSpot, const IntVector2& originSize)

<a name="Class_StaticModel"></a>
### StaticModel : Drawable

Methods:

- void SetModel(Model* model)
- void SetMaterial(Material* material)
- bool SetMaterial(unsigned index, Material* material)
- void SetOcclusionLodLevel(unsigned level)
- void ApplyMaterialList(const String fileName = String::EMPTY)
- Model* GetModel() const
- unsigned GetNumGeometries() const
- Material* GetMaterial(unsigned index = 0) const
- unsigned GetOcclusionLodLevel() const
- bool IsInside(const Vector3& point) const
- bool IsInsideLocal(const Vector3& point) const

Properties:

- Model* model
- Material* material
- BoundingBox& boundingBox (readonly)
- unsigned numGeometries (readonly)
- unsigned occlusionLodLevel

<a name="Class_StaticModelGroup"></a>
### StaticModelGroup : StaticModel

Methods:

- void AddInstanceNode(Node* node)
- void RemoveInstanceNode(Node* node)
- void RemoveAllInstanceNodes()
- unsigned GetNumInstanceNodes() const
- Node* GetInstanceNode(unsigned index) const

Properties:

- unsigned numInstanceNodes (readonly)

<a name="Class_StaticSprite2D"></a>
### StaticSprite2D : Drawable2D

Methods:

- void SetFlip(bool flipX, bool flipY)
- void SetFlipX(bool flipX)
- void SetFlipY(bool flipY)
- void SetColor(const Color& color)
- bool GetFlipX() const
- bool GetFlipY() const
- const Color& GetColor() const

Properties:

- bool flipX
- bool flipY
- Color& color

<a name="Class_StringHash"></a>
### StringHash


Methods:

- StringHash() (GC)
- StringHash* new()
- StringHash(const StringHash& rhs) (GC)
- StringHash* new(const StringHash& rhs)
- StringHash(unsigned value) (GC)
- StringHash* new(unsigned value)
- StringHash(const String str) (GC)
- StringHash* new(const String str)
- void delete()
- StringHash operator+(const StringHash& rhs) const
- bool operator==(const StringHash& rhs) const
- bool operator<(const StringHash& rhs) const
- bool operatorbool() const
- unsigned Value() const
- String ToString() const
- unsigned ToHash() const
- unsigned Calculate(const char* str)

Properties:

- const StringHash ZERO
- unsigned value (readonly)

<a name="Class_Technique"></a>
### Technique : Resource

Methods:

- bool HasPass(const StringHash type) const
- Pass* GetPass(const StringHash type) const
- Pass* GetSupportedPass(const StringHash type) const
- bool IsSupported() const
- bool IsSM3() const
- bool IsDesktop() const
- unsigned GetNumPasses() const
- const Vector<StringHash>& GetPassTypes() const
- const PODVector<Pass*>& GetPasses() const

Properties:

- bool supported (readonly)
- bool SM3 (readonly)
- bool desktop (readonly)
- unsigned numPasses (readonly)

<a name="Class_Terrain"></a>
### Terrain : Component

Methods:

- void SetPatchSize(int size)
- void SetSpacing(const Vector3& spacing)
- void SetSmoothing(bool enable)
- bool SetHeightMap(Image* image)
- void SetMaterial(Material* material)
- void SetDrawDistance(float distance)
- void SetShadowDistance(float distance)
- void SetLodBias(float bias)
- void SetViewMask(unsigned mask)
- void SetLightMask(unsigned mask)
- void SetShadowMask(unsigned mask)
- void SetZoneMask(unsigned mask)
- void SetMaxLights(unsigned num)
- void SetCastShadows(bool enable)
- void SetOccluder(bool enable)
- void SetOccludee(bool enable)
- void ApplyHeightMap()
- int GetPatchSize() const
- const Vector3& GetSpacing() const
- const IntVector2& GetNumVertices() const
- const IntVector2& GetNumPatches() const
- bool GetSmoothing() const
- Image* GetHeightMap() const
- Material* GetMaterial() const
- TerrainPatch* GetPatch(unsigned index) const
- TerrainPatch* GetPatch(int x, int z) const
- float GetHeight(const Vector3& worldPosition) const
- Vector3 GetNormal(const Vector3& worldPosition) const
- IntVector2 WorldToHeightMap(const Vector3& worldPosition) const
- SharedArrayPtr<float> GetHeightData() const
- float GetDrawDistance() const
- float GetShadowDistance() const
- float GetLodBias() const
- unsigned GetViewMask() const
- unsigned GetLightMask() const
- unsigned GetShadowMask() const
- unsigned GetZoneMask() const
- unsigned GetMaxLights() const
- bool IsVisible() const
- bool GetCastShadows() const
- bool IsOccluder() const
- bool IsOccludee() const

Properties:

- int patchSize
- Vector3& spacing
- IntVector2& numVertices (readonly)
- IntVector2& numPatches (readonly)
- bool smoothing
- Image* heightMap
- Material* material
- float drawDistance
- float shadowDistance
- float lodBias
- unsigned viewMask
- unsigned lightMask
- unsigned shadowMask
- unsigned zoneMask
- unsigned maxLights
- bool visible (readonly)
- bool castShadows
- bool occluder
- bool occludee

<a name="Class_TerrainPatch"></a>
### TerrainPatch : Drawable

Methods:

- void SetOwner(Terrain* terrain)
- void SetNeighbors(TerrainPatch* north, TerrainPatch* south, TerrainPatch* west, TerrainPatch* east)
- void SetMaterial(Material* material)
- void SetBoundingBox(const BoundingBox& box)
- void SetCoordinates(const IntVector2& coordinates)
- void SetOcclusionOffset(float offset)
- void ResetLod()
- Geometry* GetGeometry() const
- Geometry* GetMaxLodGeometry() const
- Geometry* GetMinLodGeometry() const
- VertexBuffer* GetVertexBuffer() const
- Terrain* GetOwner() const
- TerrainPatch* GetNorthPatch() const
- TerrainPatch* GetSouthPatch() const
- TerrainPatch* GetWestPatch() const
- TerrainPatch* GetEastPatch() const
- const IntVector2& GetCoordinates() const
- unsigned GetLodLevel() const
- float GetOcclusionOffset() const

Properties:

- Geometry* geometry (readonly)
- Geometry* maxLodGeometry (readonly)
- Geometry* minLodGeometry (readonly)
- VertexBuffer* vertexBuffer (readonly)
- Terrain* owner
- TerrainPatch* northPatch (readonly)
- TerrainPatch* southPatch (readonly)
- TerrainPatch* westPatch (readonly)
- TerrainPatch* eastPatch (readonly)
- BoundingBox& boundingBox
- IntVector2& coordinates
- unsigned lodLevel (readonly)
- float occlusionOffset

<a name="Class_Text"></a>
### Text : UIElement

Methods:

- Text() (GC)
- Text* new()
- void delete()
- bool SetFont(const String fontName, int size = DEFAULT_FONT_SIZE)
- bool SetFont(Font* font, int size = DEFAULT_FONT_SIZE)
- void SetText(const String text)
- void SetTextAlignment(HorizontalAlignment align)
- void SetRowSpacing(float spacing)
- void SetWordwrap(bool enable)
- void SetSelection(unsigned start, unsigned length = M_MAX_UNSIGNED)
- void ClearSelection()
- void SetSelectionColor(const Color& color)
- void SetHoverColor(const Color& color)
- void SetTextEffect(TextEffect textEffect)
- void SetEffectColor(const Color& effectColor)
- Font* GetFont() const
- int GetFontSize() const
- const String GetText() const
- HorizontalAlignment GetTextAlignment() const
- float GetRowSpacing() const
- bool GetWordwrap() const
- unsigned GetSelectionStart() const
- unsigned GetSelectionLength() const
- const Color& GetSelectionColor() const
- const Color& GetHoverColor() const
- TextEffect GetTextEffect() const
- const Color& GetEffectColor() const
- int GetRowHeight() const
- unsigned GetNumRows() const
- unsigned GetNumChars() const
- int GetRowWidth(unsigned index) const
- IntVector2 GetCharPosition(unsigned index)
- IntVector2 GetCharSize(unsigned index)
- void SetEffectDepthBias(float bias)
- float GetEffectDepthBias() const

Properties:

- Font* font
- int fontSize (readonly)
- String text
- HorizontalAlignment textAlignment
- float rowSpacing
- bool wordwrap
- unsigned selectionStart (readonly)
- unsigned selectionLength (readonly)
- Color& selectionColor
- Color& hoverColor
- TextEffect textEffect
- Color& effectColor
- int rowHeight (readonly)
- unsigned numRows (readonly)
- unsigned numChars (readonly)

<a name="Class_Text3D"></a>
### Text3D : Drawable

Methods:

- Text3D() (GC)
- Text3D* new()
- void delete()
- bool SetFont(const String fontName, int size = DEFAULT_FONT_SIZE)
- bool SetFont(Font* font, int size = DEFAULT_FONT_SIZE)
- void SetMaterial(Material* material)
- void SetText(const String text)
- void SetAlignment(HorizontalAlignment hAlign, VerticalAlignment vAlign)
- void SetHorizontalAlignment(HorizontalAlignment align)
- void SetVerticalAlignment(VerticalAlignment align)
- void SetTextAlignment(HorizontalAlignment align)
- void SetRowSpacing(float spacing)
- void SetWordwrap(bool enable)
- void SetTextEffect(TextEffect textEffect)
- void SetEffectColor(const Color& effectColor)
- void SetEffectDepthBias(float bias)
- void SetWidth(int width)
- void SetColor(const Color& color)
- void SetColor(Corner corner, const Color& color)
- void SetOpacity(float opacity)
- void SetFaceCameraMode(FaceCameraMode mode)
- Font* GetFont() const
- Material* GetMaterial() const
- int GetFontSize() const
- const String GetText() const
- HorizontalAlignment GetTextAlignment() const
- HorizontalAlignment GetHorizontalAlignment() const
- VerticalAlignment GetVerticalAlignment() const
- float GetRowSpacing() const
- bool GetWordwrap() const
- TextEffect GetTextEffect() const
- const Color& GetEffectColor() const
- float GetEffectDepthBias() const
- int GetWidth() const
- int GetRowHeight() const
- unsigned GetNumRows() const
- unsigned GetNumChars() const
- int GetRowWidth(unsigned index) const
- IntVector2 GetCharPosition(unsigned index)
- IntVector2 GetCharSize(unsigned index)
- const Color& GetColor(Corner corner) const
- float GetOpacity() const
- FaceCameraMode GetFaceCameraMode() const

Properties:

- Font* font
- Material* material
- int fontSize (readonly)
- String text
- HorizontalAlignment textAlignment
- HorizontalAlignment horizontalAlignment
- VerticalAlignment verticalAlignment
- float rowSpacing
- bool wordwrap
- TextEffect textEffect
- Color& effectColor
- float effectDepthBias
- int width
- Color& color
- int rowHeight (readonly)
- unsigned numRows (readonly)
- unsigned numChars (readonly)
- float opacity
- FaceCameraMode faceCameraMode

<a name="Class_Texture"></a>
### Texture : Resource

Methods:

- void SetNumLevels(unsigned levels)
- void SetFilterMode(TextureFilterMode filter)
- void SetAddressMode(TextureCoordinate coord, TextureAddressMode address)
- void SetBorderColor(const Color& color)
- void SetSRGB(bool enable)
- void SetBackupTexture(Texture* texture)
- void SetMipsToSkip(int quality, int mips)
- unsigned GetFormat() const
- bool IsCompressed() const
- unsigned GetLevels() const
- int GetWidth() const
- int GetHeight() const
- TextureFilterMode GetFilterMode() const
- TextureAddressMode GetAddressMode(TextureCoordinate coord) const
- const Color& GetBorderColor() const
- bool GetSRGB() const
- Texture* GetBackupTexture() const
- int GetMipsToSkip(int quality) const
- int GetLevelWidth(unsigned level) const
- int GetLevelHeight(unsigned level) const
- TextureUsage GetUsage() const
- unsigned GetDataSize(int width, int height) const
- unsigned GetRowDataSize(int width) const

Properties:

- unsigned format (readonly)
- bool compressed (readonly)
- unsigned levels (readonly)
- int width (readonly)
- int height (readonly)
- TextureFilterMode filterMode
- Color& borderColor
- bool sRGB
- Texture* backupTexture
- TextureUsage usage (readonly)

<a name="Class_Texture2D"></a>
### Texture2D : Texture

Methods:

- Texture2D() (GC)
- Texture2D* new()
- void delete()
- bool SetSize(int width, int height, unsigned format, TextureUsage usage = TEXTURE_STATIC)
- bool SetData(Image* image, bool useAlpha = false)
- RenderSurface* GetRenderSurface() const

Properties:

- RenderSurface* renderSurface (readonly)

<a name="Class_TextureCube"></a>
### TextureCube : Texture

Methods:

- RenderSurface* GetRenderSurface(CubeMapFace face) const

<a name="Class_TextureFrame"></a>
### TextureFrame


Methods:

- TextureFrame() (GC)
- TextureFrame* new()
- void delete()

Properties:

- Rect uv
- float time

<a name="Class_Tile2D"></a>
### Tile2D


Methods:

- int GetGid() const
- Sprite2D* GetSprite() const
- bool HasProperty(const String name) const
- const String GetProperty(const String name) const

Properties:

- int gid (readonly)
- Sprite2D* sprite (readonly)

<a name="Class_TileMap2D"></a>
### TileMap2D : Component

Methods:

- void SetTmxFile(TmxFile2D* tmxFile)
- TmxFile2D* GetTmxFile() const
- const TileMapInfo2D& GetInfo() const
- unsigned GetNumLayers() const
- TileMapLayer2D* GetLayer(unsigned index) const
- Vector2 TileIndexToPosition(int x, int y) const
- bool PositionToTileIndex(const Vector2& position, int x = 0, int y = 0) const

Properties:

- TmxFile2D* tmxFile
- TileMapInfo2D& info (readonly)
- unsigned numLayers (readonly)

<a name="Class_TileMapInfo2D"></a>
### TileMapInfo2D


Methods:

- float GetMapWidth() const
- float GetMapHeight() const

Properties:

- Orientation2D orientation
- int width
- int height
- float tileWidth
- float tileHeight
- float mapWidth (readonly)
- float mapHeight (readonly)

<a name="Class_TileMapLayer2D"></a>
### TileMapLayer2D : Component

Methods:

- void SetDrawOrder(int drawOrder)
- void SetVisible(bool visible)
- int GetDrawOrder() const
- bool IsVisible() const
- bool HasProperty(const String name) const
- const String GetProperty(const String name) const
- TileMapLayerType2D GetLayerType() const
- int GetWidth() const
- int GetHeight() const
- Node* GetTileNode(int x, int y) const
- Tile2D* GetTile(int x, int y) const
- unsigned GetNumObjects() const
- TileMapObject2D* GetObject(unsigned index) const
- Node* GetObjectNode(unsigned index) const
- Node* GetImageNode() const

Properties:

- int drawOrder (readonly)
- bool visible (readonly)
- TileMapLayerType2D layerType (readonly)
- int width (readonly)
- int height (readonly)
- unsigned numObjects (readonly)
- Node* imageNode (readonly)

<a name="Class_TileMapObject2D"></a>
### TileMapObject2D


Methods:

- TileMapObjectType2D GetObjectType() const
- const String GetName() const
- const String GetType() const
- const Vector2& GetPosition() const
- const Vector2& GetSize() const
- unsigned GetNumPoints() const
- const Vector2& GetPoint(unsigned index) const
- int GetTileGid() const
- Sprite2D* GetTileSprite() const
- bool HasProperty(const String name) const
- const String GetProperty(const String name) const

Properties:

- TileMapObjectType2D objectType (readonly)
- String name (readonly)
- String type (readonly)
- Vector2 position (readonly)
- Vector2 size (readonly)
- unsigned numPoints (readonly)
- int tileGid (readonly)
- Sprite2D* tileSprite (readonly)

<a name="Class_Time"></a>
### Time : Object

Methods:

- unsigned GetFrameNumber() const
- float GetTimeStep() const
- unsigned GetTimerPeriod() const
- float GetElapsedTime()
- unsigned GetSystemTime()
- unsigned GetTimeSinceEpoch()
- String GetTimeStamp()
- void Sleep(unsigned mSec)

Properties:

- unsigned frameNumber (readonly)
- float timeStep (readonly)
- unsigned timerPeriod (readonly)
- float elapsedTime (readonly)

<a name="Class_TmxFile2D"></a>
### TmxFile2D : Resource

<a name="Class_ToolTip"></a>
### ToolTip : UIElement

Methods:

- ToolTip() (GC)
- ToolTip* new()
- void delete()
- void SetDelay(float delay)
- float GetDelay() const

Properties:

- float delay

<a name="Class_TouchState"></a>
### TouchState


Methods:

- UIElement* GetTouchedElement()

Properties:

- int touchID
- IntVector2 position
- IntVector2 lastPosition
- IntVector2 delta
- float pressure
- UIElement* touchedElement (readonly)

<a name="Class_UI"></a>
### UI : Object

Methods:

- void SetCursor(Cursor* cursor)
- void SetFocusElement(UIElement* element, bool byKey = false)
- bool SetModalElement(UIElement* modalElement, bool enable)
- void Clear()
- void Update(float timeStep)
- void RenderUpdate()
- void Render()
- void DebugDraw(UIElement* element)
- UIElement* LoadLayout(File* source, XMLFile* styleFile = 0)
- UIElement* LoadLayout(const String fileName, XMLFile* styleFile = 0)
- UIElement* LoadLayout(XMLFile* file, XMLFile* styleFile = 0)
- bool SaveLayout(Serializer& dest, UIElement* element)
- void SetClipboardText(const String text)
- void SetDoubleClickInterval(float interval)
- void SetDragBeginInterval(float interval)
- void SetDragBeginDistance(int pixels)
- void SetDefaultToolTipDelay(float delay)
- void SetMaxFontTextureSize(int size)
- void SetNonFocusedMouseWheel(bool nonFocusedMouseWheel)
- void SetUseSystemClipboard(bool enable)
- void SetUseScreenKeyboard(bool enable)
- void SetUseMutableGlyphs(bool enable)
- void SetForceAutoHint(bool enable)
- UIElement* GetRoot() const
- UIElement* GetRootModalElement() const
- Cursor* GetCursor() const
- IntVector2 GetCursorPosition() const
- UIElement* GetElementAt(const IntVector2& position, bool enabledOnly = true)
- UIElement* GetElementAt(int x, int y, bool enabledOnly = true)
- UIElement* GetFocusElement() const
- UIElement* GetFrontElement() const
- UIElement* GetDragElement(unsigned index)
- const String GetClipboardText() const
- float GetDoubleClickInterval() const
- float GetDragBeginInterval() const
- int GetDragBeginDistance() const
- float GetDefaultToolTipDelay() const
- int GetMaxFontTextureSize() const
- bool IsNonFocusedMouseWheel() const
- bool GetUseSystemClipboard() const
- bool GetUseScreenKeyboard() const
- bool GetUseMutableGlyphs() const
- bool GetForceAutoHint() const
- bool HasModalElement() const
- bool IsDragging() const

Properties:

- UIElement* root (readonly)
- UIElement* rootModalElement (readonly)
- Cursor* cursor
- IntVector2 cursorPosition (readonly)
- UIElement* focusElement (readonly)
- UIElement* frontElement (readonly)
- String clipboardText
- float doubleClickInterval
- float dragBeginInterval
- int dragBeginDistance
- float defaultToolTipDelay
- int maxFontTextureSize
- bool nonFocusedMouseWheel
- bool useSystemClipboard
- bool useScreenKeyboard
- bool useMutableGlyphs
- bool forceAutoHint
- bool modalElement (readonly)

<a name="Class_UIElement"></a>
### UIElement : Animatable

Methods:

- UIElement() (GC)
- UIElement* new()
- void delete()
- const IntVector2& GetScreenPosition() const
- bool LoadXML(Deserializer& source)
- bool SaveXML(Serializer& dest) const
- bool LoadXML(const String fileName)
- bool SaveXML(const String fileName) const
- bool FilterAttributes(XMLElement& dest) const
- void SetName(const String name)
- void SetPosition(const IntVector2& position)
- void SetPosition(int x, int y)
- void SetSize(const IntVector2& size)
- void SetSize(int width, int height)
- void SetWidth(int width)
- void SetHeight(int height)
- void SetMinSize(const IntVector2& minSize)
- void SetMinSize(int width, int height)
- void SetMinWidth(int width)
- void SetMinHeight(int height)
- void SetMaxSize(const IntVector2& maxSize)
- void SetMaxSize(int width, int height)
- void SetMaxWidth(int width)
- void SetMaxHeight(int height)
- void SetFixedSize(const IntVector2& size)
- void SetFixedSize(int width, int height)
- void SetFixedWidth(int width)
- void SetFixedHeight(int height)
- void SetAlignment(HorizontalAlignment hAlign, VerticalAlignment vAlign)
- void SetHorizontalAlignment(HorizontalAlignment align)
- void SetVerticalAlignment(VerticalAlignment align)
- void SetClipBorder(const IntRect& rect)
- void SetColor(const Color& color)
- void SetColor(Corner corner, const Color& color)
- void SetPriority(int priority)
- void SetOpacity(float opacity)
- void SetBringToFront(bool enable)
- void SetBringToBack(bool enable)
- void SetClipChildren(bool enable)
- void SetSortChildren(bool enable)
- void SetUseDerivedOpacity(bool enable)
- void SetEnabled(bool enable)
- void SetDeepEnabled(bool enable)
- void ResetDeepEnabled()
- void SetEnabledRecursive(bool enable)
- void SetEditable(bool enable)
- void SetFocus(bool enable)
- void SetSelected(bool enable)
- void SetVisible(bool enable)
- void SetFocusMode(FocusMode mode)
- void SetDragDropMode(unsigned mode)
- bool SetStyle(const String styleName, XMLFile* file = 0)
- bool SetStyle(const XMLElement& element)
- bool SetStyleAuto(XMLFile* file = 0)
- void SetDefaultStyle(XMLFile* style)
- void SetLayout(LayoutMode mode, int spacing = 0)
- void SetLayout(LayoutMode mode, int spacing, const IntRect& border)
- void SetLayoutMode(LayoutMode mode)
- void SetLayoutSpacing(int spacing)
- void SetLayoutBorder(const IntRect& border)
- void SetLayoutFlexScale(const Vector2& scale)
- void SetIndent(int indent)
- void SetIndentSpacing(int indentSpacing)
- void UpdateLayout()
- void DisableLayoutUpdate()
- void EnableLayoutUpdate()
- void BringToFront()
- UIElement* CreateChild(const String type, const String name = String::EMPTY, unsigned index = M_MAX_UNSIGNED)
- void AddChild(UIElement* element)
- void InsertChild(unsigned index, UIElement* element)
- void RemoveChild(UIElement* element, unsigned index = 0)
- void RemoveChildAtIndex(unsigned index)
- void RemoveAllChildren()
- void Remove()
- unsigned FindChild(UIElement* element) const
- void SetParent(UIElement* parent, unsigned index = M_MAX_UNSIGNED)
- void SetVar(StringHash key, const Variant& value)
- void SetInternal(bool enable)
- void SetTraversalMode(TraversalMode traversalMode)
- void SetElementEventSender(bool flag)
- const String GetName() const
- const IntVector2& GetPosition() const
- const IntVector2& GetSize() const
- int GetWidth() const
- int GetHeight() const
- const IntVector2& GetMinSize() const
- int GetMinWidth() const
- int GetMinHeight() const
- const IntVector2& GetMaxSize() const
- int GetMaxWidth() const
- int GetMaxHeight() const
- bool IsFixedSize() const
- bool IsFixedWidth() const
- bool IsFixedHeight() const
- const IntVector2& GetChildOffset() const
- HorizontalAlignment GetHorizontalAlignment() const
- VerticalAlignment GetVerticalAlignment() const
- const IntRect& GetClipBorder() const
- const Color& GetColor(Corner corner) const
- int GetPriority() const
- float GetOpacity() const
- float GetDerivedOpacity() const
- bool GetBringToFront() const
- bool GetBringToBack() const
- bool GetClipChildren() const
- bool GetSortChildren() const
- bool GetUseDerivedOpacity() const
- bool HasFocus() const
- bool IsEnabled() const
- bool IsEnabledSelf() const
- bool IsEditable() const
- bool IsSelected() const
- bool IsVisible() const
- bool IsHovering() const
- bool IsInternal() const
- bool HasColorGradient() const
- FocusMode GetFocusMode() const
- unsigned GetDragDropMode() const
- const String GetAppliedStyle() const
- XMLFile* GetDefaultStyle(bool recursiveUp = true) const
- LayoutMode GetLayoutMode() const
- int GetLayoutSpacing() const
- const IntRect& GetLayoutBorder() const
- const Vector2& GetLayoutFlexScale() const
- unsigned GetNumChildren(bool recursive = false) const
- int GetDragButtonCombo() const
- unsigned GetDragButtonCount() const
- UIElement* GetChild(const String name, bool recursive = false) const
- UIElement* GetChild(unsigned index) const
- UIElement* GetParent() const
- UIElement* GetRoot() const
- const Color& GetDerivedColor() const
- const Variant& GetVar(StringHash key) const
- const VariantMap& GetVars() const
- IntVector2 ScreenToElement(const IntVector2& screenPosition)
- IntVector2 ElementToScreen(const IntVector2& position)
- bool IsInside(IntVector2 position, bool isScreen)
- bool IsInsideCombined(IntVector2 position, bool isScreen)
- IntRect GetCombinedScreenRect()
- void SortChildren()
- int GetIndent() const
- int GetIndentSpacing() const
- int GetIndentWidth() const
- void SetChildOffset(const IntVector2& offset)
- void SetHovering(bool enable)
- const Color& GetColor() const
- TraversalMode GetTraversalMode() const
- bool IsElementEventSender() const
- UIElement* GetElementEventSender() const

Properties:

- IntVector2& screenPosition (readonly)
- String name
- IntVector2& position
- IntVector2 size
- int width
- int height
- IntVector2 minSize
- int minWidth
- int minHeight
- IntVector2 maxSize
- int maxWidth
- int maxHeight
- bool fixedSize (readonly)
- bool fixedWidth (readonly)
- bool fixedHeight (readonly)
- IntVector2& childOffset
- HorizontalAlignment horizontalAlignment
- VerticalAlignment verticalAlignment
- IntRect clipBorder
- Color& color
- int priority
- float opacity
- float derivedOpacity (readonly)
- bool bringToFront
- bool bringToBack
- bool clipChildren
- bool sortChildren
- bool useDerivedOpacity
- bool focus
- bool enabled
- bool enabledSelf (readonly)
- bool editable
- bool selected
- bool visible
- bool hovering
- bool internal
- bool colorGradient (readonly)
- FocusMode focusMode
- unsigned dragDropMode
- String style
- XMLFile* defaultStyle
- LayoutMode layoutMode
- int layoutSpacing
- IntRect& layoutBorder
- Vector2& layoutFlexScale
- unsigned numChildren (readonly)
- UIElement* parent
- UIElement* root (readonly)
- Color& derivedColor (readonly)
- IntRect combinedScreenRect (readonly)
- int indent
- int indentSpacing
- int indentWidth (readonly)
- TraversalMode traversalMode
- bool elementEventSender

<a name="Class_ValueAnimation"></a>
### ValueAnimation : Resource

Methods:

- ValueAnimation() (GC)
- ValueAnimation* new()
- void delete()
- void SetInterpolationMethod(InterpMethod method)
- void SetSplineTension(float tension)
- void SetValueType(VariantType valueType)
- bool SetKeyFrame(float time, const Variant& value)
- void SetEventFrame(float time, const StringHash& eventType)
- void SetEventFrame(float time, const StringHash& eventType, const VariantMap& eventData)
- InterpMethod GetInterpolationMethod() const
- float GetSplineTension() const
- VariantType GetValueType() const

Properties:

- InterpMethod interpolationMethod
- float splineTension
- VariantType valueType

<a name="Class_Variant"></a>
### Variant


Methods:

- Variant() (GC)
- Variant* new()
- Variant(int value) (GC)
- Variant* new(int value)
- Variant(unsigned value) (GC)
- Variant* new(unsigned value)
- Variant(const StringHash& value) (GC)
- Variant* new(const StringHash& value)
- Variant(bool value) (GC)
- Variant* new(bool value)
- Variant(float value) (GC)
- Variant* new(float value)
- Variant(const Vector2& value) (GC)
- Variant* new(const Vector2& value)
- Variant(const Vector3& value) (GC)
- Variant* new(const Vector3& value)
- Variant(const Vector4& value) (GC)
- Variant* new(const Vector4& value)
- Variant(const Quaternion& value) (GC)
- Variant* new(const Quaternion& value)
- Variant(const Color& value) (GC)
- Variant* new(const Color& value)
- Variant(const String value) (GC)
- Variant* new(const String value)
- Variant(const char* value) (GC)
- Variant* new(const char* value)
- Variant(const ResourceRef& value) (GC)
- Variant* new(const ResourceRef& value)
- Variant(const ResourceRefList& value) (GC)
- Variant* new(const ResourceRefList& value)
- Variant(const IntRect& value) (GC)
- Variant* new(const IntRect& value)
- Variant(const IntVector2& value) (GC)
- Variant* new(const IntVector2& value)
- Variant(const Matrix3& value) (GC)
- Variant* new(const Matrix3& value)
- Variant(const Matrix3x4& value) (GC)
- Variant* new(const Matrix3x4& value)
- Variant(const Matrix4& value) (GC)
- Variant* new(const Matrix4& value)
- Variant(const String type, const String value) (GC)
- Variant* new(const String type, const String value)
- Variant(VariantType type, const String value) (GC)
- Variant* new(VariantType type, const String value)
- Variant(VariantType type, const char* value) (GC)
- Variant* new(VariantType type, const char* value)
- Variant(const Variant& value) (GC)
- Variant* new(const Variant& value)
- void delete()
- void Clear()
- bool operator==(const Variant& rhs) const
- bool operator==(int rhs) const
- bool operator==(unsigned rhs) const
- bool operator==(bool rhs) const
- bool operator==(float rhs) const
- bool operator==(const Vector2& rhs)
- bool operator==(const Vector3& rhs) const
- bool operator==(const Vector4& rhs) const
- bool operator==(const Quaternion& rhs) const
- bool operator==(const Color& rhs) const
- bool operator==(const String rhs) const
- bool operator==(const ResourceRef& rhs) const
- bool operator==(const ResourceRefList& rhs) const
- bool operator==(const IntRect& rhs) const
- bool operator==(const IntVector2& rhs) const
- bool operator==(const StringHash& rhs) const
- bool operator==(const Matrix3& rhs) const
- bool operator==(const Matrix3x4& rhs) const
- bool operator==(const Matrix4& rhs) const
- void SetInt(int value)
- void SetUint(unsigned value)
- void SetStringHash(const StringHash& value)
- void SetBool(bool value)
- void SetFloat(float value)
- void SetVector2(const Vector2& value)
- void SetVector3(const Vector3& value)
- void SetVector4(const Vector4& value)
- void SetQuaternion(const Quaternion& value)
- void SetColor(const Color& value)
- void SetString(const String value)
- void SetBuffer(const VectorBuffer& value)
- void SetResourceRef(const ResourceRef& value)
- void SetResourceRefList(const ResourceRefList& value)
- void SetIntRect(const IntRect& value)
- void SetIntVector2(const IntVector2& value)
- void SetMatrix3(const Matrix3& value)
- void SetMatrix3x4(const Matrix3x4& value)
- void SetMatrix4(const Matrix4& value)
- int GetInt() const
- int GetUInt() const
- StringHash GetStringHash()
- bool GetBool() const
- float GetFloat() const
- const Vector2& GetVector2() const
- const Vector3& GetVector3() const
- const Vector4& GetVector4() const
- const Quaternion& GetQuaternion() const
- const Color& GetColor() const
- const String GetString() const
- VectorBuffer GetBuffer() const
- const ResourceRef& GetResourceRef() const
- const ResourceRefList& GetResourceRefList() const
- const IntRect& GetIntRect() const
- const IntVector2& GetIntVector2() const
- const Matrix3& GetMatrix3() const
- const Matrix3x4& GetMatrix3x4() const
- const Matrix4& GetMatrix4() const
- VariantType GetType() const
- String GetTypeName() const
- String ToString() const
- bool IsZero() const
- bool IsEmpty() const

Properties:

- VariantType type (readonly)
- String typeName (readonly)
- bool zero (readonly)
- bool empty (readonly)

<a name="Class_VariantMap"></a>
### VariantMap


Methods:

- VariantMap() (GC)
- VariantMap* new()
- void delete()
- void SetInt(const String key, int value)
- void SetUInt(const String key, unsigned value)
- void SetStringHash(const String key, const StringHash& value)
- void SetBool(const String key, bool value)
- void SetFloat(const String key, float value)
- void SetVector2(const String key, const Vector2 value)
- void SetVector3(const String key, const Vector3 value)
- void SetVector4(const String key, const Vector4 value)
- void SetQuaternion(const String key, const Quaternion value)
- void SetColor(const String key, const Color value)
- void SetString(const String key, const String value)
- void SetBuffer(const String key, const VectorBuffer& value)
- void SetResourceRef(const String key, const ResourceRef value)
- void SetResourceRefList(const String key, const ResourceRefList value)
- void SetIntRect(const String key, const IntRect value)
- void SetIntVector2(const String key, const IntVector2 value)
- void SetPtr(const String key, void* value)
- void SetMatrix3(const String key, const Matrix3 value)
- void SetMatrix3x4(const String key, const Matrix3x4 value)
- void SetMatrix4(const String key, const Matrix4 value)
- int GetInt(const String key)
- int GetUInt(const String key)
- StringHash GetStringHash(const String key)
- bool GetBool(const String key)
- float GetFloat(const String key)
- const Vector2& GetVector2(const String key)
- const Vector3& GetVector3(const String key)
- const Vector4& GetVector4(const String key)
- const Quaternion& GetQuaternion(const String key)
- const Color& GetColor(const String key)
- const String GetString(const String key)
- VectorBuffer GetBuffer(const String key)
- const ResourceRef& GetResourceRef(const String key)
- const ResourceRefList& GetResourceRefList(const String key)
- const IntRect& GetIntRect(const String key)
- const IntVector2& GetIntVector2(const String key)
- const void* GetPtr(const String type, const String key)
- const Matrix3& GetMatrix3(const String key)
- const Matrix3x4& GetMatrix3x4(const String key)
- const Matrix4& GetMatrix4(const String key)

<a name="Class_Vector2"></a>
### Vector2


Methods:

- Vector2() (GC)
- Vector2* new()
- Vector2(const Vector2& vector) (GC)
- Vector2* new(const Vector2& vector)
- Vector2(float x, float y) (GC)
- Vector2* new(float x, float y)
- void delete()
- bool operator==(const Vector2& rhs) const
- Vector2 operator+(const Vector2& rhs) const
- Vector2 operator-() const
- Vector2 operator-(const Vector2& rhs) const
- Vector2 operator*(float rhs) const
- Vector2 operator*(const Vector2& rhs) const
- Vector2 operator/(float rhs) const
- Vector2 operator/(const Vector2& rhs) const
- Vector2 operator/(const Vector2& rhs) const
- void Normalize()
- float Length() const
- float LengthSquared() const
- float DotProduct(const Vector2& rhs) const
- float AbsDotProduct(const Vector2& rhs) const
- Vector2 Abs() const
- Vector2 Lerp(const Vector2& rhs, float t) const
- bool Equals(const Vector2& rhs) const
- bool IsNaN() const
- Vector2 Normalized() const
- String ToString() const

Properties:

- float x
- float y
- const Vector2 ZERO
- const Vector2 LEFT
- const Vector2 RIGHT
- const Vector2 UP
- const Vector2 DOWN
- const Vector2 ONE

<a name="Class_Vector3"></a>
### Vector3


Methods:

- Vector3() (GC)
- Vector3* new()
- Vector3(const Vector3& vector) (GC)
- Vector3* new(const Vector3& vector)
- Vector3(const Vector2& vector, float z) (GC)
- Vector3* new(const Vector2& vector, float z)
- Vector3(const Vector2& vector) (GC)
- Vector3* new(const Vector2& vector)
- Vector3(float x, float y, float z) (GC)
- Vector3* new(float x, float y, float z)
- Vector3(float x, float y) (GC)
- Vector3* new(float x, float y)
- void delete()
- bool operator==(const Vector3& rhs) const
- Vector3 operator+(const Vector3& rhs) const
- Vector3 operator-() const
- Vector3 operator-(const Vector3& rhs) const
- Vector3 operator*(float rhs) const
- Vector3 operator*(const Vector3& rhs) const
- Vector3 operator/(float rhs) const
- Vector3 operator/(const Vector3& rhs) const
- void Normalize()
- float Length() const
- float LengthSquared() const
- float DotProduct(const Vector3& rhs) const
- float AbsDotProduct(const Vector3& rhs) const
- Vector3 CrossProduct(const Vector3& rhs) const
- Vector3 Abs() const
- Vector3 Lerp(const Vector3& rhs, float t) const
- bool Equals(const Vector3& rhs) const
- bool IsNaN() const
- float Angle(const Vector3& rhs) const
- Vector3 Normalized() const
- String ToString() const

Properties:

- float x
- float y
- float z
- const Vector3 ZERO
- const Vector3 LEFT
- const Vector3 RIGHT
- const Vector3 UP
- const Vector3 DOWN
- const Vector3 FORWARD
- const Vector3 BACK
- const Vector3 ONE

<a name="Class_Vector4"></a>
### Vector4


Methods:

- Vector4() (GC)
- Vector4* new()
- Vector4(const Vector4& vector) (GC)
- Vector4* new(const Vector4& vector)
- Vector4(const Vector3& vector, float w) (GC)
- Vector4* new(const Vector3& vector, float w)
- Vector4(float x, float y, float z, float w) (GC)
- Vector4* new(float x, float y, float z, float w)
- void delete()
- bool operator==(const Vector4& rhs) const
- Vector4 operator+(const Vector4& rhs) const
- Vector4 operator-() const
- Vector4 operator-(const Vector4& rhs) const
- Vector4 operator*(float rhs) const
- Vector4 operator*(const Vector4& rhs) const
- Vector4 operator/(float rhs) const
- Vector4 operator/(const Vector4& rhs) const
- Vector4 operator/(const Vector4& rhs) const
- float DotProduct(const Vector4& rhs) const
- float AbsDotProduct(const Vector4& rhs) const
- Vector4 Abs() const
- Vector4 Lerp(const Vector4& rhs, float t) const
- bool Equals(const Vector4& rhs) const
- bool IsNaN() const
- String ToString() const

Properties:

- float x
- float y
- float z
- float w
- const Vector4 ZERO
- const Vector4 ONE

<a name="Class_VectorBuffer"></a>
### VectorBuffer


Methods:

- VectorBuffer() (GC)
- VectorBuffer* new()
- VectorBuffer(Deserializer& source, unsigned size) (GC)
- VectorBuffer* new(Deserializer& source, unsigned size)
- void delete()
- void SetData(Deserializer& source, unsigned size)
- void Clear()
- void Resize(unsigned size)
- const void* GetData() const
- void* GetModifiableData()
- VectorBuffer Read(unsigned size)
- unsigned Seek(unsigned position)
- const String GetName() const
- unsigned GetChecksum()
- unsigned GetPosition() const
- unsigned GetSize() const
- bool IsEof() const
- int ReadInt()
- short ReadShort()
- char ReadByte()
- unsigned ReadUInt()
- short ReadUShort()
- char ReadUByte()
- bool ReadBool()
- float ReadFloat()
- IntRect ReadIntRect()
- IntVector2 ReadIntVector2()
- Rect ReadRect()
- Vector2 ReadVector2()
- Vector3 ReadVector3()
- Vector3 ReadPackedVector3(float maxAbsCoord)
- Vector4 ReadVector4()
- Quaternion ReadQuaternion()
- Quaternion ReadPackedQuaternion()
- Matrix3 ReadMatrix3()
- Matrix3x4 ReadMatrix3x4()
- Matrix4 ReadMatrix4()
- Color ReadColor()
- BoundingBox ReadBoundingBox()
- String ReadString()
- String ReadFileID()
- StringHash ReadStringHash()
- VectorBuffer ReadBuffer()
- ResourceRef ReadResourceRef()
- ResourceRefList ReadResourceRefList()
- Variant ReadVariant()
- Variant ReadVariant(VariantType type)
- VariantVector ReadVariantVector()
- VariantMap ReadVariantMap()
- unsigned ReadVLE()
- unsigned ReadNetID()
- String ReadLine()
- unsigned Write(const VectorBuffer& buffer)
- bool WriteInt(int value)
- bool WriteShort(short value)
- bool WriteByte(char value)
- bool WriteUInt(unsigned value)
- bool WriteUShort(short value)
- bool WriteUByte(char value)
- bool WriteBool(bool value)
- bool WriteFloat(float value)
- bool WriteIntRect(const IntRect& value)
- bool WriteIntVector2(const IntVector2& value)
- bool WriteRect(const Rect& value)
- bool WriteVector2(const Vector2& value)
- bool WriteVector3(const Vector3& value)
- bool WritePackedVector3(const Vector3& value, float maxAbsCoord)
- bool WriteVector4(const Vector4& value)
- bool WriteQuaternion(const Quaternion& value)
- bool WritePackedQuaternion(const Quaternion& value)
- bool WriteMatrix3(const Matrix3& value)
- bool WriteMatrix3x4(const Matrix3x4& value)
- bool WriteMatrix4(const Matrix4& value)
- bool WriteColor(const Color& value)
- bool WriteBoundingBox(const BoundingBox& value)
- bool WriteString(const String value)
- bool WriteFileID(const String value)
- bool WriteStringHash(const StringHash& value)
- bool WriteBuffer(const VectorBuffer& buffer)
- bool WriteResourceRef(const ResourceRef& value)
- bool WriteResourceRefList(const ResourceRefList& value)
- bool WriteVariant(const Variant& value)
- bool WriteVariantData(const Variant& value)
- bool WriteVariantVector(const VariantVector& value)
- bool WriteVariantMap(const VariantMap& value)
- bool WriteVLE(unsigned value)
- bool WriteNetID(unsigned value)
- bool WriteLine(const String value)

Properties:

- String name (readonly)
- unsigned checksum (readonly)
- unsigned position (readonly)
- unsigned size (readonly)
- bool eof (readonly)

<a name="Class_View3D"></a>
### View3D : Window

Methods:

- View3D() (GC)
- View3D* new()
- void delete()
- void SetView(Scene* scene, Camera* camera)
- void SetFormat(unsigned format)
- void SetAutoUpdate(bool enable)
- void QueueUpdate()
- unsigned GetFormat() const
- bool GetAutoUpdate() const
- Scene* GetScene() const
- Node* GetCameraNode() const
- Texture2D* GetRenderTexture() const
- Texture2D* GetDepthTexture() const
- Viewport* GetViewport() const

Properties:

- unsigned format
- bool autoUpdate

<a name="Class_Viewport"></a>
### Viewport


Methods:

- Viewport() (GC)
- Viewport* new()
- Viewport(Scene* scene, Camera* camera, RenderPath* renderPath = 0) (GC)
- Viewport* new(Scene* scene, Camera* camera, RenderPath* renderPath = 0)
- Viewport(Scene* scene, Camera* camera, const IntRect& rect, RenderPath* renderPath = 0) (GC)
- Viewport* new(Scene* scene, Camera* camera, const IntRect& rect, RenderPath* renderPath = 0)
- void delete()
- void SetScene(Scene* scene)
- void SetCamera(Camera* camera)
- void SetRect(const IntRect& rect)
- void SetRenderPath(RenderPath* path)
- void SetRenderPath(XMLFile* file)
- void SetDrawDebug(bool enable)
- Scene* GetScene() const
- Camera* GetCamera() const
- const IntRect& GetRect() const
- RenderPath* GetRenderPath() const
- bool GetDrawDebug() const
- Ray GetScreenRay(int x, int y) const
- IntVector2 WorldToScreenPoint(const Vector3& worldPos) const
- Vector3 ScreenToWorldPoint(int x, int y, float depth) const

Properties:

- Scene* scene
- Camera* camera
- IntRect& rect
- RenderPath* renderPath
- bool drawDebug

<a name="Class_Window"></a>
### Window : BorderImage

Methods:

- Window() (GC)
- Window* new()
- void delete()
- void SetMovable(bool enable)
- void SetResizable(bool enable)
- void SetFixedWidthResizing(bool enable)
- void SetFixedHeightResizing(bool enable)
- void SetResizeBorder(const IntRect& rect)
- void SetModal(bool modal)
- void SetModalShadeColor(const Color& color)
- void SetModalFrameColor(const Color& color)
- void SetModalFrameSize(const IntVector2& size)
- void SetModalAutoDismiss(bool enable)
- bool IsMovable() const
- bool IsResizable() const
- bool GetFixedWidthResizing() const
- bool GetFixedHeightResizing() const
- const IntRect& GetResizeBorder() const
- bool IsModal() const
- const Color& GetModalShadeColor() const
- const Color& GetModalFrameColor() const
- const IntVector2& GetModalFrameSize() const
- bool GetModalAutoDismiss() const

Properties:

- bool movable
- bool resizable
- bool fixedWidthResizing
- bool fixedHeightResizing
- IntRect& resizeBorder
- bool modal
- Color& modalShadeColor
- Color& modalFrameColor
- IntVector2& modalFrameSize
- bool modalAutoDismiss

<a name="Class_XMLElement"></a>
### XMLElement


Methods:

- XMLElement CreateChild(const String name)
- bool RemoveChild(const XMLElement& element)
- bool RemoveChild(const String name)
- bool RemoveChildren(const String name = String::EMPTY)
- bool RemoveAttribute(const String name = String::EMPTY)
- bool SetValue(const String value)
- bool SetAttribute(const String name, const String value)
- bool SetAttribute(const String value)
- bool SetBool(const String name, bool value)
- bool SetBoundingBox(const BoundingBox& value)
- bool SetColor(const String name, const Color& value)
- bool SetFloat(const String name, float value)
- bool SetUInt(const String name, unsigned value)
- bool SetInt(const String name, int value)
- bool SetIntRect(const String name, const IntRect& value)
- bool SetIntVector2(const String name, const IntVector2& value)
- bool SetRect(const String name, const Rect& value)
- bool SetQuaternion(const String name, const Quaternion& value)
- bool SetString(const String name, const String value)
- bool SetVariant(const Variant& value)
- bool SetVariantValue(const Variant& value)
- bool SetResourceRef(const ResourceRef& value)
- bool SetResourceRefList(const ResourceRefList& value)
- bool SetVector2(const String name, const Vector2& value)
- bool SetVector3(const String name, const Vector3& value)
- bool SetVector4(const String name, const Vector4& value)
- bool SetVectorVariant(const String name, const Variant& value)
- bool SetMatrix3(const String name, const Matrix3& value)
- bool SetMatrix3x4(const String name, const Matrix3x4& value)
- bool SetMatrix4(const String name, const Matrix4& value)
- bool IsNull() const
- bool NotNull() const
- bool operatorbool() const
- String GetName() const
- bool HasChild(const String name) const
- XMLElement GetChild(const String name = String::EMPTY) const
- XMLElement GetNext(const String name = String::EMPTY) const
- XMLElement GetParent() const
- unsigned GetNumAttributes() const
- bool HasAttribute(const String name) const
- String GetValue() const
- String GetAttribute(const String name = String::EMPTY) const
- String GetAttributeLower(const String name) const
- String GetAttributeUpper(const String name) const
- Vector<String> GetAttributeNames() const
- bool GetBool(const String name) const
- BoundingBox GetBoundingBox() const
- Color GetColor(const String name) const
- float GetFloat(const String name) const
- unsigned GetUInt(const String name) const
- int GetInt(const String name) const
- IntRect GetIntRect(const String name) const
- IntVector2 GetIntVector2(const String name) const
- Rect GetRect(const String name) const
- Quaternion GetQuaternion(const String name) const
- Variant GetVariant() const
- Variant GetVariantValue(VariantType type) const
- ResourceRef GetResourceRef() const
- ResourceRefList GetResourceRefList() const
- VariantMap GetVariantMap() const
- Vector2 GetVector2(const String name) const
- Vector3 GetVector3(const String name) const
- Vector4 GetVector4(const String name) const
- Vector4 GetVector(const String name) const
- Matrix3 GetMatrix3(const String name) const
- Matrix3x4 GetMatrix3x4(const String name) const
- Matrix4 GetMatrix4(const String name) const
- XMLFile* GetFile() const

Properties:

- const XMLElement EMPTY
- bool null (readonly)
- String name (readonly)
- XMLElement parent (readonly)
- String value (readonly)
- unsigned numAttributes (readonly)
- XMLFile* file (readonly)

<a name="Class_XMLFile"></a>
### XMLFile : Resource

Methods:

- XMLFile() (GC)
- XMLFile* new()
- void delete()
- bool FromString(const String source)
- XMLElement CreateRoot(const String name = String::EMPTY)
- XMLElement GetRoot(const String name = String::EMPTY)
- String ToString() const
- void Patch(XMLFile* patchFile)
- void Patch(XMLElement patchElement)

<a name="Class_Zone"></a>
### Zone : Drawable

Methods:

- void SetBoundingBox(const BoundingBox& box)
- void SetAmbientColor(const Color& color)
- void SetFogColor(const Color& color)
- void SetFogStart(float start)
- void SetFogEnd(float end)
- void SetFogHeight(float height)
- void SetFogHeightScale(float scale)
- void SetPriority(int priority)
- void SetHeightFog(bool enable)
- void SetOverride(bool enable)
- void SetAmbientGradient(bool enable)
- void SetZoneTexture(Texture* texture)
- const Matrix3x4& GetInverseWorldTransform() const
- const Color& GetAmbientColor() const
- const Color& GetAmbientStartColor()
- const Color& GetAmbientEndColor()
- const Color& GetFogColor() const
- float GetFogStart() const
- float GetFogEnd() const
- float GetFogHeight() const
- float GetFogHeightScale() const
- int GetPriority() const
- bool GetHeightFog() const
- bool GetOverride() const
- bool GetAmbientGradient() const
- Texture* GetZoneTexture() const
- bool IsInside(const Vector3& point) const

Properties:

- BoundingBox& boundingBox
- Matrix3x4& inverseWorldTransform (readonly)
- Color& ambientColor
- Color& ambientStartColor (readonly)
- Color& ambientEndColor (readonly)
- Color& fogColor
- float fogStart
- float fogEnd
- float fogHeight
- float fogHeightScale
- int priority
- bool heightFog
- bool override
- bool ambientGradient
- Texture* zoneTexture

\section LuaScriptAPI_Enums Enumerations

### BlendMode

- int BLEND_REPLACE
- int BLEND_ADD
- int BLEND_MULTIPLY
- int BLEND_ALPHA
- int BLEND_ADDALPHA
- int BLEND_PREMULALPHA
- int BLEND_INVDESTALPHA
- int BLEND_SUBTRACT
- int BLEND_SUBTRACTALPHA
- int MAX_BLENDMODES

### BodyType2D

- int BT_STATIC
- int BT_DYNAMIC
- int BT_KINEMATIC

### CollisionEventMode

- int COLLISION_NEVER
- int COLLISION_ACTIVE
- int COLLISION_ALWAYS

### CompareMode

- int CMP_ALWAYS
- int CMP_EQUAL
- int CMP_NOTEQUAL
- int CMP_LESS
- int CMP_LESSEQUAL
- int CMP_GREATER
- int CMP_GREATEREQUAL
- int MAX_COMPAREMODES

### CompressedFormat

- int CF_NONE
- int CF_DXT1
- int CF_DXT3
- int CF_DXT5
- int CF_ETC1
- int CF_PVRTC_RGB_2BPP
- int CF_PVRTC_RGBA_2BPP
- int CF_PVRTC_RGB_4BPP
- int CF_PVRTC_RGBA_4BPP

### ConstraintType

- int CONSTRAINT_POINT
- int CONSTRAINT_HINGE
- int CONSTRAINT_SLIDER
- int CONSTRAINT_CONETWIST

### Corner

- int C_TOPLEFT
- int C_TOPRIGHT
- int C_BOTTOMLEFT
- int C_BOTTOMRIGHT
- int MAX_UIELEMENT_CORNERS

### CreateMode

- int REPLICATED
- int LOCAL

### CubeMapFace

- int FACE_POSITIVE_X
- int FACE_NEGATIVE_X
- int FACE_POSITIVE_Y
- int FACE_NEGATIVE_Y
- int FACE_POSITIVE_Z
- int FACE_NEGATIVE_Z
- int MAX_CUBEMAP_FACES

### CullMode

- int CULL_NONE
- int CULL_CCW
- int CULL_CW
- int MAX_CULLMODES

### CursorShape

- int CS_NORMAL
- int CS_RESIZEVERTICAL
- int CS_RESIZEDIAGONAL_TOPRIGHT
- int CS_RESIZEHORIZONTAL
- int CS_RESIZEDIAGONAL_TOPLEFT
- int CS_ACCEPTDROP
- int CS_REJECTDROP
- int CS_BUSY
- int CS_MAX_SHAPES

### EmitterType

- int EMITTER_SPHERE
- int EMITTER_BOX

### EmitterType2D

- int EMITTER_TYPE_GRAVITY
- int EMITTER_TYPE_RADIAL

### FaceCameraMode

- int FC_NONE
- int FC_ROTATE_XYZ
- int FC_ROTATE_Y
- int FC_LOOKAT_XYZ
- int FC_LOOKAT_Y

### FaceCameraMode

- int FC_NONE
- int FC_ROTATE_XYZ
- int FC_ROTATE_Y
- int FC_LOOKAT_XYZ
- int FC_LOOKAT_Y

### FileMode

- int FILE_READ
- int FILE_WRITE
- int FILE_READWRITE

### FillMode

- int FILL_SOLID
- int FILL_WIREFRAME
- int FILL_POINT

### FocusMode

- int FM_NOTFOCUSABLE
- int FM_RESETFOCUS
- int FM_FOCUSABLE
- int FM_FOCUSABLE_DEFOCUSABLE

### FrustumPlane

- int PLANE_NEAR
- int PLANE_LEFT
- int PLANE_RIGHT
- int PLANE_UP
- int PLANE_DOWN
- int PLANE_FAR

### GeometryType

- int GEOM_STATIC
- int GEOM_SKINNED
- int GEOM_INSTANCED
- int GEOM_BILLBOARD
- int GEOM_STATIC_NOINSTANCING
- int MAX_GEOMETRYTYPES

### HighlightMode

- int HM_NEVER
- int HM_FOCUS
- int HM_ALWAYS

### HorizontalAlignment

- int HA_LEFT
- int HA_CENTER
- int HA_RIGHT

### HttpRequestState

- int HTTP_INITIALIZING
- int HTTP_ERROR
- int HTTP_OPEN
- int HTTP_CLOSED

### InterpMethod

- int IM_LINEAR
- int IM_SPLINE

### InterpolationMode

- int BEZIER_CURVE

### Intersection

- int OUTSIDE
- int INTERSECTS
- int INSIDE

### JSONValueType

- int JSON_ANY
- int JSON_OBJECT
- int JSON_ARRAY

### LayoutMode

- int LM_FREE
- int LM_HORIZONTAL
- int LM_VERTICAL

### LightType

- int LIGHT_DIRECTIONAL
- int LIGHT_SPOT
- int LIGHT_POINT

### LoadMode

- int LOAD_RESOURCES_ONLY
- int LOAD_SCENE
- int LOAD_SCENE_AND_RESOURCES

### LockState

- int LOCK_NONE
- int LOCK_HARDWARE
- int LOCK_SHADOW
- int LOCK_SCRATCH

### LoopMode2D

- int LM_DEFAULT
- int LM_FORCE_LOOPED
- int LM_FORCE_CLAMPED

### MouseMode

- int MM_ABSOLUTE
- int MM_RELATIVE
- int MM_WRAP

### Orientation

- int O_HORIZONTAL
- int O_VERTICAL

### Orientation2D

- int O_ORTHOGONAL
- int O_ISOMETRIC
- int O_STAGGERED

### PassLightingMode

- int LIGHTING_UNLIT
- int LIGHTING_PERVERTEX
- int LIGHTING_PERPIXEL

### PrimitiveType

- int TRIANGLE_LIST
- int LINE_LIST
- int POINT_LIST
- int TRIANGLE_STRIP
- int LINE_STRIP
- int TRIANGLE_FAN

### RayQueryLevel

- int RAY_AABB
- int RAY_OBB
- int RAY_TRIANGLE

### RenderSurfaceUpdateMode

- int SURFACE_MANUALUPDATE
- int SURFACE_UPDATEVISIBLE
- int SURFACE_UPDATEALWAYS

### ShaderParameterGroup

- int SP_FRAME
- int SP_CAMERA
- int SP_VIEWPORT
- int SP_ZONE
- int SP_LIGHT
- int SP_VERTEXLIGHTS
- int SP_MATERIAL
- int SP_OBJECTTRANSFORM
- int MAX_SHADER_PARAMETER_GROUPS

### ShaderType

- int VS
- int PS

### ShapeType

- int SHAPE_BOX
- int SHAPE_SPHERE
- int SHAPE_STATICPLANE
- int SHAPE_CYLINDER
- int SHAPE_CAPSULE
- int SHAPE_CONE
- int SHAPE_TRIANGLEMESH
- int SHAPE_CONVEXHULL
- int SHAPE_TERRAIN

### SoundType

- int SOUND_EFFECT
- int SOUND_AMBIENT
- int SOUND_VOICE
- int SOUND_MUSIC
- int SOUND_MASTER
- int MAX_SOUND_TYPES

### StencilOp

- int OP_KEEP
- int OP_ZERO
- int OP_REF
- int OP_INCR
- int OP_DECR

### TextEffect

- int TE_NONE
- int TE_SHADOW
- int TE_STROKE

### TextureAddressMode

- int ADDRESS_WRAP
- int ADDRESS_MIRROR
- int ADDRESS_CLAMP
- int ADDRESS_BORDER
- int MAX_ADDRESSMODES

### TextureCoordinate

- int COORD_U
- int COORD_V
- int COORD_W
- int MAX_COORDS

### TextureFilterMode

- int FILTER_NEAREST
- int FILTER_BILINEAR
- int FILTER_TRILINEAR
- int FILTER_ANISOTROPIC
- int FILTER_DEFAULT
- int MAX_FILTERMODES

### TextureUnit

- int TU_DIFFUSE
- int TU_ALBEDOBUFFER
- int TU_NORMAL
- int TU_NORMALBUFFER
- int TU_SPECULAR
- int TU_EMISSIVE
- int TU_ENVIRONMENT
- int MAX_MATERIAL_TEXTURE_UNITS
- int TU_LIGHTRAMP
- int TU_LIGHTSHAPE
- int TU_SHADOWMAP
- int TU_FACESELECT
- int TU_INDIRECTION
- int TU_DEPTHBUFFER
- int TU_LIGHTBUFFER
- int TU_VOLUMEMAP
- int TU_ZONE
- int MAX_TEXTURE_UNITS

### TextureUsage

- int TEXTURE_STATIC
- int TEXTURE_DYNAMIC
- int TEXTURE_RENDERTARGET
- int TEXTURE_DEPTHSTENCIL

### TileMapLayerType2D

- int LT_TILE_LAYER
- int LT_OBJECT_GROUP
- int LT_IMAGE_LAYER
- int LT_INVALID

### TileMapObjectType2D

- int OT_RECTANGLE
- int OT_ELLIPSE
- int OT_POLYGON
- int OT_POLYLINE
- int OT_TILE
- int OT_INVALID

### TransformSpace

- int TS_LOCAL
- int TS_PARENT
- int TS_WORLD

### TraversalMode

- int TM_BREADTH_FIRST
- int TM_DEPTH_FIRST

### VariantType

- int VAR_NONE
- int VAR_INT
- int VAR_BOOL
- int VAR_FLOAT
- int VAR_VECTOR2
- int VAR_VECTOR3
- int VAR_VECTOR4
- int VAR_QUATERNION
- int VAR_COLOR
- int VAR_STRING
- int VAR_BUFFER
- int VAR_VOIDPTR
- int VAR_RESOURCEREF
- int VAR_RESOURCEREFLIST
- int VAR_VARIANTVECTOR
- int VAR_VARIANTMAP
- int VAR_INTRECT
- int VAR_INTVECTOR2
- int VAR_PTR
- int VAR_MATRIX3
- int VAR_MATRIX3X4
- int VAR_MATRIX4
- int MAX_VAR_TYPES

### VertexElement

- int ELEMENT_POSITION
- int ELEMENT_NORMAL
- int ELEMENT_COLOR
- int ELEMENT_TEXCOORD1
- int ELEMENT_TEXCOORD2
- int ELEMENT_CUBETEXCOORD1
- int ELEMENT_CUBETEXCOORD2
- int ELEMENT_TANGENT
- int ELEMENT_BLENDWEIGHTS
- int ELEMENT_BLENDINDICES
- int ELEMENT_INSTANCEMATRIX1
- int ELEMENT_INSTANCEMATRIX2
- int ELEMENT_INSTANCEMATRIX3
- int MAX_VERTEX_ELEMENTS

### VerticalAlignment

- int VA_TOP
- int VA_CENTER
- int VA_BOTTOM

### WindowDragMode

- int DRAG_NONE
- int DRAG_MOVE
- int DRAG_RESIZE_TOPLEFT
- int DRAG_RESIZE_TOP
- int DRAG_RESIZE_TOPRIGHT
- int DRAG_RESIZE_RIGHT
- int DRAG_RESIZE_BOTTOMRIGHT
- int DRAG_RESIZE_BOTTOM
- int DRAG_RESIZE_BOTTOMLEFT
- int DRAG_RESIZE_LEFT

### WrapMode

- int WM_LOOP
- int WM_ONCE
- int WM_CLAMP


\section LuaScriptAPI_GlobalFunctions Global functions
- float Abs(float value)
- int AbsInt(int value)
- float Acos(float x)
- String AddTrailingSlash(const String pathName)
- float Asin(float x)
- float Atan(float x)
- float Atan2(float y, float x)
- float Clamp(float value, float min, float max)
- int ClampInt(int value, int min, int max)
- VectorBuffer CompressVectorBuffer(VectorBuffer& src)
- float Cos(float angle)
- unsigned CountSetBits(unsigned value)
- VectorBuffer DecompressVectorBuffer(VectorBuffer& src)
- bool Equals(float lhs, float rhs)
- void ErrorDialog(const String title, const String message)
- void ErrorExit(const String message = String::EMPTY, int exitCode = EXIT_FAILURE)
- const Vector<String>& GetArguments()
- Audio* GetAudio()
- ResourceCache* GetCache()
- Console* GetConsole()
- String GetConsoleInput()
- Context* GetContext()
- DebugHud* GetDebugHud()
- Engine* GetEngine()
- EventHandler* GetEventHandler() const
- Object* GetEventSender()
- bool GetExecuteConsoleCommands()
- String GetExtension(const String fullPath, bool lowercaseExtension = true)
- String GetFileName(const String fullPath)
- String GetFileNameAndExtension(const String fullPath, bool lowercaseExtension = false)
- FileSystem* GetFileSystem()
- Graphics* GetGraphics()
- Input* GetInput()
- String GetInternalPath(const String pathName)
- Log* GetLog()
- String GetNativePath(const String pathName)
- Network* GetNetwork()
- unsigned GetNumLogicalCPUs()
- unsigned GetNumPhysicalCPUs()
- String GetParentPath(const String pathName)
- String GetPath(const String fullPath)
- String GetPlatform()
- unsigned GetRandomSeed()
- Renderer* GetRenderer()
- Time* GetTime()
- UI* GetUI()
- bool IsAbsolutePath(const String pathName)
- bool IsAlpha(unsigned ch)
- bool IsDigit(unsigned ch)
- bool IsNaN(float value)
- bool IsPowerOfTwo(unsigned value)
- float Lerp(float lhs, float rhs, float t)
- float Max(float lhs, float rhs)
- int MaxInt(int lhs, int rhs)
- float Min(float lhs, float rhs)
- int MinInt(int lhs, int rhs)
- unsigned NextPowerOfTwo(unsigned value)
- void OpenConsoleWindow()
- void PrintLine(const String str, bool error = false)
- int Rand()
- float RandStandardNormal()
- float Random()
- float Random(float min, float max)
- float Random(float range)
- int RandomInt(int min, int max)
- int RandomInt(int range)
- float RandomNormal(float meanValue, float variance)
- String RemoveTrailingSlash(const String pathName)
- String ReplaceExtension(const String fullPath, const String newExtension)
- unsigned SDBMHash(unsigned hash, char c)
- void SendEvent(const String eventName, VariantMap& eventData)
- void SetExecuteConsoleCommands(bool enable)
- void SetRandomSeed(unsigned seed)
- float Sign(float value)
- float Sin(float angle)
- float SmoothStep(float lhs, float rhs, float t)
- void SubscribeToEvent(const String eventName, void* functionOrFunctionName)
- void SubscribeToEvent(void* sender, const String eventName, void* functionOrFunctionName)
- float Tan(float angle)
- bool ToBool(const String source)
- Color ToColor(const String source)
- float ToFloat(const String source)
- int ToInt(const String source)
- IntRect ToIntRect(const String source)
- IntVector2 ToIntVector2(const String source)
- unsigned ToLower(unsigned ch)
- Matrix3 ToMatrix3(const String source)
- Matrix3x4 ToMatrix3x4(const String source)
- Matrix4 ToMatrix4(const String source)
- Quaternion ToQuaternion(const String source)
- Rect ToRect(const String source)
- String ToString(void* value)
- String ToStringHex(unsigned value)
- unsigned ToUInt(const String source)
- unsigned ToUpper(unsigned ch)
- Vector2 ToVector2(const String source)
- Vector3 ToVector3(const String source)
- Vector4 ToVector4(const String source, bool allowMissingCoords = false)
- void UnsubscribeFromAllEvents()
- void UnsubscribeFromEvent(void* sender, const String eventName, void* functionOrFunctionName)
- void UnsubscribeFromEvent(const String eventName)
- void UnsubscribeFromEvent(const String eventName, void* functionOrFunctionName)
- void UnsubscribeFromEvents(void* sender)


\section LuaScriptAPI_GlobalProperties Global properties
- Audio* audio (readonly)
- ResourceCache* cache (readonly)
- Console* console (readonly)
- DebugHud* debugHud (readonly)
- Engine* engine (readonly)
- FileSystem* fileSystem (readonly)
- Graphics* graphics (readonly)
- Input* input (readonly)
- Log* log (readonly)
- Network* network (readonly)
- Renderer* renderer (readonly)
- Time* time (readonly)
- UI* ui (readonly)

\section LuaScriptAPI_GlobalConstants Global constants
- float ANIMATION_LOD_BASESCALE
- char CHANNEL_POSITION
- char CHANNEL_ROTATION
- char CHANNEL_SCALE
- unsigned CLEAR_COLOR
- unsigned CLEAR_DEPTH
- unsigned CLEAR_STENCIL
- int CONTROLLER_AXIS_LEFTX
- int CONTROLLER_AXIS_LEFTY
- int CONTROLLER_AXIS_RIGHTX
- int CONTROLLER_AXIS_RIGHTY
- int CONTROLLER_AXIS_TRIGGERLEFT
- int CONTROLLER_AXIS_TRIGGERRIGHT
- int CONTROLLER_BUTTON_A
- int CONTROLLER_BUTTON_B
- int CONTROLLER_BUTTON_BACK
- int CONTROLLER_BUTTON_DPAD_DOWN
- int CONTROLLER_BUTTON_DPAD_LEFT
- int CONTROLLER_BUTTON_DPAD_RIGHT
- int CONTROLLER_BUTTON_DPAD_UP
- int CONTROLLER_BUTTON_GUIDE
- int CONTROLLER_BUTTON_LEFTSHOULDER
- int CONTROLLER_BUTTON_LEFTSTICK
- int CONTROLLER_BUTTON_RIGHTSHOULDER
- int CONTROLLER_BUTTON_RIGHTSTICK
- int CONTROLLER_BUTTON_START
- int CONTROLLER_BUTTON_X
- int CONTROLLER_BUTTON_Y
- unsigned DD_DISABLED
- unsigned DD_SOURCE
- unsigned DD_SOURCE_AND_TARGET
- unsigned DD_TARGET
- unsigned DEBUGHUD_SHOW_ALL
- unsigned DEBUGHUD_SHOW_MODE
- unsigned DEBUGHUD_SHOW_NONE
- unsigned DEBUGHUD_SHOW_PROFILER
- unsigned DEBUGHUD_SHOW_STATS
- unsigned DEFAULT_LIGHTMASK
- unsigned DEFAULT_SHADOWMASK
- unsigned DEFAULT_VIEWMASK
- unsigned DEFAULT_ZONEMASK
- unsigned DRAWABLE_ANY
- unsigned DRAWABLE_GEOMETRY
- unsigned DRAWABLE_LIGHT
- unsigned DRAWABLE_PROXYGEOMETRY
- unsigned DRAWABLE_ZONE
- unsigned FIRST_LOCAL_ID
- unsigned FIRST_REPLICATED_ID
- int HAT_CENTER
- int HAT_DOWN
- int HAT_LEFT
- int HAT_RIGHT
- int HAT_UP
- int KEY_0
- int KEY_1
- int KEY_2
- int KEY_3
- int KEY_4
- int KEY_5
- int KEY_6
- int KEY_7
- int KEY_8
- int KEY_9
- int KEY_A
- int KEY_ALT
- int KEY_APPLICATION
- int KEY_B
- int KEY_BACKSPACE
- int KEY_C
- int KEY_CAPSLOCK
- int KEY_CTRL
- int KEY_D
- int KEY_DELETE
- int KEY_DOWN
- int KEY_E
- int KEY_END
- int KEY_ESC
- int KEY_F
- int KEY_F1
- int KEY_F10
- int KEY_F11
- int KEY_F12
- int KEY_F13
- int KEY_F14
- int KEY_F15
- int KEY_F16
- int KEY_F17
- int KEY_F18
- int KEY_F19
- int KEY_F2
- int KEY_F20
- int KEY_F21
- int KEY_F22
- int KEY_F23
- int KEY_F24
- int KEY_F3
- int KEY_F4
- int KEY_F5
- int KEY_F6
- int KEY_F7
- int KEY_F8
- int KEY_F9
- int KEY_G
- int KEY_GUI
- int KEY_H
- int KEY_HOME
- int KEY_I
- int KEY_INSERT
- int KEY_J
- int KEY_K
- int KEY_KP_0
- int KEY_KP_1
- int KEY_KP_2
- int KEY_KP_3
- int KEY_KP_4
- int KEY_KP_5
- int KEY_KP_6
- int KEY_KP_7
- int KEY_KP_8
- int KEY_KP_9
- int KEY_KP_DIVIDE
- int KEY_KP_ENTER
- int KEY_KP_MINUS
- int KEY_KP_MULTIPLY
- int KEY_KP_PERIOD
- int KEY_KP_PLUS
- int KEY_L
- int KEY_LALT
- int KEY_LCTRL
- int KEY_LEFT
- int KEY_LGUI
- int KEY_LSHIFT
- int KEY_M
- int KEY_N
- int KEY_NUMLOCKCLEAR
- int KEY_O
- int KEY_P
- int KEY_PAGEDOWN
- int KEY_PAGEUP
- int KEY_PAUSE
- int KEY_PRINTSCREEN
- int KEY_Q
- int KEY_R
- int KEY_RALT
- int KEY_RCTRL
- int KEY_RETURN
- int KEY_RETURN2
- int KEY_RGUI
- int KEY_RIGHT
- int KEY_RSHIFT
- int KEY_S
- int KEY_SCROLLLOCK
- int KEY_SELECT
- int KEY_SHIFT
- int KEY_SPACE
- int KEY_T
- int KEY_TAB
- int KEY_U
- int KEY_UP
- int KEY_V
- int KEY_W
- int KEY_X
- int KEY_Y
- int KEY_Z
- unsigned LAST_LOCAL_ID
- unsigned LAST_REPLICATED_ID
- int LOG_DEBUG
- int LOG_ERROR
- int LOG_INFO
- int LOG_NONE
- int LOG_WARNING
- int MAX_VERTEX_LIGHTS
- int MOUSEB_LEFT
- int MOUSEB_MIDDLE
- int MOUSEB_RIGHT
- float M_DEGTORAD
- float M_DEGTORAD_2
- float M_EPSILON
- float M_HALF_PI
- float M_INFINITY
- float M_LARGE_EPSILON
- float M_LARGE_VALUE
- float M_MAX_FOV
- int M_MAX_INT
- unsigned M_MAX_UNSIGNED
- int M_MIN_INT
- float M_MIN_NEARCLIP
- unsigned M_MIN_UNSIGNED
- float M_PI
- float M_RADTODEG
- unsigned NUM_FRUSTUM_PLANES
- unsigned NUM_FRUSTUM_VERTICES
- float PIXEL_SIZE
- int QUALITY_HIGH
- int QUALITY_LOW
- int QUALITY_MAX
- int QUALITY_MEDIUM
- int QUAL_ALT
- int QUAL_ANY
- int QUAL_CTRL
- int QUAL_SHIFT
- int SCANCODE_0
- int SCANCODE_1
- int SCANCODE_2
- int SCANCODE_3
- int SCANCODE_4
- int SCANCODE_5
- int SCANCODE_6
- int SCANCODE_7
- int SCANCODE_8
- int SCANCODE_9
- int SCANCODE_A
- int SCANCODE_AC_BACK
- int SCANCODE_AC_BOOKMARKS
- int SCANCODE_AC_FORWARD
- int SCANCODE_AC_HOME
- int SCANCODE_AC_REFRESH
- int SCANCODE_AC_SEARCH
- int SCANCODE_AC_STOP
- int SCANCODE_AGAIN
- int SCANCODE_ALT
- int SCANCODE_ALTERASE
- int SCANCODE_APOSTROPHE
- int SCANCODE_APP1
- int SCANCODE_APP2
- int SCANCODE_APPLICATION
- int SCANCODE_AUDIOMUTE
- int SCANCODE_AUDIONEXT
- int SCANCODE_AUDIOPLAY
- int SCANCODE_AUDIOPREV
- int SCANCODE_AUDIOSTOP
- int SCANCODE_B
- int SCANCODE_BACKSLASH
- int SCANCODE_BACKSPACE
- int SCANCODE_BRIGHTNESSDOWN
- int SCANCODE_BRIGHTNESSUP
- int SCANCODE_C
- int SCANCODE_CALCULATOR
- int SCANCODE_CANCEL
- int SCANCODE_CAPSLOCK
- int SCANCODE_CLEAR
- int SCANCODE_CLEARAGAIN
- int SCANCODE_COMMA
- int SCANCODE_COMPUTER
- int SCANCODE_COPY
- int SCANCODE_CRSEL
- int SCANCODE_CTRL
- int SCANCODE_CURRENCYSUBUNIT
- int SCANCODE_CURRENCYUNIT
- int SCANCODE_CUT
- int SCANCODE_D
- int SCANCODE_DECIMALSEPARATOR
- int SCANCODE_DELETE
- int SCANCODE_DISPLAYSWITCH
- int SCANCODE_DOWN
- int SCANCODE_E
- int SCANCODE_EJECT
- int SCANCODE_END
- int SCANCODE_EQUALS
- int SCANCODE_ESCAPE
- int SCANCODE_EXECUTE
- int SCANCODE_EXSEL
- int SCANCODE_F
- int SCANCODE_F1
- int SCANCODE_F10
- int SCANCODE_F11
- int SCANCODE_F12
- int SCANCODE_F13
- int SCANCODE_F14
- int SCANCODE_F15
- int SCANCODE_F16
- int SCANCODE_F17
- int SCANCODE_F18
- int SCANCODE_F19
- int SCANCODE_F2
- int SCANCODE_F20
- int SCANCODE_F21
- int SCANCODE_F22
- int SCANCODE_F23
- int SCANCODE_F24
- int SCANCODE_F3
- int SCANCODE_F4
- int SCANCODE_F5
- int SCANCODE_F6
- int SCANCODE_F7
- int SCANCODE_F8
- int SCANCODE_F9
- int SCANCODE_FIND
- int SCANCODE_G
- int SCANCODE_GRAVE
- int SCANCODE_GUI
- int SCANCODE_H
- int SCANCODE_HELP
- int SCANCODE_HOME
- int SCANCODE_I
- int SCANCODE_INSERT
- int SCANCODE_INTERNATIONAL1
- int SCANCODE_INTERNATIONAL2
- int SCANCODE_INTERNATIONAL3
- int SCANCODE_INTERNATIONAL4
- int SCANCODE_INTERNATIONAL5
- int SCANCODE_INTERNATIONAL6
- int SCANCODE_INTERNATIONAL7
- int SCANCODE_INTERNATIONAL8
- int SCANCODE_INTERNATIONAL9
- int SCANCODE_J
- int SCANCODE_K
- int SCANCODE_KBDILLUMDOWN
- int SCANCODE_KBDILLUMTOGGLE
- int SCANCODE_KBDILLUMUP
- int SCANCODE_KP_0
- int SCANCODE_KP_00
- int SCANCODE_KP_000
- int SCANCODE_KP_1
- int SCANCODE_KP_2
- int SCANCODE_KP_3
- int SCANCODE_KP_4
- int SCANCODE_KP_5
- int SCANCODE_KP_6
- int SCANCODE_KP_7
- int SCANCODE_KP_8
- int SCANCODE_KP_9
- int SCANCODE_KP_A
- int SCANCODE_KP_AMPERSAND
- int SCANCODE_KP_AT
- int SCANCODE_KP_B
- int SCANCODE_KP_BACKSPACE
- int SCANCODE_KP_BINARY
- int SCANCODE_KP_C
- int SCANCODE_KP_CLEAR
- int SCANCODE_KP_CLEARENTRY
- int SCANCODE_KP_COLON
- int SCANCODE_KP_COMMA
- int SCANCODE_KP_D
- int SCANCODE_KP_DBLAMPERSAND
- int SCANCODE_KP_DBLVERTICALBAR
- int SCANCODE_KP_DECIMAL
- int SCANCODE_KP_DIVIDE
- int SCANCODE_KP_E
- int SCANCODE_KP_ENTER
- int SCANCODE_KP_EQUALS
- int SCANCODE_KP_EQUALSAS400
- int SCANCODE_KP_EXCLAM
- int SCANCODE_KP_F
- int SCANCODE_KP_GREATER
- int SCANCODE_KP_HASH
- int SCANCODE_KP_HEXADECIMAL
- int SCANCODE_KP_LEFTBRACE
- int SCANCODE_KP_LEFTPAREN
- int SCANCODE_KP_LESS
- int SCANCODE_KP_MEMADD
- int SCANCODE_KP_MEMCLEAR
- int SCANCODE_KP_MEMDIVIDE
- int SCANCODE_KP_MEMMULTIPLY
- int SCANCODE_KP_MEMRECALL
- int SCANCODE_KP_MEMSTORE
- int SCANCODE_KP_MEMSUBTRACT
- int SCANCODE_KP_MINUS
- int SCANCODE_KP_MULTIPLY
- int SCANCODE_KP_OCTAL
- int SCANCODE_KP_PERCENT
- int SCANCODE_KP_PERIOD
- int SCANCODE_KP_PLUS
- int SCANCODE_KP_PLUSMINUS
- int SCANCODE_KP_POWER
- int SCANCODE_KP_RIGHTBRACE
- int SCANCODE_KP_RIGHTPAREN
- int SCANCODE_KP_SPACE
- int SCANCODE_KP_TAB
- int SCANCODE_KP_VERTICALBAR
- int SCANCODE_KP_XOR
- int SCANCODE_L
- int SCANCODE_LALT
- int SCANCODE_LANG1
- int SCANCODE_LANG2
- int SCANCODE_LANG3
- int SCANCODE_LANG4
- int SCANCODE_LANG5
- int SCANCODE_LANG6
- int SCANCODE_LANG7
- int SCANCODE_LANG8
- int SCANCODE_LANG9
- int SCANCODE_LCTRL
- int SCANCODE_LEFT
- int SCANCODE_LEFTBRACKET
- int SCANCODE_LGUI
- int SCANCODE_LSHIFT
- int SCANCODE_M
- int SCANCODE_MAIL
- int SCANCODE_MEDIASELECT
- int SCANCODE_MENU
- int SCANCODE_MINUS
- int SCANCODE_MODE
- int SCANCODE_MUTE
- int SCANCODE_N
- int SCANCODE_NONUSBACKSLASH
- int SCANCODE_NONUSHASH
- int SCANCODE_NUMLOCKCLEAR
- int SCANCODE_O
- int SCANCODE_OPER
- int SCANCODE_OUT
- int SCANCODE_P
- int SCANCODE_PAGEDOWN
- int SCANCODE_PAGEUP
- int SCANCODE_PASTE
- int SCANCODE_PAUSE
- int SCANCODE_PERIOD
- int SCANCODE_POWER
- int SCANCODE_PRINTSCREEN
- int SCANCODE_PRIOR
- int SCANCODE_Q
- int SCANCODE_R
- int SCANCODE_RALT
- int SCANCODE_RCTRL
- int SCANCODE_RETURN
- int SCANCODE_RETURN2
- int SCANCODE_RGUI
- int SCANCODE_RIGHT
- int SCANCODE_RIGHTBRACKET
- int SCANCODE_RSHIFT
- int SCANCODE_S
- int SCANCODE_SCROLLLOCK
- int SCANCODE_SELECT
- int SCANCODE_SEMICOLON
- int SCANCODE_SEPARATOR
- int SCANCODE_SHIFT
- int SCANCODE_SLASH
- int SCANCODE_SLEEP
- int SCANCODE_SPACE
- int SCANCODE_STOP
- int SCANCODE_SYSREQ
- int SCANCODE_T
- int SCANCODE_TAB
- int SCANCODE_THOUSANDSSEPARATOR
- int SCANCODE_U
- int SCANCODE_UNDO
- int SCANCODE_UNKNOWN
- int SCANCODE_UP
- int SCANCODE_V
- int SCANCODE_VOLUMEDOWN
- int SCANCODE_VOLUMEUP
- int SCANCODE_W
- int SCANCODE_WWW
- int SCANCODE_X
- int SCANCODE_Y
- int SCANCODE_Z
- unsigned SCAN_DIRS
- unsigned SCAN_FILES
- unsigned SCAN_HIDDEN
- int SHADOWQUALITY_HIGH_16BIT
- int SHADOWQUALITY_HIGH_24BIT
- int SHADOWQUALITY_LOW_16BIT
- int SHADOWQUALITY_LOW_24BIT
- unsigned VO_DISABLE_OCCLUSION
- unsigned VO_DISABLE_SHADOWS
- unsigned VO_LOW_MATERIAL_QUALITY
- unsigned VO_NONE

*/

}
